/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_PSImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[3] = x7;
  x8 = XEXP (x1, 1);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern10 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern10 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern10 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern10 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      res = pattern18 (x3);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      res = pattern19 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 23
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != UNSPEC
      || XVECLEN (x9, 0) != 1
      || XINT (x9, 1) != 1)
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 24)
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 26
      || GET_MODE (x13) != E_HImode)
    return -1;
  x14 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 30
      || GET_MODE (x15) != E_HImode)
    return -1;
  x16 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 0
      || GET_MODE (x17) != E_QImode)
    return -1;
  x18 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 24
      || GET_MODE (x19) != E_HImode)
    return -1;
  x20 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x20) != CLOBBER)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 23
      || GET_MODE (x21) != E_QImode)
    return -1;
  x22 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x22) != CLOBBER)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != MEM
      || GET_MODE (x23) != E_QImode)
    return -1;
  x24 = XVECEXP (x9, 0, 0);
  operands[0] = x24;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x25 = XEXP (x23, 0);
  operands[1] = x25;
  if (!io_address_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x11))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 16
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 18)
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x2) != E_DQmode
          || GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x2) != E_UDQmode
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x2) != E_DAmode
          || GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x2) != E_UDAmode
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x2) != E_TAmode
          || GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x2) != E_UTAmode
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      return pattern67 (x1); /* [-1, 6] */

    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 26
          || GET_MODE (x6) != E_QImode
          || GET_MODE (x4) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 7;

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      res = pattern68 (x1);
      if (res >= 0)
        return res + 8; /* [8, 14] */
      return -1;

    default:
      return -1;
    }
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[3] = x10;
  return 0;
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_QImode)
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != REG)
    return -1;
  x11 = XEXP (x7, 0);
  if (GET_CODE (x11) != REG)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG)
    return -1;
  x14 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG)
    return -1;
  x16 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG)
    return -1;
  switch (REGNO (x4))
    {
    case 24:
      return 0;

    case 22:
      return 1;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x1) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !register_operand (operands[2], E_QImode)
              || !const7_operand (operands[3], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !register_operand (operands[2], E_HImode)
              || !const15_operand (operands[3], E_QImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x1) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || !register_operand (operands[2], E_PSImode)
              || !const23_operand (operands[3], E_QImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[2], E_SImode)
              || !const31_operand (operands[3], E_QImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[2], E_QImode)
              || !const15_operand (operands[3], E_QImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x1) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || GET_MODE (x5) != E_PSImode
              || !const23_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 5;

            case E_HImode:
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x5) != E_SImode
              || !const31_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 7;

            case E_HImode:
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 8;

            case E_PSImode:
              if (!register_operand (operands[2], E_PSImode))
                return -1;
              return 9;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern153 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_PSImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!const_int_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_HImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern162 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XINT (x2, 1) != 1
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 28
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 28
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PLUS
      || GET_MODE (x9) != E_HImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 28
      || GET_MODE (x10) != E_HImode)
    return -1;
  x11 = XEXP (x8, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 32
      || GET_MODE (x11) != E_HImode)
    return -1;
  return 0;
}

int
pattern174 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 22
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 18
      || GET_MODE (x5) != E_PSImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 22
      || GET_MODE (x6) != E_PSImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != i1
      || GET_MODE (x8) != E_PSImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 22
      || GET_MODE (x9) != E_PSImode)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 18
      || GET_MODE (x10) != E_PSImode)
    return -1;
  x11 = XEXP (x7, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 18
      || GET_MODE (x11) != E_PSImode)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 21
      || GET_MODE (x13) != E_QImode
      || pattern173 (x1, 
E_QImode, 
26, 
25) != 0)
    return -1;
  return 0;
}

int
pattern186 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (XWINT (x6, 0) != 8L)
    return -1;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode
      || GET_MODE (x3) != E_HImode
      || GET_MODE (x4) != E_HImode)
    return -1;
  x8 = XEXP (x4, 0);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[2] = x10;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern200 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != IF_THEN_ELSE)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  return 0;
}

int
pattern205 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  return 0;
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case MEM:
      if (GET_MODE (x1) != E_QImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      if (!low_io_address_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[0] = x1;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern222 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || !register_operand (operands[3], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern227 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_UQQmode:
      return pattern99 (x1, 
E_UQQmode); /* [-1, 0] */

    case E_UHQmode:
      if (pattern99 (x1, 
E_UHQmode) != 0)
        return -1;
      return 1;

    case E_UHAmode:
      if (pattern99 (x1, 
E_UHAmode) != 0)
        return -1;
      return 2;

    case E_USAmode:
      if (pattern99 (x1, 
E_USAmode) != 0)
        return -1;
      return 3;

    case E_USQmode:
      if (pattern99 (x1, 
E_USQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTEND
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != NOT
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  if (REGNO (x10) != 18
      || GET_MODE (x10) != E_DImode)
    return -1;
  x11 = XEXP (x2, 0);
  operands[0] = x11;
  if (!pseudo_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x12 = XEXP (x6, 0);
  operands[1] = x12;
  if (!pseudo_register_operand (operands[1], E_HImode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[2] = x13;
  if (!pseudo_register_or_const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern238 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 26
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern171 (x5); /* [-1, 10] */
}

int
pattern246 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern260 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SAmode)
        return -1;
      return 0;

    case E_USAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_USAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_USAmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern271 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != 26)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 24)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 22
      || GET_MODE (x7) != E_HImode)
    return -1;
  return pattern230 (x2); /* [-1, 3] */
}

int
pattern275 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XEXP (x5, 1);
  if (GET_CODE (x8) != i1
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 26
      || GET_MODE (x9) != E_HImode)
    return -1;
  x10 = XEXP (x4, 1);
  if (XWINT (x10, 0) != 16L)
    return -1;
  x11 = XEXP (x2, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 24
      || GET_MODE (x11) != E_HImode)
    return -1;
  x12 = XVECEXP (x1, 0, 1);
  x13 = XEXP (x12, 0);
  if (REGNO (x13) != 22
      || GET_MODE (x13) != E_HImode
      || GET_MODE (x3) != E_HImode
      || GET_MODE (x4) != E_SImode
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern283 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x1, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1
      || GET_MODE (x2) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != i1
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern294 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != i4)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 24)
    return -1;
  return pattern265 (x1, 
i1, 
i2, 
i3); /* [-1, 3] */
}

int
pattern301 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!d_register_operand (operands[0], i1)
      || !const_int_operand (operands[1], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 3)
    return -1;
  return pattern300 (x1, 
i1); /* [-1, 2] */
}

int
pattern304 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2
      || pattern303 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern307 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != COMPARE
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern316 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!l_register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      if (!l_register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      if (!l_register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22
      || GET_MODE (x5) != E_SImode
      || pattern297 (x1, 
E_QImode, 
26, 
22) != 0)
    return -1;
  return 0;
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 25
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  return pattern133 (x6); /* [-1, 1] */
}

int
pattern328 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 22
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i3
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i2
      || GET_MODE (x7) != E_HImode
      || pattern129 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern334 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern338 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  if (!const_operand (operands[2], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern337 (x3); /* [-1, 0] */
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern348 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (REGNO (x3))
    {
    case 18:
      if (GET_MODE (x3) != E_SImode
          || pattern347 (x1, 
E_SImode, 
30, 
E_HImode, 
26) != 0)
        return -1;
      return 0;

    case 21:
      if (GET_MODE (x3) != E_QImode
          || pattern347 (x1, 
E_PSImode, 
26, 
E_QImode, 
25) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern355 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i2
      || pattern131 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern361 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2
      || pattern131 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern365 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  if (!const0_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern335 (x3); /* [-1, 1] */
}

int
pattern370 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return 0;

    case E_PSImode:
      return 1;

    case E_SImode:
      return 2;

    default:
      return -1;
    }
}

int
pattern378 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      return pattern376 (x6, 
E_HImode); /* [-1, 5] */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || GET_MODE (x2) != E_PSImode
          || !const0_operand (operands[3], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern377 (x6, 
E_QImode);
          if (res >= 0)
            return res + 6; /* [6, 11] */
          return -1;

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern377 (x6, 
E_HImode);
          if (res >= 0)
            return res + 12; /* [12, 17] */
          return -1;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || !const0_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern377 (x6, 
E_QImode);
          if (res >= 0)
            return res + 18; /* [18, 23] */
          return -1;

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern377 (x6, 
E_HImode);
          if (res >= 0)
            return res + 24; /* [24, 29] */
          return -1;

        case E_PSImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern377 (x6, 
E_PSImode);
          if (res >= 0)
            return res + 30; /* [30, 35] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern178 (x3, 
E_QImode) != 0)
        return -1;
      if (
#line 2200 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 300; /* *mulqi3_enh_split */
      if (pnum_clobbers == NULL
          || !
#line 2213 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 301; /* *mulqi3_enh */

    case E_HImode:
      if (pattern178 (x3, 
E_HImode) != 0)
        return -1;
      if (
#line 3268 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 537; /* *mulhi3_enh_split */
      if (pnum_clobbers == NULL
          || !
#line 3281 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 538; /* *mulhi3_enh */

    case E_SImode:
      if (pattern179 (x3, pnum_clobbers, 
E_SImode) != 0)
        return -1;
      if (pseudo_register_or_const_int_operand (operands[2], E_SImode)
          && 
#line 3398 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
        {
          *pnum_clobbers = 2;
          return 541; /* *mulsi3 */
        }
      if (!pseudo_register_operand (operands[2], E_SImode)
          || !
#line 3434 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && ! reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 542; /* *mulsi3_pr118012 */

    case E_PSImode:
      if (pattern179 (x3, pnum_clobbers, 
E_PSImode) != 0
          || !pseudo_register_or_const_int_operand (operands[2], E_PSImode)
          || !
#line 4192 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 601; /* *mulpsi3 */

    case E_QQmode:
      if (pattern178 (x3, 
E_QQmode) != 0)
        return -1;
      if (
#line 296 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
        return 3053; /* mulqq3_enh */
      if (pnum_clobbers == NULL
          || !
#line 309 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3054; /* *mulqq3_enh */

    case E_UQQmode:
      if (pattern178 (x3, 
E_UQQmode) != 0)
        return -1;
      if (
#line 317 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
        return 3055; /* muluqq3_enh */
      if (pnum_clobbers == NULL
          || !
#line 330 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3056; /* *muluqq3_enh */

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != ZERO_EXTEND)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  switch (REGNO (x4))
    {
    case 22:
      if (GET_MODE (x4) != E_QImode
          || REGNO (x6) != 24
          || pattern283 (x1, 
E_HImode, 
24, 
E_QImode) != 0)
        return -1;
      if (
#line 2432 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
        {
          *pnum_clobbers = 2;
          return 476; /* *umulqihi3.call_split */
        }
      if (!
#line 2449 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 477; /* *umulqihi3.call */

    case 18:
      if (GET_MODE (x4) != E_SImode
          || REGNO (x6) != 22
          || pattern283 (x1, 
E_DImode, 
18, 
E_SImode) != 0)
        return -1;
      if (
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
        {
          *pnum_clobbers = 2;
          return 3338; /* umulsidi3_insn */
        }
      if (!
#line 693 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL
   && reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 3340; /* *umulsidi3_insn */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x2, 1);
  switch (pattern244 (x4, pnum_clobbers))
    {
    case 0:
      if (s8_operand (operands[2], E_HImode)
          && 
#line 2989 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        {
          *pnum_clobbers = 1;
          return 521; /* *mulsqihi3.sconst */
        }
      if (u8_operand (operands[2], E_HImode)
          && 
#line 3025 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        {
          *pnum_clobbers = 1;
          return 524; /* *mulsqihi3.uconst */
        }
      if (!o8_operand (operands[2], E_HImode)
          || !
#line 3043 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      *pnum_clobbers = 1;
      return 525; /* *mulsqihi3.oconst */

    case 1:
      if (
#line 3144 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 531; /* mulsqihi3 */
      if (pnum_clobbers == NULL
          || !
#line 3157 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 532; /* *mulsqihi3 */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern49 (x3, 
E_QImode) != 0)
        return -1;
      return 661; /* *ashlqi3_split */

    case E_QQmode:
      if (pattern49 (x3, 
E_QQmode) != 0)
        return -1;
      return 662; /* *ashlqq3_split */

    case E_UQQmode:
      if (pattern49 (x3, 
E_UQQmode) != 0)
        return -1;
      return 663; /* *ashluqq3_split */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 667; /* ashlhi3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5567 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 692; /* *ashlhi3_const */

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 668; /* ashlhq3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5567 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 693; /* *ashlhq3_const */

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 669; /* ashluhq3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5567 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 694; /* *ashluhq3_const */

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 670; /* ashlha3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5567 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 695; /* *ashlha3_const */

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 671; /* ashluha3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5567 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 696; /* *ashluha3_const */

    case E_SImode:
      if (pattern49 (x3, 
E_SImode) != 0)
        return -1;
      return 682; /* ashlsi3 */

    case E_SQmode:
      if (pattern49 (x3, 
E_SQmode) != 0)
        return -1;
      return 683; /* ashlsq3 */

    case E_USQmode:
      if (pattern49 (x3, 
E_USQmode) != 0)
        return -1;
      return 684; /* ashlusq3 */

    case E_SAmode:
      if (pattern49 (x3, 
E_SAmode) != 0)
        return -1;
      return 685; /* ashlsa3 */

    case E_USAmode:
      if (pattern49 (x3, 
E_USAmode) != 0)
        return -1;
      return 686; /* ashlusa3 */

    case E_PSImode:
      if (pattern50 (x3, pnum_clobbers, 
E_QImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 702; /* *ashlpsi3_split */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  switch (pattern83 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      operands[0] = x3;
      switch (pattern247 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (register_operand (operands[1], E_QImode)
                  && nonmemory_operand (operands[2], E_QImode))
                return 878; /* cbranchqi4_insn */
              break;

            case E_QQmode:
              if (register_operand (operands[1], E_QQmode)
                  && nonmemory_operand (operands[2], E_QQmode))
                return 879; /* cbranchqq4_insn */
              break;

            case E_UQQmode:
              if (register_operand (operands[1], E_UQQmode)
                  && nonmemory_operand (operands[2], E_UQQmode))
                return 880; /* cbranchuqq4_insn */
              break;

            case E_SImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_SImode)
                  && nonmemory_operand (operands[2], E_SImode))
                {
                  *pnum_clobbers = 1;
                  return 881; /* cbranchsi4_insn */
                }
              break;

            case E_SQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_SQmode)
                  && nonmemory_operand (operands[2], E_SQmode))
                {
                  *pnum_clobbers = 1;
                  return 882; /* cbranchsq4_insn */
                }
              break;

            case E_USQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_USQmode)
                  && nonmemory_operand (operands[2], E_USQmode))
                {
                  *pnum_clobbers = 1;
                  return 883; /* cbranchusq4_insn */
                }
              break;

            case E_SAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_SAmode)
                  && nonmemory_operand (operands[2], E_SAmode))
                {
                  *pnum_clobbers = 1;
                  return 884; /* cbranchsa4_insn */
                }
              break;

            case E_USAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_USAmode)
                  && nonmemory_operand (operands[2], E_USAmode))
                {
                  *pnum_clobbers = 1;
                  return 885; /* cbranchusa4_insn */
                }
              break;

            case E_PSImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_PSImode)
                  && nonmemory_operand (operands[2], E_PSImode))
                {
                  *pnum_clobbers = 1;
                  return 886; /* cbranchpsi4_insn */
                }
              break;

            case E_HImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_HImode)
                  && nonmemory_operand (operands[2], E_HImode))
                {
                  *pnum_clobbers = 1;
                  return 887; /* cbranchhi4_insn */
                }
              break;

            case E_HQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_HQmode)
                  && nonmemory_operand (operands[2], E_HQmode))
                {
                  *pnum_clobbers = 1;
                  return 888; /* cbranchhq4_insn */
                }
              break;

            case E_UHQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_UHQmode)
                  && nonmemory_operand (operands[2], E_UHQmode))
                {
                  *pnum_clobbers = 1;
                  return 889; /* cbranchuhq4_insn */
                }
              break;

            case E_HAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_HAmode)
                  && nonmemory_operand (operands[2], E_HAmode))
                {
                  *pnum_clobbers = 1;
                  return 890; /* cbranchha4_insn */
                }
              break;

            case E_UHAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_UHAmode)
                  && nonmemory_operand (operands[2], E_UHAmode))
                {
                  *pnum_clobbers = 1;
                  return 891; /* cbranchuha4_insn */
                }
              break;

            default:
              break;
            }
          break;

        case 1:
          if (
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return 904; /* *cbranchhi.sign_extendqi.0 */
          break;

        case 2:
          if (
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return 906; /* *cbranchpsi.sign_extendqi.0 */
          break;

        case 3:
          if (
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return 910; /* *cbranchpsi.sign_extendhi.0 */
          break;

        case 4:
          if (
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return 908; /* *cbranchsi.sign_extendqi.0 */
          break;

        case 5:
          if (
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return 912; /* *cbranchsi.sign_extendhi.0 */
          break;

        case 6:
          if (
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return 914; /* *cbranchsi.sign_extendpsi.0 */
          break;

        case 7:
          if (
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return 905; /* *cbranchhi.zero_extendqi.0 */
          break;

        case 8:
          if (
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return 907; /* *cbranchpsi.zero_extendqi.0 */
          break;

        case 9:
          if (
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return 911; /* *cbranchpsi.zero_extendhi.0 */
          break;

        case 10:
          if (
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return 909; /* *cbranchsi.zero_extendqi.0 */
          break;

        case 11:
          if (
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return 913; /* *cbranchsi.zero_extendhi.0 */
          break;

        case 12:
          if (
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return 915; /* *cbranchsi.zero_extendpsi.0 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != REG)
        return -1;
      switch (REGNO (x4))
        {
        case 36:
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[1] = x3;
          x6 = XEXP (x2, 1);
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          switch (GET_MODE (x4))
            {
            case E_CCmode:
              if (!
#line 7780 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 966; /* branch */

            case E_CCNmode:
              if (!
#line 7780 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 967; /* branch_N */

            case E_CCZNmode:
              if (!
#line 7780 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 968; /* branch_ZN */

            default:
              return -1;
            }

        case 18:
          operands[0] = x3;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case REG:
              if (REGNO (x5) != 10)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              switch (pattern317 (x3))
                {
                case 0:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3251; /* cbranch_di2_split */

                case 1:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3252; /* cbranch_dq2_split */

                case 2:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3253; /* cbranch_udq2_split */

                case 3:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3254; /* cbranch_da2_split */

                case 4:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3255; /* cbranch_uda2_split */

                case 5:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3256; /* cbranch_ta2_split */

                case 6:
                  if (!
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3257; /* cbranch_uta2_split */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (pattern284 (x3) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (!
#line 529 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                return -1;
              return 3265; /* cbranch_const8_di2_split */

            case CONST_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
              if (pnum_clobbers == NULL)
                return -1;
              operands[1] = x5;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              switch (GET_MODE (x4))
                {
                case E_DImode:
                  if (!const_operand (operands[1], E_DImode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3267; /* cbranch_const_di2_split */

                case E_DQmode:
                  if (!const_operand (operands[1], E_DQmode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3268; /* cbranch_const_dq2_split */

                case E_UDQmode:
                  if (!const_operand (operands[1], E_UDQmode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3269; /* cbranch_const_udq2_split */

                case E_DAmode:
                  if (!const_operand (operands[1], E_DAmode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3270; /* cbranch_const_da2_split */

                case E_UDAmode:
                  if (!const_operand (operands[1], E_UDAmode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3271; /* cbranch_const_uda2_split */

                case E_TAmode:
                  if (!const_operand (operands[1], E_TAmode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3272; /* cbranch_const_ta2_split */

                case E_UTAmode:
                  if (!const_operand (operands[1], E_UTAmode)
                      || !
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3273; /* cbranch_const_uta2_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      switch (pattern219 (x2))
        {
        case 0:
          if (!
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return -1;
          return 892; /* *cbranchhi.sign_extendqi.0 */

        case 1:
          if (!
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return -1;
          return 894; /* *cbranchpsi.sign_extendqi.0 */

        case 2:
          if (!
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return -1;
          return 898; /* *cbranchpsi.sign_extendhi.0 */

        case 3:
          if (!
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return -1;
          return 896; /* *cbranchsi.sign_extendqi.0 */

        case 4:
          if (!
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return -1;
          return 900; /* *cbranchsi.sign_extendhi.0 */

        case 5:
          if (!
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return -1;
          return 902; /* *cbranchsi.sign_extendpsi.0 */

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      switch (pattern219 (x2))
        {
        case 0:
          if (!
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return -1;
          return 893; /* *cbranchhi.zero_extendqi.0 */

        case 1:
          if (!
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return -1;
          return 895; /* *cbranchpsi.zero_extendqi.0 */

        case 2:
          if (!
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return -1;
          return 899; /* *cbranchpsi.zero_extendhi.0 */

        case 3:
          if (!
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return -1;
          return 897; /* *cbranchsi.zero_extendqi.0 */

        case 4:
          if (!
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return -1;
          return 901; /* *cbranchsi.zero_extendhi.0 */

        case 5:
          if (!
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return -1;
          return 903; /* *cbranchsi.zero_extendpsi.0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG)
        return -1;
      switch (pattern53 (x1))
        {
        case 0:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3284; /* rotldi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3312; /* *rotldi3_insn */

        case 1:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3288; /* rotldq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3316; /* *rotldq3_insn */

        case 2:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3292; /* rotludq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3320; /* *rotludq3_insn */

        case 3:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3296; /* rotlda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3324; /* *rotlda3_insn */

        case 4:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3300; /* rotluda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3328; /* *rotluda3_insn */

        case 5:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3304; /* rotlta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3332; /* *rotlta3_insn */

        case 6:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3308; /* rotluta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3336; /* *rotluta3_insn */

        default:
          return -1;
        }

    case CONST_INT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      switch (XWINT (x3, 0))
        {
        case 1L:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_QImode)
              || !
#line 8971 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1014; /* *mask1_0x01 */

        case -2L:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              if (GET_MODE (x5) != E_QImode)
                return -1;
              x6 = XEXP (x5, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
                return -1;
              x7 = XEXP (x5, 0);
              operands[1] = x7;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 1018; /* mask1_0xfe_split */

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode)
                  || !
#line 9047 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 1019; /* *mask1_0xfe */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) == REG
          && REGNO (x7) == 36
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern99 (x4, 
E_QImode) == 0
                  && 
#line 1585 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 177; /* *addqi3 */
              break;

            case E_QQmode:
              if (pattern99 (x4, 
E_QQmode) == 0
                  && 
#line 1585 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 178; /* *addqq3 */
              break;

            case E_UQQmode:
              if (pattern99 (x4, 
E_UQQmode) == 0
                  && 
#line 1585 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 179; /* *adduqq3 */
              break;

            case E_HImode:
              if (pattern296 (x4, 
E_HImode) == 0
                  && 
#line 1843 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 199; /* *addhi3 */
              break;

            case E_HQmode:
              if (pattern296 (x4, 
E_HQmode) == 0
                  && 
#line 1843 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 200; /* *addhq3 */
              break;

            case E_UHQmode:
              if (pattern296 (x4, 
E_UHQmode) == 0
                  && 
#line 1843 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 201; /* *adduhq3 */
              break;

            case E_HAmode:
              if (pattern296 (x4, 
E_HAmode) == 0
                  && 
#line 1843 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 202; /* *addha3 */
              break;

            case E_UHAmode:
              if (pattern296 (x4, 
E_UHAmode) == 0
                  && 
#line 1843 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 203; /* *adduha3 */
              break;

            default:
              break;
            }
        }
      operands[3] = x7;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern295 (x4, 
E_HImode) != 0)
            return -1;
          return 204; /* addhi3_clobber */

        case E_HQmode:
          if (pattern295 (x4, 
E_HQmode) != 0)
            return -1;
          return 205; /* addhq3_clobber */

        case E_UHQmode:
          if (pattern295 (x4, 
E_UHQmode) != 0)
            return -1;
          return 206; /* adduhq3_clobber */

        case E_HAmode:
          if (pattern295 (x4, 
E_HAmode) != 0)
            return -1;
          return 207; /* addha3_clobber */

        case E_UHAmode:
          if (pattern295 (x4, 
E_UHAmode) != 0)
            return -1;
          return 208; /* adduha3_clobber */

        case E_SImode:
          if (pattern99 (x4, 
E_SImode) != 0)
            return -1;
          return 214; /* addsi3 */

        case E_SQmode:
          if (pattern99 (x4, 
E_SQmode) != 0)
            return -1;
          return 215; /* addsq3 */

        case E_USQmode:
          if (pattern99 (x4, 
E_USQmode) != 0)
            return -1;
          return 216; /* addusq3 */

        case E_SAmode:
          if (pattern99 (x4, 
E_SAmode) != 0)
            return -1;
          return 217; /* addsa3 */

        case E_USAmode:
          if (pattern99 (x4, 
E_USAmode) != 0)
            return -1;
          return 218; /* addusa3 */

        case E_PSImode:
          if (pattern99 (x4, 
E_PSImode) != 0)
            return -1;
          return 270; /* addpsi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern211 (x1) != 0
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 1667 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 183; /* *addhi3_zero_extend1 */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x5, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !nonmemory_operand (operands[1], E_HImode)
          || !
#line 6814 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 864; /* cmphi3 */

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !nonmemory_operand (operands[1], E_HQmode)
          || !
#line 6814 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 865; /* cmphq3 */

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !nonmemory_operand (operands[1], E_UHQmode)
          || !
#line 6814 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 866; /* cmpuhq3 */

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !nonmemory_operand (operands[1], E_HAmode)
          || !
#line 6814 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 867; /* cmpha3 */

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !nonmemory_operand (operands[1], E_UHAmode)
          || !
#line 6814 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 868; /* cmpuha3 */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !nonmemory_operand (operands[1], E_PSImode)
          || !
#line 6849 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 869; /* *cmppsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !nonmemory_operand (operands[1], E_SImode)
          || !
#line 6881 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 870; /* *cmpsi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !nonmemory_operand (operands[1], E_SQmode)
          || !
#line 6881 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 871; /* *cmpsq */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !nonmemory_operand (operands[1], E_USQmode)
          || !
#line 6881 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 872; /* *cmpusq */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !nonmemory_operand (operands[1], E_SAmode)
          || !
#line 6881 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 873; /* *cmpsa */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !nonmemory_operand (operands[1], E_USAmode)
          || !
#line 6881 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 874; /* *cmpusa */

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 36
          && GET_MODE (x6) == E_CCmode)
        {
          x7 = XEXP (x3, 0);
          operands[0] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern309 (x4, 
E_QImode) == 0
                  && 
#line 2213 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return 301; /* *mulqi3_enh */
              break;

            case E_HImode:
              if (pattern309 (x4, 
E_HImode) == 0
                  && 
#line 3281 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return 538; /* *mulhi3_enh */
              break;

            case E_QQmode:
              if (pattern309 (x4, 
E_QQmode) == 0
                  && 
#line 309 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return 3054; /* *mulqq3_enh */
              break;

            case E_UQQmode:
              if (pattern309 (x4, 
E_UQQmode) == 0
                  && 
#line 330 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return 3056; /* *muluqq3_enh */
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x5) != REG)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != REG)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG
          || GET_CODE (x6) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 24:
          if (pattern269 (x1) != 0
              || !
#line 2234 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            return -1;
          return 302; /* *mulqi3_call_split */

        case 22:
          if (pattern270 (x1) != 0
              || !
#line 3710 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 564; /* *mulsi3_call_split */

        case 18:
          switch (pattern271 (x1))
            {
            case 0:
              if (!
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3059; /* *mulhq3.call_split */

            case 1:
              if (!
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3060; /* *muluhq3.call_split */

            case 2:
              if (!
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3061; /* *mulha3.call_split */

            case 3:
              if (!
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3062; /* *muluha3.call_split */

            default:
              return -1;
            }

        case 16:
          if (REGNO (x8) != 20
              || REGNO (x7) != 24
              || REGNO (x6) != 36
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (pattern260 (x3))
            {
            case 0:
              if (!
#line 481 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 3069; /* *mulsa3.call */

            case 1:
              if (!
#line 481 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 3070; /* *mulusa3.call */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x5) == E_HImode)
        {
          res = recog_44 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (REGNO (x9))
        {
        case 18:
          if (pattern286 (x4, 
E_HImode, 
26, 
E_SImode) != 0
              || pattern287 (x3, 
E_SImode, 
22) != 0
              || !
#line 3783 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 570; /* *mulhisi3_call */

        case 26:
          if (pattern288 (x3, 
E_SImode, 
22, 
18, 
E_HImode) != 0
              || !
#line 3854 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 580; /* *mulshisi3_call */

        case 25:
          if (pattern288 (x3, 
E_PSImode, 
18, 
22, 
E_QImode) != 0
              || !
#line 4233 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 603; /* *mulsqipsi3.libgcc */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      res = recog_45 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG
          || GET_CODE (x7) != REG
          || REGNO (x7) != 22
          || GET_MODE (x7) != E_SImode)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x9) != E_HImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      switch (REGNO (x9))
        {
        case 18:
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 26
                  || GET_MODE (x10) != E_HImode
                  || !
#line 3783 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 571; /* *umulhisi3_call */

            case SIGN_EXTEND:
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 26
                  || GET_MODE (x10) != E_HImode
                  || !
#line 3833 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 577; /* *usmulhisi3_call */

            default:
              return -1;
            }

        case 26:
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 18
              || !
#line 3854 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 581; /* *muluhisi3_call */

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != ZERO_EXTEND)
        return -1;
      x11 = XEXP (x9, 0);
      if (GET_CODE (x11) != NOT)
        return -1;
      if (GET_MODE (x11) == E_QImode)
        {
          res = recog_46 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_MODE (x11) != E_HImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 26
          || GET_MODE (x12) != E_HImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 18
          || GET_MODE (x8) != E_SImode
          || pattern143 (x1, 
36, 
E_CCmode, 
E_SImode, 
22) != 0
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x9) != E_SImode
          || !
#line 3875 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 583; /* *mulohisi3_call */

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case LSHIFTRT:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MULT)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x9) == E_HImode
              && pattern274 (x1, 
SIGN_EXTEND) == 0
              && 
#line 2277 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 306; /* *smulqi3_highpart */
          if (GET_MODE (x9) != E_SImode
              || pattern275 (x1, 
SIGN_EXTEND) != 0
              || !
#line 3795 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 572; /* *smulhi3_highpart_call_split */

        case ZERO_EXTEND:
          if (GET_MODE (x9) == E_HImode
              && pattern274 (x1, 
ZERO_EXTEND) == 0
              && 
#line 2277 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 307; /* *umulqi3_highpart */
          if (GET_MODE (x9) != E_SImode
              || pattern275 (x1, 
ZERO_EXTEND) != 0
              || !
#line 3795 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 573; /* *umulhi3_highpart_call_split */

        default:
          return -1;
        }

    case PARITY:
      if (pattern192 (x1, 
E_CCmode, 
36) != 0
          || !
#line 9238 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1030; /* *paritysihi2.libgcc */

    case POPCOUNT:
      if (pattern192 (x1, 
E_CCmode, 
36) != 0
          || !
#line 9314 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1035; /* *popcountsi2.libgcc */

    case CLZ:
      if (pattern192 (x1, 
E_QImode, 
26) != 0)
        return -1;
      return 1041; /* *clzsihi2.libgcc_split */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PARITY
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  if (REGNO (x6) == 24
      && GET_MODE (x6) == E_HImode)
    {
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (register_operand (operands[0], E_HImode))
        {
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (register_operand (operands[1], E_QImode)
              && 
#line 9150 "../../gcc/config/avr/avr.md"
(!reload_completed))
            return 1023; /* *parityqihi2.1 */
        }
    }
  if (REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x8 = XEXP (x4, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 24
      || GET_MODE (x8) != E_QImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 24
      || GET_MODE (x7) != E_HImode
      || !
#line 9220 "../../gcc/config/avr/avr.md"
(reload_completed))
    return -1;
  return 1028; /* *parityqihi2.libgcc */
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern231 (x1, 
MOD))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != MOD)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 22)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern362 (x1))
        {
        case 0:
          return 585; /* *divmodqi4_call_split */

        case 1:
          return 591; /* *divmodhi4_call_split */

        default:
          return -1;
        }

    case 1:
      switch (pattern312 (x1))
        {
        case 0:
          if (!
#line 625 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3100; /* *divsa3.call */

        case 1:
          if (!
#line 625 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3102; /* *divusa3.call */

        default:
          return -1;
        }

    case 2:
      return 613; /* *divmodsi4_call_split */

    case 3:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3088; /* *divhq3.call */

    case 4:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3090; /* *divuhq3.call */

    case 5:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3092; /* *divha3.call */

    case 6:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3094; /* *divuha3.call */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      if (REGNO (x8) != 22)
        return -1;
      switch (REGNO (x4))
        {
        case 22:
          if (REGNO (x5) != 24)
            return -1;
          x9 = XVECEXP (x1, 0, 2);
          x10 = XEXP (x9, 0);
          switch (REGNO (x10))
            {
            case 36:
              if (pattern343 (x1, 
E_QImode, 
E_CCmode) != 0
                  || !
#line 2247 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
                return -1;
              return 303; /* *mulqi3_call */

            case 21:
              if (pattern343 (x1, 
E_HImode, 
E_QImode) != 0
                  || !
#line 3310 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                return -1;
              return 539; /* *mulhi3_call_split */

            default:
              return -1;
            }

        case 25:
          if (pattern325 (x1) != 0
              || !
#line 377 "../../gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL))
            return -1;
          return 3057; /* *mulqq3.call_split */

        default:
          return -1;
        }

    case 22:
      if (GET_MODE (x6) != E_SImode
          || REGNO (x4) != 18
          || GET_MODE (x4) != E_SImode
          || REGNO (x5) != 22
          || GET_MODE (x5) != E_SImode
          || pattern344 (x1, 
E_CCmode, 
36, 
E_HImode, 
26) != 0
          || GET_MODE (x3) != E_SImode
          || !
#line 3745 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 566; /* *mulsi3_call */

    case 18:
      switch (pattern294 (x1, 
E_CCmode, 
36, 
22, 
26))
        {
        case 0:
          if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3063; /* *mulhq3.call */

        case 1:
          if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3064; /* *muluhq3.call */

        case 2:
          if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3065; /* *mulha3.call */

        case 3:
          if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3066; /* *muluha3.call */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      if (pattern95 (x2) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 21
          || GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      switch (pattern363 (x1))
        {
        case 0:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 83; /* fxload_qi_libgcc */

        case 1:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 84; /* fxload_qq_libgcc */

        case 2:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 85; /* fxload_uqq_libgcc */

        case 3:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 86; /* fxload_hi_libgcc */

        case 4:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 87; /* fxload_hq_libgcc */

        case 5:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 88; /* fxload_uhq_libgcc */

        case 6:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 89; /* fxload_ha_libgcc */

        case 7:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 90; /* fxload_uha_libgcc */

        case 8:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 91; /* fxload_si_libgcc */

        case 9:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 92; /* fxload_sq_libgcc */

        case 10:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 93; /* fxload_usq_libgcc */

        case 11:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 94; /* fxload_sa_libgcc */

        case 12:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 95; /* fxload_usa_libgcc */

        case 13:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 96; /* fxload_sf_libgcc */

        case 14:
          if (!
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 97; /* fxload_psi_libgcc */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_79 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern161 (x1) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          *pnum_clobbers = 2;
          return 168; /* *clrmemqi_split */

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          *pnum_clobbers = 2;
          return 170; /* *clrmemhi_split */

        default:
          return -1;
        }

    case PLUS:
      return recog_83 (x1, insn, pnum_clobbers);

    case MINUS:
      if (pattern96 (x1) != 0
          || !scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern296 (x3, 
E_HImode) != 0
              || !
#line 2143 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 285; /* *subhi3 */

        case E_HQmode:
          if (pattern296 (x3, 
E_HQmode) != 0
              || !
#line 2143 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 286; /* *subhq3 */

        case E_UHQmode:
          if (pattern296 (x3, 
E_UHQmode) != 0
              || !
#line 2143 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 287; /* *subuhq3 */

        case E_HAmode:
          if (pattern296 (x3, 
E_HAmode) != 0
              || !
#line 2143 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 288; /* *subha3 */

        case E_UHAmode:
          if (pattern296 (x3, 
E_UHAmode) != 0
              || !
#line 2143 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 289; /* *subuha3 */

        case E_SImode:
          if (pattern296 (x3, 
E_SImode) != 0
              || !
#line 2173 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 295; /* *subsi3 */

        case E_SQmode:
          if (pattern296 (x3, 
E_SQmode) != 0
              || !
#line 2173 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 296; /* *subsq3 */

        case E_USQmode:
          if (pattern296 (x3, 
E_USQmode) != 0
              || !
#line 2173 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 297; /* *subusq3 */

        case E_SAmode:
          if (pattern296 (x3, 
E_SAmode) != 0
              || !
#line 2173 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 298; /* *subsa3 */

        case E_USAmode:
          if (pattern296 (x3, 
E_USAmode) != 0
              || !
#line 2173 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 299; /* *subusa3 */

        default:
          return -1;
        }

    case MULT:
      return recog_81 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      if (pattern98 (x2, 
24, 
E_HImode) != 0
          || pattern97 (x1) != 0)
        return -1;
      x10 = XEXP (x3, 0);
      if (GET_MODE (x10) != E_SImode)
        return -1;
      switch (GET_CODE (x10))
        {
        case LSHIFTRT:
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != MULT
              || GET_MODE (x11) != E_SImode)
            return -1;
          x12 = XEXP (x10, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || pattern344 (x1, 
E_CCmode, 
36, 
E_HImode, 
22) != 0)
            return -1;
          switch (pattern346 (x11))
            {
            case 0:
              if (!
#line 3812 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 574; /* *smulhi3_highpart_call */

            case 1:
              if (!
#line 3812 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 575; /* *umulhi3_highpart_call */

            default:
              return -1;
            }

        case CLZ:
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 22
              || GET_MODE (x11) != E_SImode
              || pattern344 (x1, 
E_CCmode, 
36, 
E_QImode, 
26) != 0
              || !
#line 9411 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1042; /* *clzsihi2.libgcc */

        case CTZ:
          if (pattern322 (x1) != 0)
            return -1;
          return 1045; /* *ctzsihi2.libgcc_split */

        case FFS:
          if (pattern322 (x1) != 0)
            return -1;
          return 1049; /* *ffssihi2.libgcc_split */

        default:
          return -1;
        }

    case UDIV:
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      x13 = XEXP (x3, 1);
      if (GET_CODE (x13) != REG)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      switch (REGNO (x10))
        {
        case 24:
          switch (pattern263 (x1))
            {
            case 0:
              return 588; /* *udivmodqi4_call_split */

            case 1:
              return 3095; /* *udivsa3.call_split */

            case 2:
              return 3097; /* *udivusa3.call_split */

            default:
              return -1;
            }

        case 25:
          if (REGNO (x13) != 22
              || REGNO (x8) != 24)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != REG)
            return -1;
          switch (pattern323 (x1))
            {
            case 0:
              if (!
#line 529 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3075; /* *udivqq3.call */

            case 1:
              if (!
#line 529 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3077; /* *udivuqq3.call */

            default:
              return -1;
            }

        case 26:
          switch (pattern266 (x1))
            {
            case 0:
              return 3079; /* *udivhq3.call_split */

            case 1:
              return 3081; /* *udivuhq3.call_split */

            case 2:
              return 3083; /* *udivha3.call_split */

            case 3:
              return 3085; /* *udivuha3.call_split */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern102 (x1))
        {
        case 0:
          if (!
#line 4517 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 621; /* *andhi3 */

        case 1:
          if (!
#line 4551 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 623; /* *andpsi3 */

        case 2:
          if (!
#line 4586 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 625; /* *andsi3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern102 (x1))
        {
        case 0:
          if (!
#line 4665 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 629; /* *iorhi3 */

        case 1:
          if (!
#line 4697 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 631; /* *iorpsi3 */

        case 2:
          if (!
#line 4729 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 633; /* *iorsi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern102 (x1))
        {
        case 0:
          if (!
#line 4786 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 637; /* *xorhi3 */

        case 1:
          if (!
#line 4816 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 639; /* *xorpsi3 */

        case 2:
          if (!
#line 4848 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 641; /* *xorsi3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern96 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern104 (x3, 
E_HImode) != 0
              || !
#line 5567 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 692; /* *ashlhi3_const */

        case E_HQmode:
          if (pattern104 (x3, 
E_HQmode) != 0
              || !
#line 5567 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 693; /* *ashlhq3_const */

        case E_UHQmode:
          if (pattern104 (x3, 
E_UHQmode) != 0
              || !
#line 5567 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 694; /* *ashluhq3_const */

        case E_HAmode:
          if (pattern104 (x3, 
E_HAmode) != 0
              || !
#line 5567 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 695; /* *ashlha3_const */

        case E_UHAmode:
          if (pattern104 (x3, 
E_UHAmode) != 0
              || !
#line 5567 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 696; /* *ashluha3_const */

        case E_SImode:
          if (pattern105 (x3, 
E_SImode) != 0
              || !
#line 5665 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 697; /* *ashlsi3_const */

        case E_SQmode:
          if (pattern105 (x3, 
E_SQmode) != 0
              || !
#line 5665 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 698; /* *ashlsq3_const */

        case E_USQmode:
          if (pattern105 (x3, 
E_USQmode) != 0
              || !
#line 5665 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 699; /* *ashlusq3_const */

        case E_SAmode:
          if (pattern105 (x3, 
E_SAmode) != 0
              || !
#line 5665 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 700; /* *ashlsa3_const */

        case E_USAmode:
          if (pattern105 (x3, 
E_USAmode) != 0
              || !
#line 5665 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 701; /* *ashlusa3_const */

        case E_PSImode:
          if (pattern103 (x3) != 0
              || !
#line 5723 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 703; /* *ashlpsi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern106 (x1))
        {
        case 0:
          if (!
#line 5840 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 722; /* *ashrpsi3 */

        case 1:
          if (!
#line 5887 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 733; /* *ashrhi3_const */

        case 2:
          if (!
#line 5887 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 734; /* *ashrhq3_const */

        case 3:
          if (!
#line 5887 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 735; /* *ashruhq3_const */

        case 4:
          if (!
#line 5887 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 736; /* *ashrha3_const */

        case 5:
          if (!
#line 5887 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 737; /* *ashruha3_const */

        case 6:
          if (!
#line 5905 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 738; /* *ashrsi3_const */

        case 7:
          if (!
#line 5905 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 739; /* *ashrsq3_const */

        case 8:
          if (!
#line 5905 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 740; /* *ashrusq3_const */

        case 9:
          if (!
#line 5905 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 741; /* *ashrsa3_const */

        case 10:
          if (!
#line 5905 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 742; /* *ashrusa3_const */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern106 (x1))
        {
        case 0:
          if (!
#line 6040 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 760; /* *lshrpsi3 */

        case 1:
          if (!
#line 6143 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 771; /* *lshrhi3_const */

        case 2:
          if (!
#line 6143 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 772; /* *lshrhq3_const */

        case 3:
          if (!
#line 6143 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 773; /* *lshruhq3_const */

        case 4:
          if (!
#line 6143 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 774; /* *lshrha3_const */

        case 5:
          if (!
#line 6143 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 775; /* *lshruha3_const */

        case 6:
          if (!
#line 6160 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 776; /* *lshrsi3_const */

        case 7:
          if (!
#line 6160 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 777; /* *lshrsq3_const */

        case 8:
          if (!
#line 6160 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 778; /* *lshrusq3_const */

        case 9:
          if (!
#line 6160 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 779; /* *lshrsa3_const */

        case 10:
          if (!
#line 6160 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 780; /* *lshrusa3_const */

        default:
          return -1;
        }

    case COMPARE:
      return recog_82 (x1, insn, pnum_clobbers);

    case CLZ:
      if (pattern108 (x1) != 0
          || !
#line 9390 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1040; /* *clzhi2.libgcc */

    case CTZ:
      if (pattern108 (x1) != 0
          || !
#line 9459 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1044; /* *ctzhi2.libgcc */

    case FFS:
      if (pattern108 (x1) != 0
          || !
#line 9531 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1048; /* *ffshi2.libgcc */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x14 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x14) != REG)
        return -1;
      x15 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x15) != REG
          || GET_MODE (x15) != E_QImode)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (pattern107 (x6) != 0)
        return -1;
      switch (pattern281 (x1))
        {
        case 0:
          if (!
#line 9739 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 1060; /* *fmul.call */

        case 1:
          if (!
#line 9811 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 1064; /* *fmuls.call */

        case 2:
          if (!
#line 9883 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 1068; /* *fmulsu.call */

        case 3:
          if (!
#line 729 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3125; /* *roundqq3.libgcc */

        case 4:
          if (!
#line 729 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3126; /* *rounduqq3.libgcc */

        case 5:
          if (!
#line 755 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3131; /* *roundhq3.libgcc */

        case 6:
          if (!
#line 755 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3132; /* *rounduhq3.libgcc */

        case 7:
          if (!
#line 755 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3133; /* *roundha3.libgcc */

        case 8:
          if (!
#line 755 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3134; /* *rounduha3.libgcc */

        case 9:
          if (!
#line 781 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3139; /* *roundsq3.libgcc */

        case 10:
          if (!
#line 781 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3140; /* *roundusq3.libgcc */

        case 11:
          if (!
#line 781 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3141; /* *roundsa3.libgcc */

        case 12:
          if (!
#line 781 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3142; /* *roundusa3.libgcc */

        default:
          return -1;
        }

    case DIV:
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      x13 = XEXP (x3, 1);
      if (GET_CODE (x13) != REG)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || pattern97 (x1) != 0)
        return -1;
      switch (REGNO (x10))
        {
        case 25:
          if (REGNO (x13) != 22
              || REGNO (x8) != 24)
            return -1;
          switch (pattern323 (x1))
            {
            case 0:
              if (!
#line 529 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3076; /* *divqq3.call */

            case 1:
              if (!
#line 529 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3078; /* *divuqq3.call */

            default:
              return -1;
            }

        case 26:
          switch (pattern294 (x1, 
E_QImode, 
21, 
26, 
22))
            {
            case 0:
              return 3080; /* *divhq3.call_split */

            case 1:
              return 3082; /* *divuhq3.call_split */

            case 2:
              return 3084; /* *divha3.call_split */

            case 3:
              return 3086; /* *divuha3.call_split */

            default:
              return -1;
            }

        case 24:
          if (REGNO (x13) != 18
              || REGNO (x8) != 22)
            return -1;
          switch (pattern262 (x1))
            {
            case 0:
              return 3096; /* *divsa3.call_split */

            case 1:
              return 3098; /* *divusa3.call_split */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern39 (x1))
        {
        case 0:
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || !
#line 3065 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_303 (insn, operands);

        case 1:
          if (!(
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10886 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_987 (insn, operands);

        case 2:
          if (!(
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10886 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_989 (insn, operands);

        case 3:
          if (!(
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10886 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_993 (insn, operands);

        case 4:
          if (!(
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10886 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_991 (insn, operands);

        case 5:
          if (!(
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10886 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_995 (insn, operands);

        case 6:
          if (!(
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10886 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_997 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == CONST_INT
          && rtx_equal_p (x3, operands[0]))
        {
          switch (XWINT (x4, 0))
            {
            case 4L:
              switch (pattern165 (x2))
                {
                case 0:
                  return gen_split_408 (insn, operands);

                case 1:
                  return gen_split_409 (insn, operands);

                case 2:
                  return gen_split_410 (insn, operands);

                default:
                  break;
                }
              break;

            case 5L:
              switch (pattern165 (x2))
                {
                case 0:
                  return gen_split_411 (insn, operands);

                case 1:
                  return gen_split_412 (insn, operands);

                case 2:
                  return gen_split_413 (insn, operands);

                default:
                  break;
                }
              break;

            case 6L:
              switch (pattern165 (x2))
                {
                case 0:
                  return gen_split_414 (insn, operands);

                case 1:
                  return gen_split_415 (insn, operands);

                case 2:
                  return gen_split_416 (insn, operands);

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      operands[1] = x3;
      operands[2] = x4;
      switch (pattern142 (x2))
        {
        case 0:
          if (
#line 5321 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_417 (insn, operands);
          break;

        case 1:
          if (
#line 5321 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_418 (insn, operands);
          break;

        case 2:
          if (
#line 5321 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_419 (insn, operands);
          break;

        case 3:
          if (
#line 5348 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_420 (insn, operands);
          break;

        case 4:
          if (
#line 5348 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_421 (insn, operands);
          break;

        case 5:
          if (
#line 5348 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_422 (insn, operands);
          break;

        case 6:
          if (
#line 5348 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_423 (insn, operands);
          break;

        case 7:
          if (
#line 5348 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_424 (insn, operands);
          break;

        case 8:
          if (
#line 5464 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_430 (insn, operands);
          break;

        case 9:
          if (
#line 5464 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_431 (insn, operands);
          break;

        case 10:
          if (
#line 5464 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_432 (insn, operands);
          break;

        case 11:
          if (
#line 5464 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_433 (insn, operands);
          break;

        case 12:
          if (
#line 5464 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_434 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != REG)
        return NULL;
      switch (pattern53 (x1))
        {
        case 0:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1919 (insn, operands);

        case 1:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1923 (insn, operands);

        case 2:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1927 (insn, operands);

        case 3:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1931 (insn, operands);

        case 4:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1935 (insn, operands);

        case 5:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1939 (insn, operands);

        case 6:
          if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1943 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 1L
          || pattern71 (x1) != 0
          || !
#line 8960 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_629 (insn, operands);

    case ZERO_EXTEND:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != AND)
        return NULL;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern38 (x2))
        {
        case 0:
          if (!(
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10886 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_988 (insn, operands);

        case 1:
          if (!(
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10886 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_990 (insn, operands);

        case 2:
          if (!(
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10886 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_994 (insn, operands);

        case 3:
          if (!(
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10886 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_992 (insn, operands);

        case 4:
          if (!(
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10886 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_996 (insn, operands);

        case 5:
          if (!(
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10886 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_998 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (pattern141 (x3) == 0
          && 
#line 4477 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_367 (insn, operands);
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_QImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      switch (pattern204 (x3))
        {
        case 0:
          if (!(
#line 10627 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10629 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_768 (insn, operands);

        case 1:
          if (!(
#line 10627 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10629 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_770 (insn, operands);

        case 2:
          if (!(
#line 10627 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10629 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_772 (insn, operands);

        case 3:
          if (!(
#line 10627 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10629 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_769 (insn, operands);

        case 4:
          if (!(
#line 10627 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10629 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_771 (insn, operands);

        case 5:
          if (!(
#line 10627 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10629 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_773 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern73 (x3))
        {
        case 0:
          if (!
#line 10577 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_752 (insn, operands);

        case 1:
          if (!
#line 10577 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_755 (insn, operands);

        case 2:
          if (!
#line 10577 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_758 (insn, operands);

        case 3:
          if (!
#line 10577 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_761 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern73 (x3))
        {
        case 0:
          if (!
#line 10577 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_753 (insn, operands);

        case 1:
          if (!
#line 10577 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_756 (insn, operands);

        case 2:
          if (!
#line 10577 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_759 (insn, operands);

        case 3:
          if (!
#line 10577 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_762 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern73 (x3))
        {
        case 0:
          if (!
#line 10577 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_754 (insn, operands);

        case 1:
          if (!
#line 10577 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_757 (insn, operands);

        case 2:
          if (!
#line 10577 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_760 (insn, operands);

        case 3:
          if (!
#line 10577 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_763 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      switch (pattern125 (x3))
        {
        case 0:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_999 (insn, operands);

        case 1:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1003 (insn, operands);

        case 2:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1007 (insn, operands);

        case 3:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1011 (insn, operands);

        case 4:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1000 (insn, operands);

        case 5:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1004 (insn, operands);

        case 6:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1008 (insn, operands);

        case 7:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1012 (insn, operands);

        case 8:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1001 (insn, operands);

        case 9:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1005 (insn, operands);

        case 10:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1009 (insn, operands);

        case 11:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1013 (insn, operands);

        case 12:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1002 (insn, operands);

        case 13:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1006 (insn, operands);

        case 14:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1010 (insn, operands);

        case 15:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1014 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      if (pattern46 (x1) != 0
          || !
#line 5738 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_502 (insn, operands);

    case REG:
    case SUBREG:
      switch (pattern47 (x1))
        {
        case 0:
          if (!
#line 6567 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_556 (insn, operands);

        case 1:
          if (!
#line 6583 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_557 (insn, operands);

        case 2:
          if (!
#line 6614 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_559 (insn, operands);

        case 3:
          if (!
#line 6598 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_558 (insn, operands);

        case 4:
          if (!
#line 6648 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_561 (insn, operands);

        case 5:
          if (!
#line 6664 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_562 (insn, operands);

        case 6:
          if (!
#line 6677 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_563 (insn, operands);

        case 7:
          if (!
#line 6693 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_564 (insn, operands);

        case 8:
          if (!
#line 6709 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_565 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x3) != E_QImode
          || pattern35 (x1, 
E_QImode, 
24) != 0
          || !
#line 9211 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_639 (insn, operands);

    case POPCOUNT:
      if (GET_MODE (x3) != E_QImode
          || pattern34 (x1, 
E_HImode, 
24) != 0)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_QImode)
          && (
#line 9272 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 9274 "../../gcc/config/avr/avr.md"
( 1)))
        return gen_split_641 (insn, operands);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24
          || GET_MODE (x4) != E_QImode)
        return NULL;
      return gen_split_645 (insn, operands);

    case ZERO_EXTRACT:
      switch (pattern48 (x1))
        {
        case 0:
          if (!(
#line 10603 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10605 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_764 (insn, operands);

        case 1:
          if (!(
#line 10603 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10605 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_765 (insn, operands);

        case 2:
          if (!(
#line 10603 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10605 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_766 (insn, operands);

        case 3:
          if (!(
#line 10603 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10605 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_767 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      switch (pattern65 (x3))
        {
        case 0:
          if (!
#line 1543 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_98 (insn, operands);

        case 1:
          if (!
#line 8900 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_628 (insn, operands);

        case 2:
          if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1830 (insn, operands);

        case 3:
          if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1831 (insn, operands);

        case 4:
          if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1832 (insn, operands);

        case 5:
          if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1833 (insn, operands);

        case 6:
          if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1834 (insn, operands);

        case 7:
          if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1835 (insn, operands);

        case 8:
          if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1836 (insn, operands);

        case 9:
          if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1837 (insn, operands);

        case 10:
          if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1838 (insn, operands);

        case 11:
          if (!
#line 686 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1839 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return NULL;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_QImode))
        return NULL;
      switch (XINT (x3, 1))
        {
        case 3:
          if (!(
#line 9698 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 9700 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_653 (insn, operands);

        case 4:
          if (!(
#line 9770 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 9772 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_655 (insn, operands);

        case 5:
          if (!(
#line 9842 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 9844 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_657 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return NULL;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_DImode)
    return NULL;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return NULL;
  x10 = XEXP (x8, 1);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!pseudo_register_operand (operands[1], E_SImode))
    return NULL;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  if (!pseudo_register_operand (operands[2], E_SImode)
      || !(
#line 3434 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && ! reload_completed) && 
#line 3439 "../../gcc/config/avr/avr.md"
( 1)))
    return NULL;
  return gen_split_313 (insn, operands);
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return NULL;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return NULL;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 22)
    return NULL;
  switch (pattern326 (x1))
    {
    case 0:
      if (!(
#line 3310 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 3312 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_311 (insn, operands);

    case 1:
      if (!(
#line 377 "../../gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL) && 
#line 379 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1807 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_33 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case ZERO_EXTRACT:
          if (GET_MODE (x3) == E_QImode)
            {
              x4 = XEXP (x3, 1);
              if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
                {
                  x5 = XEXP (x3, 0);
                  operands[0] = x5;
                  if (register_operand (operands[0], E_QImode))
                    {
                      x6 = XEXP (x3, 2);
                      operands[1] = x6;
                      if (const_0_to_7_operand (operands[1], E_QImode))
                        {
                          operands[2] = x2;
                          if (nonmemory_operand (operands[2], E_QImode)
                              && 
#line 9995 "../../gcc/config/avr/avr.md"
( reload_completed))
                            return gen_split_659 (insn, operands);
                        }
                    }
                }
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x2) != SUBREG)
        return NULL;
      operands[0] = x3;
      if (GET_MODE (x2) != E_QImode)
        return NULL;
      switch (pattern112 (x2))
        {
        case 0:
          if (register_operand (operands[0], E_QImode))
            return gen_split_425 (insn, operands);
          if (!memory_operand (operands[0], E_QImode)
              || !(
#line 5400 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 5402 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_427 (insn, operands);

        case 1:
          if (register_operand (operands[0], E_QImode))
            return gen_split_426 (insn, operands);
          if (!memory_operand (operands[0], E_QImode)
              || !(
#line 5400 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 5402 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_428 (insn, operands);

        case 2:
          if (!(
#line 5418 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 5420 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_429 (insn, operands);

        case 3:
          if (!
#line 8993 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_630 (insn, operands);

        case 4:
          if (!(
#line 10461 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10463 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_727 (insn, operands);

        case 5:
          if (!(
#line 10461 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10463 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_728 (insn, operands);

        case 6:
          if (!(
#line 10461 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10463 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_729 (insn, operands);

        case 7:
          return gen_split_634 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      return split_23 (x1, insn);

    case PLUS:
      return split_10 (x1, insn);

    case MINUS:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 1767 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_107 (insn, operands);

        case 1:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          switch (pattern70 (x1))
            {
            case 0:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1865 (insn, operands);

            case 1:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1866 (insn, operands);

            case 2:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1867 (insn, operands);

            case 3:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1868 (insn, operands);

            case 4:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1869 (insn, operands);

            case 5:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1870 (insn, operands);

            case 6:
              if (!(
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1871 (insn, operands);

            case 7:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1872 (insn, operands);

            case 8:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1873 (insn, operands);

            case 9:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1874 (insn, operands);

            case 10:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1875 (insn, operands);

            case 11:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1876 (insn, operands);

            case 12:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1877 (insn, operands);

            case 13:
              if (!(
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1878 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      return split_13 (x1, insn);

    case TRUNCATE:
      return split_21 (x1, insn);

    case ASHIFT:
      return split_14 (x1, insn);

    case AND:
      return split_15 (x1, insn);

    case IOR:
      return split_12 (x1, insn);

    case XOR:
      return split_11 (x1, insn);

    case ROTATE:
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          res = split_6 (x1, insn);
          if (res != NULL_RTX)
            return res;
          if (GET_CODE (x7) != REG)
            return NULL;
          switch (pattern53 (x1))
            {
            case 0:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1922 (insn, operands);

            case 1:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1926 (insn, operands);

            case 2:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1930 (insn, operands);

            case 3:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1934 (insn, operands);

            case 4:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1938 (insn, operands);

            case 5:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1942 (insn, operands);

            case 6:
              if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1946 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
          if (XWINT (x7, 0) != -2L
              || pattern71 (x1) != 0
              || !
#line 9036 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_632 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      return split_19 (x1, insn);

    case ASHIFTRT:
      return split_22 (x1, insn);

    case LSHIFTRT:
      return split_17 (x1, insn);

    case ABS:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 6175 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_538 (insn, operands);

        case 1:
          if (!
#line 6195 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_539 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      return split_16 (x1, insn);

    case NOT:
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern54 (x1))
            {
            case 0:
              if (!
#line 6352 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_546 (insn, operands);

            case 1:
              if (!
#line 6370 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_547 (insn, operands);

            case 2:
              if (!
#line 6389 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_548 (insn, operands);

            case 3:
              if (!
#line 6407 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_549 (insn, operands);

            case 4:
              x3 = XEXP (x1, 0);
              x5 = XEXP (x3, 0);
              operands[0] = x5;
              if (!register_operand (operands[0], E_QImode))
                return NULL;
              x6 = XEXP (x3, 2);
              operands[1] = x6;
              if (!const_0_to_7_operand (operands[1], E_QImode)
                  || GET_MODE (x2) != E_QImode)
                return NULL;
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !
#line 10096 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_663 (insn, operands);

            default:
              return NULL;
            }

        case ROTATE:
          if (pattern55 (x1) != 0
              || !
#line 9023 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_631 (insn, operands);

        case LSHIFTRT:
          if (pattern56 (x1) != 0
              || !
#line 10065 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_660 (insn, operands);

        case ASHIFTRT:
          if (pattern56 (x1) != 0
              || !
#line 10065 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_661 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_550 (insn, operands);

        case 1:
          if (!
#line 6459 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_551 (insn, operands);

        case 2:
          if (!
#line 6501 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_553 (insn, operands);

        case 3:
          if (!
#line 6480 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_552 (insn, operands);

        case 4:
          if (!
#line 6522 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_554 (insn, operands);

        case 5:
          if (!
#line 6543 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_555 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      return split_18 (x1, insn);

    case PARITY:
      if (GET_MODE (x2) != E_HImode
          || pattern57 (x1, 
24, 
E_HImode) != 0
          || !
#line 9193 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_638 (insn, operands);

    case POPCOUNT:
      switch (pattern22 (x1))
        {
        case 0:
          if (!
#line 9287 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_642 (insn, operands);

        case 1:
          if (!
#line 9323 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_644 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      if (GET_MODE (x2) != E_SImode
          || pattern57 (x1, 
22, 
E_SImode) != 0
          || !
#line 9591 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_652 (insn, operands);

    case GE:
      if (GET_MODE (x2) != E_QImode)
        return NULL;
      x8 = XEXP (x2, 1);
      if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && pattern88 (x1) == 0
          && 
#line 10112 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_664 (insn, operands);
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern89 (x2))
        {
        case 0:
          if (!
#line 10521 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_743 (insn, operands);

        case 1:
          if (!
#line 10521 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_744 (insn, operands);

        case 2:
          if (!
#line 10521 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_745 (insn, operands);

        case 3:
          if (!
#line 10521 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_746 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      x8 = XEXP (x2, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case XOR:
          if (pattern85 (x1) != 0
              || !(
#line 10128 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))) && 
#line 10130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_665 (insn, operands);

        case REG:
        case SUBREG:
          operands[1] = x7;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          switch (pattern167 (x2))
            {
            case 0:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_774 (insn, operands);

            case 1:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_778 (insn, operands);

            case 2:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_782 (insn, operands);

            case 3:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_786 (insn, operands);

            case 4:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_775 (insn, operands);

            case 5:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_779 (insn, operands);

            case 6:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_783 (insn, operands);

            case 7:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_787 (insn, operands);

            case 8:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_776 (insn, operands);

            case 9:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_780 (insn, operands);

            case 10:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_784 (insn, operands);

            case 11:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_788 (insn, operands);

            case 12:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_777 (insn, operands);

            case 13:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_781 (insn, operands);

            case 14:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_785 (insn, operands);

            case 15:
              if (!
#line 10644 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_789 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      return split_20 (x1, insn);

    case FRACT_CONVERT:
      return split_9 (x1, insn);

    case UNSIGNED_FRACT_CONVERT:
      return split_8 (x1, insn);

    case SS_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern59 (x2))
        {
        case 0:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1775 (insn, operands);
          break;

        case 1:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1777 (insn, operands);
          break;

        case 2:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1779 (insn, operands);
          break;

        case 3:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1781 (insn, operands);
          break;

        case 4:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1783 (insn, operands);
          break;

        default:
          break;
        }
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      switch (pattern60 (x1))
        {
        case 0:
          if (!(
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1879 (insn, operands);

        case 1:
          if (!(
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1881 (insn, operands);

        case 2:
          if (!(
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1883 (insn, operands);

        case 3:
          if (!(
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1885 (insn, operands);

        case 4:
          if (!(
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1887 (insn, operands);

        case 5:
          if (!(
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1889 (insn, operands);

        default:
          return NULL;
        }

    case SS_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern59 (x2))
        {
        case 0:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1776 (insn, operands);
          break;

        case 1:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1778 (insn, operands);
          break;

        case 2:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1780 (insn, operands);
          break;

        case 3:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1782 (insn, operands);
          break;

        case 4:
          if (
#line 126 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1784 (insn, operands);
          break;

        default:
          break;
        }
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      switch (pattern60 (x1))
        {
        case 0:
          if (!(
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1880 (insn, operands);

        case 1:
          if (!(
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1882 (insn, operands);

        case 2:
          if (!(
#line 288 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1884 (insn, operands);

        case 3:
          if (!(
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1886 (insn, operands);

        case 4:
          if (!(
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1888 (insn, operands);

        case 5:
          if (!(
#line 309 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1890 (insn, operands);

        default:
          return NULL;
        }

    case US_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern61 (x2))
        {
        case 0:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1785 (insn, operands);
          break;

        case 1:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1787 (insn, operands);
          break;

        case 2:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1789 (insn, operands);
          break;

        case 3:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1791 (insn, operands);
          break;

        case 4:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1793 (insn, operands);
          break;

        default:
          break;
        }
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      switch (pattern62 (x1))
        {
        case 0:
          if (!(
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1891 (insn, operands);

        case 1:
          if (!(
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1893 (insn, operands);

        case 2:
          if (!(
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1895 (insn, operands);

        case 3:
          if (!(
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1897 (insn, operands);

        case 4:
          if (!(
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1899 (insn, operands);

        case 5:
          if (!(
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1901 (insn, operands);

        default:
          return NULL;
        }

    case US_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern61 (x2))
        {
        case 0:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1786 (insn, operands);
          break;

        case 1:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1788 (insn, operands);
          break;

        case 2:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1790 (insn, operands);
          break;

        case 3:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1792 (insn, operands);
          break;

        case 4:
          if (
#line 151 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1794 (insn, operands);
          break;

        default:
          break;
        }
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      switch (pattern62 (x1))
        {
        case 0:
          if (!(
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1892 (insn, operands);

        case 1:
          if (!(
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1894 (insn, operands);

        case 2:
          if (!(
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1896 (insn, operands);

        case 3:
          if (!(
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1898 (insn, operands);

        case 4:
          if (!(
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1900 (insn, operands);

        case 5:
          if (!(
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1902 (insn, operands);

        default:
          return NULL;
        }

    case SS_NEG:
      if (GET_MODE (x2) == E_QQmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_QQmode))
            {
              x7 = XEXP (x2, 0);
              operands[1] = x7;
              if (register_operand (operands[1], E_QQmode)
                  && 
#line 191 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return gen_split_1795 (insn, operands);
            }
        }
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 243 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1798 (insn, operands);

        case 1:
          if (!
#line 243 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1800 (insn, operands);

        case 2:
          if (!
#line 263 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1802 (insn, operands);

        case 3:
          if (!
#line 263 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1804 (insn, operands);

        default:
          return NULL;
        }

    case SS_ABS:
      if (GET_MODE (x2) == E_QQmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_QQmode))
            {
              x7 = XEXP (x2, 0);
              operands[1] = x7;
              if (register_operand (operands[1], E_QQmode)
                  && 
#line 209 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                return gen_split_1796 (insn, operands);
            }
        }
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 243 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1797 (insn, operands);

        case 1:
          if (!
#line 243 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1799 (insn, operands);

        case 2:
          if (!
#line 263 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1801 (insn, operands);

        case 3:
          if (!
#line 263 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1803 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
