/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!combine_pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x3) != E_QQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 0;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 1;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 2;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 3;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 4;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 5;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 6;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 7;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 8;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 9;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 10;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 11;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 12;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 13;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 14;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 15;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 16;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 17;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x3) != E_UQQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 19;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 20;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 21;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 22;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 23;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 24;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 25;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 26;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 27;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 28;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 29;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 30;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 31;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 32;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 33;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 34;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 35;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 36;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 38;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 39;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 40;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 41;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 42;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 43;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 44;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 45;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 46;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 47;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 48;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 49;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 50;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 51;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 52;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 53;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 54;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 55;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 57;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 58;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 59;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 60;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 61;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 62;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 63;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 64;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 65;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 66;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 67;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 68;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 69;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 70;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 71;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 72;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 73;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 74;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 75;

        default:
          return -1;
        }

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 76;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 77;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 78;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 79;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 80;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 81;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 82;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 83;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 84;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 85;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 86;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 87;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 88;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 89;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 90;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 91;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 92;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 93;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 95;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 96;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 97;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 98;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 99;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 100;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 101;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 102;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 103;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 104;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 105;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 106;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 107;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 108;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 109;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 110;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 111;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 112;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x3) != E_SQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 114;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 115;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 116;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 117;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 118;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 119;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 120;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 121;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 122;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 123;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 124;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 125;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 126;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 127;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 128;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 129;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 130;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 131;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 132;

        default:
          return -1;
        }

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x3) != E_USQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 133;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 134;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 135;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 136;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 137;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 138;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 139;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 140;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 141;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 142;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 143;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 144;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 145;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 146;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 147;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 148;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 149;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 150;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 151;

        default:
          return -1;
        }

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x3) != E_SAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 152;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 153;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 154;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 155;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 156;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 157;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 158;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 159;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 160;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 161;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 162;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 163;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 164;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 165;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 166;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 167;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 168;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 169;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 170;

        default:
          return -1;
        }

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x3) != E_USAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 171;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 172;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 173;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 174;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 175;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 176;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 177;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 178;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 179;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 180;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 181;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 182;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 183;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 184;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 185;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 186;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 187;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 188;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 189;

        default:
          return -1;
        }

    case E_DQmode:
      if (!register_operand (operands[0], E_DQmode)
          || GET_MODE (x3) != E_DQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 190;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 191;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 192;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 193;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 194;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 195;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 196;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 197;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 198;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 199;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 200;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 201;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 202;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 203;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 204;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 205;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 206;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 207;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 208;

        default:
          return -1;
        }

    case E_UDQmode:
      if (!register_operand (operands[0], E_UDQmode)
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 209;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 210;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 211;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 212;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 213;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 214;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 215;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 216;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 217;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 218;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 219;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 220;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 221;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 222;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 223;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 224;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 225;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 226;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 227;

        default:
          return -1;
        }

    case E_DAmode:
      if (!register_operand (operands[0], E_DAmode)
          || GET_MODE (x3) != E_DAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 228;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 229;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 230;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 231;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 232;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 233;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 234;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 235;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 236;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 237;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 238;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 239;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 240;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 241;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 242;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 243;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 244;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 245;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 246;

        default:
          return -1;
        }

    case E_UDAmode:
      if (!register_operand (operands[0], E_UDAmode)
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 247;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 248;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 249;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 250;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 251;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 252;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 253;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 254;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 255;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 256;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 257;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 258;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 259;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 260;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 261;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 262;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 263;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 264;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 265;

        default:
          return -1;
        }

    case E_TAmode:
      if (!register_operand (operands[0], E_TAmode)
          || GET_MODE (x3) != E_TAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 266;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 267;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 268;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 269;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 270;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 271;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 272;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 273;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 274;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 275;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 276;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 277;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 278;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 279;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 280;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 281;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 282;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 283;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 284;

        default:
          return -1;
        }

    case E_UTAmode:
      if (!register_operand (operands[0], E_UTAmode)
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 285;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 286;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 287;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 288;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 289;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 290;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 291;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 292;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 293;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 294;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 295;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 296;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 297;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 298;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 299;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 300;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 301;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 302;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 303;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 304;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 305;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 306;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 307;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 308;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 309;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 310;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 311;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 312;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 313;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 314;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 315;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 316;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 317;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 318;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 319;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 320;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 321;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 322;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 323;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 324;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 325;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 326;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 327;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 328;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 329;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 330;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 331;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 332;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 333;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 334;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 335;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 336;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 337;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 338;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 339;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 340;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 341;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 342;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 343;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 344;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 345;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 346;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 347;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 348;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 349;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 350;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 351;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 352;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 353;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 354;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 355;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 356;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 357;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 358;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 359;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 360;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 361;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 362;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 363;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 364;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 365;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 366;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 367;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 368;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 369;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 370;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 371;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 372;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 373;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 374;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 375;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 376;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 377;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 378;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 379;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern178 (x2, 
E_QImode) == 0)
            return 634; /* xorqi3 */
          break;

        case E_HImode:
          if (pnum_clobbers != NULL
              && pattern58 (x2, 
E_HImode) == 0)
            {
              *pnum_clobbers = 1;
              return 636; /* xorhi3 */
            }
          break;

        case E_PSImode:
          if (pattern50 (x2, pnum_clobbers, 
E_PSImode) == 0)
            {
              *pnum_clobbers = 1;
              return 638; /* xorpsi3 */
            }
          break;

        case E_SImode:
          if (pnum_clobbers != NULL
              && pattern58 (x2, 
E_SImode) == 0)
            {
              *pnum_clobbers = 1;
              return 640; /* xorsi3 */
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!register_operand (operands[2], E_QImode)
          || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      return 1087; /* *insv.xor1-bit.0_split */

    case LSHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern74 (x2))
        {
        case 0:
          if (!
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1092; /* *xorhi.lshiftrt */

        case 1:
          if (!
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1096; /* *xorpsi.lshiftrt */

        case 2:
          if (!
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1100; /* *xorsi.lshiftrt */

        case 3:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1116; /* *xorhiqi.lshiftrt */

        case 4:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1120; /* *xorpsiqi.lshiftrt */

        case 5:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1128; /* *xorpsihi.lshiftrt */

        case 6:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1124; /* *xorsiqi.lshiftrt */

        case 7:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1132; /* *xorsihi.lshiftrt */

        case 8:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1136; /* *xorsipsi.lshiftrt */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1094; /* *xorhi.ashift */

        case 1:
          if (!
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1098; /* *xorpsi.ashift */

        case 2:
          if (!
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1102; /* *xorsi.ashift */

        case 3:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1118; /* *xorhiqi.ashift */

        case 4:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1122; /* *xorpsiqi.ashift */

        case 5:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1130; /* *xorpsihi.ashift */

        case 6:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1126; /* *xorsiqi.ashift */

        case 7:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1134; /* *xorsihi.ashift */

        case 8:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1138; /* *xorsipsi.ashift */

        case 9:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1373; /* *shl.ext.and1-to-skip.hi */

        case 10:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1379; /* *shl.ext.and1-to-skip.psi */

        case 11:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1391; /* *shl.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1385; /* *shl.ext.and1-to-skip.si */

        case 13:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1397; /* *shl.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1403; /* *shl.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1372; /* *shl.ext.and1-to-skip.hi */

        case 16:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1378; /* *shl.ext.and1-to-skip.psi */

        case 17:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1390; /* *shl.ext.and1-to-skip.psi */

        case 18:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1384; /* *shl.ext.and1-to-skip.si */

        case 19:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1396; /* *shl.ext.and1-to-skip.si */

        case 20:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1402; /* *shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      switch (pattern3 (x2))
        {
        case 0:
          return 1104; /* *xorhiqi.0 */

        case 1:
          return 1106; /* *xorpsiqi.0 */

        case 2:
          return 1110; /* *xorpsihi.0 */

        case 3:
          return 1108; /* *xorsiqi.0 */

        case 4:
          return 1112; /* *xorsihi.0 */

        case 5:
          return 1114; /* *xorsipsi.0 */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x9 = XEXP (x3, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1274; /* *pixop-to-skip.qi */

            case 1:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1286; /* *pixop-to-skip.qi */

            case 2:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1298; /* *pixop-to-skip.qi */

            case 3:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1310; /* *pixop-to-skip.qi */

            case 4:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1277; /* *pixop-to-skip.hi */

            case 5:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1289; /* *pixop-to-skip.hi */

            case 6:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1301; /* *pixop-to-skip.hi */

            case 7:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1313; /* *pixop-to-skip.hi */

            case 8:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1280; /* *pixop-to-skip.psi */

            case 9:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1292; /* *pixop-to-skip.psi */

            case 10:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1304; /* *pixop-to-skip.psi */

            case 11:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1316; /* *pixop-to-skip.psi */

            case 12:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1283; /* *pixop-to-skip.si */

            case 13:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1295; /* *pixop-to-skip.si */

            case 14:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1307; /* *pixop-to-skip.si */

            case 15:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1319; /* *pixop-to-skip.si */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1406; /* *shl.and-to-skip.hi */

            case 1:
              if (!
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1409; /* *shl.and-to-skip.psi */

            case 2:
              if (!
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1412; /* *shl.and-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern80 (x2))
        {
        case 0:
          if (!
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1322; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1325; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1328; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1331; /* *mul.and1-to-skip.si */

        case 4:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1336; /* *mul.ext.and1-to-skip.hi */

        case 5:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1342; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1354; /* *mul.ext.and1-to-skip.psi */

        case 7:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1348; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1360; /* *mul.ext.and1-to-skip.si */

        case 9:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1366; /* *mul.ext.and1-to-skip.si */

        case 10:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1337; /* *mul.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1343; /* *mul.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1355; /* *mul.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1349; /* *mul.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1361; /* *mul.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1367; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern61 (x3))
    {
    case 0:
      return 3014; /* ussubuqq3 */

    case 1:
      return 3016; /* ussubuhq3 */

    case 2:
      return 3018; /* ussubuha3 */

    case 3:
      return 3020; /* ussubusa3 */

    case 4:
      return 3022; /* ussubusq3 */

    default:
      break;
    }
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern62 (x1))
    {
    case 0:
      if (
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3226; /* ussubudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3232; /* *ussubudq3_insn */

    case 1:
      if (
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3228; /* ussubuda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3234; /* *ussubuda3_insn */

    case 2:
      if (
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3230; /* ussubuta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3236; /* *ussubuta3_insn */

    case 3:
      if (
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3238; /* ussubudq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3244; /* *ussubudq3_const_insn */

    case 4:
      if (
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3240; /* ussubuda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3246; /* *ussubuda3_const_insn */

    case 5:
      if (
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3242; /* ussubuta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3248; /* *ussubuta3_const_insn */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x4, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (pattern310 (x1) != 0
          || !
#line 2473 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 480; /* mulqihi3 */

    case ZERO_EXTEND:
      if (pattern310 (x1) != 0
          || !
#line 2521 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 485; /* *sumulqihi3 */

    case CONST_INT:
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      if (s8_operand (operands[2], E_HImode)
          && 
#line 2989 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 521; /* *mulsqihi3.sconst */
      if (u8_operand (operands[2], E_HImode)
          && 
#line 3025 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 524; /* *mulsqihi3.uconst */
      if (!o8_operand (operands[2], E_HImode)
          || !
#line 3043 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 525; /* *mulsqihi3.oconst */

    case REG:
    case SUBREG:
      if (pattern212 (x1) != 0
          || !
#line 3157 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 532; /* *mulsqihi3 */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pattern156 (x1, 
E_HImode) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x8 = XEXP (x3, 1);
  switch (GET_CODE (x8))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 2546 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 487; /* *osmulqihi3 */

    case ZERO_EXTEND:
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 2570 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 489; /* *oumulqihi3 */

    case REG:
    case SUBREG:
      operands[2] = x8;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 3209 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 536; /* *muloqihi3 */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern224 (x1))
        {
        case 0:
          if (
#line 5777 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 708; /* *ashrqi3 */
          break;

        case 1:
          if (
#line 5777 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 709; /* *ashrqq3 */
          break;

        case 2:
          if (
#line 5777 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 710; /* *ashruqq3 */
          break;

        case 3:
          if (
#line 5809 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 716; /* *ashrhi3 */
          break;

        case 4:
          if (
#line 5809 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 717; /* *ashrhq3 */
          break;

        case 5:
          if (
#line 5809 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 718; /* *ashruhq3 */
          break;

        case 6:
          if (
#line 5809 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 719; /* *ashrha3 */
          break;

        case 7:
          if (
#line 5809 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 720; /* *ashruha3 */
          break;

        case 8:
          if (
#line 5869 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 728; /* *ashrsi3 */
          break;

        case 9:
          if (
#line 5869 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 729; /* *ashrsq3 */
          break;

        case 10:
          if (
#line 5869 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 730; /* *ashrusq3 */
          break;

        case 11:
          if (
#line 5869 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 731; /* *ashrsa3 */
          break;

        case 12:
          if (
#line 5869 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 732; /* *ashrusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      if (pattern103 (x3) != 0)
        return -1;
      return 721; /* ashrpsi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_SImode) != 0
          || !
#line 5905 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 738; /* *ashrsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_SQmode) != 0
          || !
#line 5905 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 739; /* *ashrsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_USQmode) != 0
          || !
#line 5905 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 740; /* *ashrusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_SAmode) != 0
          || !
#line 5905 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 741; /* *ashrsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_USAmode) != 0
          || !
#line 5905 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 742; /* *ashrusa3_const */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[0] = x5;
      res = recog_51 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 18)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER
          || GET_MODE (x3) != E_CCmode
          || GET_MODE (x4) != E_CCmode)
        return -1;
      x7 = XEXP (x4, 1);
      operands[0] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      switch (GET_MODE (x5))
        {
        case E_DImode:
          if (!const_operand (operands[0], E_DImode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3274; /* compare_const_di2 */

        case E_DQmode:
          if (!const_operand (operands[0], E_DQmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3275; /* compare_const_dq2 */

        case E_UDQmode:
          if (!const_operand (operands[0], E_UDQmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3276; /* compare_const_udq2 */

        case E_DAmode:
          if (!const_operand (operands[0], E_DAmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3277; /* compare_const_da2 */

        case E_UDAmode:
          if (!const_operand (operands[0], E_UDAmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3278; /* compare_const_uda2 */

        case E_TAmode:
          if (!const_operand (operands[0], E_TAmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3279; /* compare_const_ta2 */

        case E_UTAmode:
          if (!const_operand (operands[0], E_UTAmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3280; /* compare_const_uta2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != SCRATCH
              || GET_MODE (x8) != E_QImode
              || GET_MODE (x3) != E_CCmode
              || GET_MODE (x4) != E_CCmode)
            return -1;
          switch (pattern311 (x5))
            {
            case 0:
              if (!
#line 6903 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 875; /* *cmphi_lsr */

            case 1:
              if (!
#line 6903 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 876; /* *cmppsi_lsr */

            case 2:
              if (!
#line 6903 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 877; /* *cmpsi_lsr */

            default:
              return -1;
            }

        case SET:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != LSHIFTRT
              || GET_MODE (x9) != E_QImode
              || GET_MODE (x3) != E_CCZNmode
              || GET_MODE (x4) != E_CCZNmode
              || GET_MODE (x5) != E_QImode
              || pattern320 (x1) != 0
              || !
#line 7601 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 947; /* *op8.for.cczn.lshiftrt */

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != PLUS)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      switch (GET_MODE (x3))
        {
        case E_CCZNmode:
          if (GET_MODE (x4) != E_CCZNmode)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern327 (x1, pnum_clobbers, 
E_HImode) != 0
                  || !
#line 7329 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 916; /* *add.for.cczn.hi */

            case E_PSImode:
              if (pattern327 (x1, pnum_clobbers, 
E_PSImode) != 0
                  || !
#line 7329 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 917; /* *add.for.cczn.psi */

            case E_SImode:
              if (pattern327 (x1, pnum_clobbers, 
E_SImode) != 0
                  || !
#line 7329 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 918; /* *add.for.cczn.si */

            case E_QImode:
              if (!register_operand (operands[3], E_QImode))
                return -1;
              x11 = XEXP (x5, 1);
              operands[4] = x11;
              if (!nonmemory_operand (operands[4], E_QImode)
                  || !register_operand (operands[0], E_QImode)
                  || GET_MODE (x9) != E_QImode)
                return -1;
              x12 = XEXP (x9, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              x13 = XEXP (x9, 1);
              operands[2] = x13;
              if (!nonmemory_operand (operands[2], E_QImode)
                  || !
#line 7601 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 940; /* *op8.for.cczn.plus */

            default:
              return -1;
            }

        case E_CCNmode:
          if (pnum_clobbers == NULL
              || GET_MODE (x4) != E_CCNmode)
            return -1;
          x11 = XEXP (x5, 1);
          operands[1] = x11;
          x12 = XEXP (x9, 0);
          operands[4] = x12;
          x13 = XEXP (x9, 1);
          operands[5] = x13;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern352 (x9, 
E_HImode) != 0
                  || !
#line 7348 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 919; /* *add.for.ccn.hi */

            case E_PSImode:
              if (pattern352 (x9, 
E_PSImode) != 0
                  || !
#line 7348 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 920; /* *add.for.ccn.psi */

            case E_SImode:
              if (pattern352 (x9, 
E_SImode) != 0
                  || !
#line 7348 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 921; /* *add.for.ccn.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != MINUS
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      x11 = XEXP (x5, 1);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[4] = x11;
          x13 = XEXP (x9, 1);
          operands[2] = x13;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern353 (x9, 
E_HImode) != 0
                  || !
#line 7464 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 922; /* *sub.for.cczn.hi */

            case E_PSImode:
              if (pattern353 (x9, 
E_PSImode) != 0
                  || !
#line 7464 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 923; /* *sub.for.cczn.psi */

            case E_SImode:
              if (pattern353 (x9, 
E_SImode) != 0
                  || !
#line 7464 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 924; /* *sub.for.cczn.si */

            case E_QImode:
              if (pattern353 (x9, 
E_QImode) != 0
                  || !
#line 7601 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 941; /* *op8.for.cczn.minus */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern339 (x1, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 7480 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return -1;
              return 925; /* *sub-extendqi.for.cczn.hi */

            case 1:
              if (!
#line 7480 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return -1;
              return 927; /* *sub-extendqi.for.cczn.psi */

            case 2:
              if (!
#line 7480 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return -1;
              return 931; /* *sub-extendhi.for.cczn.psi */

            case 3:
              if (!
#line 7480 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return -1;
              return 929; /* *sub-extendqi.for.cczn.si */

            case 4:
              if (!
#line 7480 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return -1;
              return 933; /* *sub-extendhi.for.cczn.si */

            case 5:
              if (!
#line 7480 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return -1;
              return 935; /* *sub-extendpsi.for.cczn.si */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern339 (x1, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 7480 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return -1;
              return 926; /* *sub-extendqi.for.cczn.hi */

            case 1:
              if (!
#line 7480 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return -1;
              return 928; /* *sub-extendqi.for.cczn.psi */

            case 2:
              if (!
#line 7480 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return -1;
              return 932; /* *sub-extendhi.for.cczn.psi */

            case 3:
              if (!
#line 7480 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return -1;
              return 930; /* *sub-extendqi.for.cczn.si */

            case 4:
              if (!
#line 7480 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return -1;
              return 934; /* *sub-extendhi.for.cczn.si */

            case 5:
              if (!
#line 7480 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return -1;
              return 936; /* *sub-extendpsi.for.cczn.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x11 = XEXP (x5, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != ASHIFT)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (XWINT (x11, 0) == 1L)
        {
          res = recog_52 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!register_operand (operands[1], E_QImode)
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode
          || GET_MODE (x5) != E_QImode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      operands[4] = x11;
      if (!const_1_to_3_operand (operands[4], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x9) != E_QImode)
        return -1;
      x13 = XEXP (x9, 1);
      operands[2] = x13;
      if (!const_1_to_3_operand (operands[2], E_QImode)
          || !
#line 7601 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 945; /* *op8.for.cczn.ashift */

    case AND:
      if (pattern195 (x1, 
AND) != 0
          || !
#line 7601 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 942; /* *op8.for.cczn.and */

    case IOR:
      if (pattern195 (x1, 
IOR) != 0
          || !
#line 7601 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 943; /* *op8.for.cczn.ior */

    case XOR:
      if (pattern196 (x1, 
XOR) != 0
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[4] = x11;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x9 = XEXP (x6, 1);
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x13 = XEXP (x9, 1);
      operands[2] = x13;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 7601 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 944; /* *op8.for.cczn.xor */

    case ASHIFTRT:
      if (pattern196 (x1, 
ASHIFTRT) != 0
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode
          || pattern320 (x1) != 0
          || !
#line 7601 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 946; /* *op8.for.cczn.ashiftrt */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x4, 0);
  operands[3] = x10;
  x11 = XEXP (x4, 1);
  operands[1] = x11;
  x12 = XEXP (x7, 0);
  operands[0] = x12;
  x13 = XEXP (x8, 0);
  operands[4] = x13;
  x14 = XEXP (x8, 1);
  operands[5] = x14;
  x15 = XEXP (x9, 0);
  operands[2] = x15;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x6))
    {
    case E_CCZNmode:
      if (GET_MODE (x3) != E_CCZNmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (pattern368 (x8, 
E_HImode) != 0
              || !
#line 7329 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 916; /* *add.for.cczn.hi */

        case E_PSImode:
          if (pattern368 (x8, 
E_PSImode) != 0
              || !
#line 7329 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 917; /* *add.for.cczn.psi */

        case E_SImode:
          if (pattern368 (x8, 
E_SImode) != 0
              || !
#line 7329 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 918; /* *add.for.cczn.si */

        default:
          return -1;
        }

    case E_CCNmode:
      if (GET_MODE (x3) != E_CCNmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (pattern352 (x8, 
E_HImode) != 0
              || !
#line 7348 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 919; /* *add.for.ccn.hi */

        case E_PSImode:
          if (pattern352 (x8, 
E_PSImode) != 0
              || !
#line 7348 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 920; /* *add.for.ccn.psi */

        case E_SImode:
          if (pattern352 (x8, 
E_SImode) != 0
              || !
#line 7348 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 921; /* *add.for.ccn.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 23
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != UNSPEC
      || XVECLEN (x9, 0) != 1
      || XINT (x9, 1) != 1)
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 24
      || pattern27 (x1) != 0)
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 24
      || GET_MODE (x13) != E_HImode)
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  if (pattern374 (x14, 
E_QImode, 
23) != 0)
    return -1;
  x15 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x15) != CLOBBER)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != MEM
      || GET_MODE (x16) != E_QImode)
    return -1;
  x17 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x17) != CLOBBER)
    return -1;
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != REG
      || REGNO (x18) != 36
      || GET_MODE (x18) != E_CCmode)
    return -1;
  x19 = XVECEXP (x9, 0, 0);
  operands[0] = x19;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x20 = XEXP (x16, 0);
  operands[1] = x20;
  if (!io_address_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x11))
    {
    case E_QImode:
      if (!
#line 1407 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 166; /* *cpymemx_qi */

    case E_HImode:
      if (!
#line 1407 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 167; /* *cpymemx_hi */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_90 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_73 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_78 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_85 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 7:
          res = recog_86 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          if (pattern28 (x1) == 0)
            {
              x2 = XVECEXP (x1, 0, 7);
              if (pattern374 (x2, 
E_CCmode, 
36) == 0)
                {
                  switch (pattern373 (x1))
                    {
                    case 0:
                      if (
#line 1342 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return 162; /* *cpymem_qi */
                      break;

                    case 1:
                      if (
#line 1342 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return 163; /* *cpymem_hi */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        case 9:
          switch (pattern29 (x1))
            {
            case 0:
              return 164; /* cpymemx_qi */

            case 1:
              return 165; /* cpymemx_hi */

            default:
              break;
            }
          break;

        case 10:
          res = recog_87 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_88 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_89 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 6)
        return -1;
      operands[0] = x1;
      if (!set_some_operation (operands[0], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != USE)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE
          || pattern164 (x1, 
USE) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!dreg_or_0_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[4] = x11;
      if (!const_int_operand (operands[4], E_QImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[5] = x12;
      if (!register_operand (operands[5], E_QImode))
        return -1;
      x13 = XEXP (x5, 1);
      operands[6] = x13;
      if (!const_int_operand (operands[6], E_QImode)
          || !
#line 1220 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 156; /* set_some */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 972; /* nop */

    case RETURN:
      if (
#line 8676 "../../gcc/config/avr/avr.md"
(reload_completed && avr_simple_epilogue ()))
        return 999; /* return */
      if (
#line 8682 "../../gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && !(cfun->machine->is_interrupt || cfun->machine->is_signal)
   && !cfun->machine->is_naked))
        return 1000; /* return_from_epilogue */
      if (
#line 8691 "../../gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && (cfun->machine->is_interrupt || cfun->machine->is_signal)
   && !cfun->machine->is_naked))
        return 1001; /* return_from_interrupt_epilogue */
      if (!
#line 8700 "../../gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && cfun->machine->is_naked))
        return -1;
      return 1002; /* return_from_naked_epilogue */

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_HImode))
    return NULL;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return NULL;
  x5 = XEXP (x3, 1);
  switch (pattern268 (x5))
    {
    case 0:
      if (!(
#line 2460 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2462 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_271 (insn, operands);

    case 1:
      if (!(
#line 2508 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2510 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_274 (insn, operands);

    case 2:
      if (!(
#line 3144 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3146 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_307 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern180 (x2) != 0
              || !(
#line 2460 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2462 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_272 (insn, operands);

        case E_PSImode:
          switch (pattern181 (x2))
            {
            case 0:
              if (!(
#line 4103 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4105 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_353 (insn, operands);

            case 1:
              if (!(
#line 4130 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4132 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_354 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_QImode)
          || !(
#line 2483 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2485 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_273 (insn, operands);

    case REG:
    case SUBREG:
      operands[2] = x3;
      if (!register_operand (operands[2], E_HImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 3169 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3171 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_308 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern83 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern247 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (register_operand (operands[1], E_QImode)
                  && nonmemory_operand (operands[2], E_QImode)
                  && 
#line 6989 "../../gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_569 (insn, operands);
              break;

            case E_QQmode:
              if (register_operand (operands[1], E_QQmode)
                  && nonmemory_operand (operands[2], E_QQmode)
                  && 
#line 6989 "../../gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_570 (insn, operands);
              break;

            case E_UQQmode:
              if (register_operand (operands[1], E_UQQmode)
                  && nonmemory_operand (operands[2], E_UQQmode)
                  && 
#line 6989 "../../gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_571 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case 1:
          if ((
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7125 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_595 (insn, operands);
          break;

        case 2:
          if ((
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7125 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_597 (insn, operands);
          break;

        case 3:
          if ((
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7125 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_601 (insn, operands);
          break;

        case 4:
          if ((
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7125 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_599 (insn, operands);
          break;

        case 5:
          if ((
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7125 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_603 (insn, operands);
          break;

        case 6:
          if ((
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7125 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_605 (insn, operands);
          break;

        case 7:
          if ((
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7125 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_596 (insn, operands);
          break;

        case 8:
          if ((
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7125 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_598 (insn, operands);
          break;

        case 9:
          if ((
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7125 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_602 (insn, operands);
          break;

        case 10:
          if ((
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7125 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_600 (insn, operands);
          break;

        case 11:
          if ((
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7125 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_604 (insn, operands);
          break;

        case 12:
          if ((
#line 7122 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7125 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_606 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 18)
        return NULL;
      x5 = XEXP (x2, 1);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 10)
            return NULL;
          switch (pattern317 (x3))
            {
            case 0:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1904 (insn, operands);

            case 1:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1905 (insn, operands);

            case 2:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1906 (insn, operands);

            case 3:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1907 (insn, operands);

            case 4:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1908 (insn, operands);

            case 5:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1909 (insn, operands);

            case 6:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1910 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern284 (x3) != 0
              || !(
#line 529 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 531 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1911 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x2 = XEXP (x1, 1);
      switch (pattern219 (x2))
        {
        case 0:
          if (!(
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7094 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_583 (insn, operands);

        case 1:
          if (!(
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7094 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_585 (insn, operands);

        case 2:
          if (!(
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7094 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_589 (insn, operands);

        case 3:
          if (!(
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7094 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_587 (insn, operands);

        case 4:
          if (!(
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7094 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_591 (insn, operands);

        case 5:
          if (!(
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7094 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_593 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x2 = XEXP (x1, 1);
      switch (pattern219 (x2))
        {
        case 0:
          if (!(
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7094 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_584 (insn, operands);

        case 1:
          if (!(
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7094 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_586 (insn, operands);

        case 2:
          if (!(
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7094 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_590 (insn, operands);

        case 3:
          if (!(
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7094 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_588 (insn, operands);

        case 4:
          if (!(
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7094 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_592 (insn, operands);

        case 5:
          if (!(
#line 7091 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7094 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_594 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      if (!register_operand (x3, E_QImode)
          || GET_MODE (x2) != E_QImode)
        return NULL;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode))
            return NULL;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          operands[1] = x3;
          if (!
#line 4751 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_375 (insn, operands);

        case CONST_INT:
          if (XWINT (x4, 0) != 1L)
            return NULL;
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) != ZERO_EXTRACT
              || GET_MODE (x5) != E_QImode)
            return NULL;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          x8 = XEXP (x5, 2);
          operands[1] = x8;
          if (!const_0_to_7_operand (operands[1], E_QImode))
            return NULL;
          operands[2] = x3;
          if (!
#line 10081 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_662 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern74 (x2))
        {
        case 0:
          if (!(
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10149 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_667 (insn, operands);

        case 1:
          if (!(
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10149 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_671 (insn, operands);

        case 2:
          if (!(
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10149 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_675 (insn, operands);

        case 3:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_691 (insn, operands);

        case 4:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_695 (insn, operands);

        case 5:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_703 (insn, operands);

        case 6:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_699 (insn, operands);

        case 7:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_707 (insn, operands);

        case 8:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_711 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern45 (x1))
        {
        case 0:
          if (!(
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10149 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_669 (insn, operands);

        case 1:
          if (!(
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10149 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_673 (insn, operands);

        case 2:
          if (!(
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10149 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_677 (insn, operands);

        case 3:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_693 (insn, operands);

        case 4:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_697 (insn, operands);

        case 5:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_705 (insn, operands);

        case 6:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_701 (insn, operands);

        case 7:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_709 (insn, operands);

        case 8:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_713 (insn, operands);

        case 9:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_915 (insn, operands);

        case 10:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_921 (insn, operands);

        case 11:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_933 (insn, operands);

        case 12:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_927 (insn, operands);

        case 13:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_939 (insn, operands);

        case 14:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_945 (insn, operands);

        case 15:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_914 (insn, operands);

        case 16:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_920 (insn, operands);

        case 17:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_932 (insn, operands);

        case 18:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_926 (insn, operands);

        case 19:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_938 (insn, operands);

        case 20:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_944 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      switch (pattern3 (x2))
        {
        case 0:
          if (!(
#line 10170 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 10172 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_679 (insn, operands);

        case 1:
          if (!(
#line 10170 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 10172 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_681 (insn, operands);

        case 2:
          if (!(
#line 10170 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 10172 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_685 (insn, operands);

        case 3:
          if (!(
#line 10170 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 10172 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_683 (insn, operands);

        case 4:
          if (!(
#line 10170 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 10172 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_687 (insn, operands);

        case 5:
          if (!(
#line 10170 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 10172 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_689 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x9 = XEXP (x3, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_816 (insn, operands);

            case 1:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_828 (insn, operands);

            case 2:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_840 (insn, operands);

            case 3:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_852 (insn, operands);

            case 4:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_819 (insn, operands);

            case 5:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_831 (insn, operands);

            case 6:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_843 (insn, operands);

            case 7:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_855 (insn, operands);

            case 8:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_822 (insn, operands);

            case 9:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_834 (insn, operands);

            case 10:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_846 (insn, operands);

            case 11:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_858 (insn, operands);

            case 12:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_825 (insn, operands);

            case 13:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_837 (insn, operands);

            case 14:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_849 (insn, operands);

            case 15:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_861 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!(
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10813 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_948 (insn, operands);

            case 1:
              if (!(
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10813 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_951 (insn, operands);

            case 2:
              if (!(
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10813 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_954 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern80 (x2))
        {
        case 0:
          if (!(
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_864 (insn, operands);

        case 1:
          if (!(
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_867 (insn, operands);

        case 2:
          if (!(
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_870 (insn, operands);

        case 3:
          if (!(
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_873 (insn, operands);

        case 4:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_878 (insn, operands);

        case 5:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_884 (insn, operands);

        case 6:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_896 (insn, operands);

        case 7:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_890 (insn, operands);

        case 8:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_902 (insn, operands);

        case 9:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_908 (insn, operands);

        case 10:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_879 (insn, operands);

        case 11:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_885 (insn, operands);

        case 12:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_897 (insn, operands);

        case 13:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_891 (insn, operands);

        case 14:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_903 (insn, operands);

        case 15:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_909 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT)
    {
      x5 = XEXP (x3, 0);
      if (rtx_equal_p (x5, operands[0]))
        {
          switch (XWINT (x4, 0))
            {
            case 4L:
              switch (pattern165 (x3))
                {
                case 0:
                  return gen_split_517 (insn, operands);

                case 1:
                  return gen_split_518 (insn, operands);

                case 2:
                  return gen_split_519 (insn, operands);

                default:
                  break;
                }
              break;

            case 5L:
              switch (pattern165 (x3))
                {
                case 0:
                  return gen_split_520 (insn, operands);

                case 1:
                  return gen_split_521 (insn, operands);

                case 2:
                  return gen_split_522 (insn, operands);

                default:
                  break;
                }
              break;

            case 6L:
              if (d_register_operand (operands[0], E_QImode)
                  && GET_MODE (x3) == E_QImode)
                return gen_split_523 (insn, operands);
              break;

            default:
              break;
            }
        }
    }
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  operands[2] = x4;
  switch (pattern142 (x3))
    {
    case 0:
      if (
#line 5971 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_524 (insn, operands);
      break;

    case 1:
      if (
#line 5971 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_525 (insn, operands);
      break;

    case 2:
      if (
#line 5971 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_526 (insn, operands);
      break;

    case 3:
      if (
#line 5997 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_527 (insn, operands);
      break;

    case 4:
      if (
#line 5997 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_528 (insn, operands);
      break;

    case 5:
      if (
#line 5997 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_529 (insn, operands);
      break;

    case 6:
      if (
#line 5997 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_530 (insn, operands);
      break;

    case 7:
      if (
#line 5997 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_531 (insn, operands);
      break;

    case 8:
      if (
#line 6056 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_533 (insn, operands);
      break;

    case 9:
      if (
#line 6056 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_534 (insn, operands);
      break;

    case 10:
      if (
#line 6056 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_535 (insn, operands);
      break;

    case 11:
      if (
#line 6056 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_536 (insn, operands);
      break;

    case 12:
      if (
#line 6056 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_537 (insn, operands);
      break;

    default:
      break;
    }
  if (reg_or_low_io_operand (operands[1], E_QImode)
      && x4 == const_int_rtx[MAX_SAVED_CONST_INT + 7]
      && register_operand (operands[0], E_QImode)
      && GET_MODE (x3) == E_QImode
      && (
#line 10555 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10557 "../../gcc/config/avr/avr.md"
( 1)))
    return gen_split_751 (insn, operands);
  if (GET_CODE (x5) != REG)
    return NULL;
  switch (pattern53 (x1))
    {
    case 0:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1921 (insn, operands);

    case 1:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1925 (insn, operands);

    case 2:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1929 (insn, operands);

    case 3:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1933 (insn, operands);

    case 4:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1937 (insn, operands);

    case 5:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1941 (insn, operands);

    case 6:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1945 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_QImode))
    return NULL;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern295 (x6, 
E_HImode) != 0
              || !
#line 1902 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_114 (insn, operands);

        case E_HQmode:
          if (pattern295 (x6, 
E_HQmode) != 0
              || !
#line 1902 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_115 (insn, operands);

        case E_UHQmode:
          if (pattern295 (x6, 
E_UHQmode) != 0
              || !
#line 1902 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_116 (insn, operands);

        case E_HAmode:
          if (pattern295 (x6, 
E_HAmode) != 0
              || !
#line 1902 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_117 (insn, operands);

        case E_UHAmode:
          if (pattern295 (x6, 
E_UHAmode) != 0
              || !
#line 1902 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_118 (insn, operands);

        case E_SImode:
          if (pattern99 (x6, 
E_SImode) != 0
              || !
#line 1936 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_119 (insn, operands);

        case E_SQmode:
          if (pattern99 (x6, 
E_SQmode) != 0
              || !
#line 1936 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_120 (insn, operands);

        case E_USQmode:
          if (pattern99 (x6, 
E_USQmode) != 0
              || !
#line 1936 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_121 (insn, operands);

        case E_SAmode:
          if (pattern99 (x6, 
E_SAmode) != 0
              || !
#line 1936 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_122 (insn, operands);

        case E_USAmode:
          if (pattern99 (x6, 
E_USAmode) != 0
              || !
#line 1936 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_123 (insn, operands);

        case E_PSImode:
          if (pattern99 (x6, 
E_PSImode) != 0
              || !
#line 2046 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_147 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      operands[4] = x5;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          if (pattern220 (x6) != 0
              || !const_int_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_QImode)
              || !(
#line 2640 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2642 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_279 (insn, operands);

        case SIGN_EXTEND:
          if (pattern221 (x6) != 0)
            return NULL;
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2850 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2852 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_290 (insn, operands);
          if (!u8_operand (operands[2], E_HImode)
              || !(
#line 2942 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)) && 
#line 2945 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_296 (insn, operands);

        case ZERO_EXTEND:
          if (GET_MODE (x10) != E_HImode
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode
              || GET_MODE (x7) != E_HImode)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_QImode)
              || !u8_operand (operands[2], E_HImode)
              || !register_operand (operands[3], E_HImode)
              || !(
#line 2850 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2852 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_291 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_33 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_31 (x1, insn);

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case SUBREG:
            case MEM:
              switch (pattern159 (x1))
                {
                case 0:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_32 (insn, operands);

                case 1:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_33 (insn, operands);

                case 2:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_34 (insn, operands);

                case 3:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_35 (insn, operands);

                case 4:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_36 (insn, operands);

                case 5:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_37 (insn, operands);

                case 6:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_38 (insn, operands);

                case 7:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_39 (insn, operands);

                case 8:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_40 (insn, operands);

                case 9:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_41 (insn, operands);

                case 10:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_42 (insn, operands);

                case 11:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_43 (insn, operands);

                case 12:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_44 (insn, operands);

                case 13:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_45 (insn, operands);

                case 14:
                  if (!(
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_46 (insn, operands);

                default:
                  return NULL;
                }

            case MULT:
              if (GET_MODE (x5) == E_SImode)
                {
                  res = split_28 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != REG
                  || pattern139 (x2) != 0
                  || pattern160 (x1) != 0)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_MODE (x7) != E_HImode)
                return NULL;
              switch (pattern348 (x1))
                {
                case 0:
                  if (!(
#line 3726 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY) && 
#line 3730 "../../gcc/config/avr/avr.md"
( reload_completed)))
                    return NULL;
                  return gen_split_336 (insn, operands);

                case 1:
                  if (!(
#line 4244 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4246 "../../gcc/config/avr/avr.md"
( reload_completed)))
                    return NULL;
                  return gen_split_358 (insn, operands);

                default:
                  return NULL;
                }

            case DIV:
              x8 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x8) != SET)
                return NULL;
              x9 = XEXP (x8, 1);
              if (GET_CODE (x9) != MOD)
                return NULL;
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != REG)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG)
                return NULL;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) == REG)
                {
                  res = split_29 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              if (REGNO (x7) != 26
                  || GET_MODE (x7) != E_QImode
                  || REGNO (x10) != 18
                  || GET_MODE (x10) != E_DImode
                  || pattern324 (x1) != 0)
                return NULL;
              return gen_split_359 (insn, operands);

            case UDIV:
              x8 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x8) != SET)
                return NULL;
              x9 = XEXP (x8, 1);
              if (GET_CODE (x9) != UMOD)
                return NULL;
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != REG)
                return NULL;
              if (REGNO (x10) == 26
                  && GET_MODE (x10) == E_HImode)
                {
                  x6 = XEXP (x5, 0);
                  if (GET_CODE (x6) == REG
                      && pattern282 (x1) == 0)
                    {
                      x7 = XEXP (x4, 0);
                      if (GET_CODE (x7) == REG)
                        {
                          switch (REGNO (x6))
                            {
                            case 24:
                              if (pattern359 (x1, 
E_HImode, 
E_QImode, 
21, 
24, 
22) == 0
                                  && 
#line 4052 "../../gcc/config/avr/avr.md"
( reload_completed))
                                return gen_split_352 (insn, operands);
                              break;

                            case 22:
                              if (pattern359 (x1, 
E_SImode, 
E_HImode, 
30, 
22, 
18) == 0
                                  && 
#line 4451 "../../gcc/config/avr/avr.md"
( reload_completed))
                                return gen_split_366 (insn, operands);
                              break;

                            default:
                              break;
                            }
                        }
                    }
                }
              if (REGNO (x10) != 18
                  || GET_MODE (x10) != E_DImode)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 26
                  || GET_MODE (x7) != E_QImode
                  || pattern324 (x1) != 0)
                return NULL;
              return gen_split_361 (insn, operands);

            case UNSPEC:
              if (pattern110 (x1) != 0)
                return NULL;
              x7 = XEXP (x4, 0);
              if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x11 = XVECEXP (x5, 0, 0);
                  operands[0] = x11;
                  if (register_operand (operands[0], E_HImode))
                    {
                      x8 = XVECEXP (x1, 0, 1);
                      x12 = XEXP (x8, 0);
                      x13 = XEXP (x12, 0);
                      operands[1] = x13;
                      x10 = XEXP (x3, 0);
                      operands[2] = x10;
                      if (scratch_operand (operands[2], E_HImode)
                          && (
#line 7924 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL) && 
#line 7926 "../../gcc/config/avr/avr.md"
( reload_completed)))
                        return gen_split_616 (insn, operands);
                    }
                }
              x11 = XVECEXP (x5, 0, 0);
              if (GET_CODE (x11) != REG
                  || pattern313 (x1) != 0
                  || !(
#line 7960 "../../gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL) && 
#line 7962 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_617 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          return split_32 (x1, insn);

        case 7:
          if (pattern28 (x1) != 0)
            return NULL;
          switch (pattern373 (x1))
            {
            case 0:
              if (!
#line 1319 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_92 (insn, operands);

            case 1:
              if (!
#line 1319 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_93 (insn, operands);

            default:
              return NULL;
            }

        case 9:
          switch (pattern29 (x1))
            {
            case 0:
              if (!
#line 1375 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_94 (insn, operands);

            case 1:
              if (!
#line 1375 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_95 (insn, operands);

            default:
              return NULL;
            }

        case 5:
          x4 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x14 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x14) != CLOBBER)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x5 = XEXP (x2, 1);
              switch (GET_CODE (x5))
                {
                case CONST_INT:
                  if (XWINT (x5, 0) != 0L
                      || pattern161 (x1) != 0)
                    return NULL;
                  switch (pattern276 (x1))
                    {
                    case 0:
                      if (!
#line 1454 "../../gcc/config/avr/avr.md"
( reload_completed))
                        return NULL;
                      return gen_split_96 (insn, operands);

                    case 1:
                      if (!
#line 1485 "../../gcc/config/avr/avr.md"
( reload_completed))
                        return NULL;
                      return gen_split_97 (insn, operands);

                    default:
                      return NULL;
                    }

                case DIV:
                  if (pattern174 (x1, 
MOD) != 0
                      || !
#line 4304 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_360 (insn, operands);

                case UDIV:
                  if (pattern174 (x1, 
UMOD) != 0
                      || !
#line 4353 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_362 (insn, operands);

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (pattern146 (x1, 
3) != 0
                  || pattern237 (x1) != 0
                  || !
#line 8811 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_626 (insn, operands);

            default:
              return NULL;
            }

        case 6:
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x14 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x14) != CLOBBER)
            return NULL;
          x15 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x15) != CLOBBER)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != REG)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG)
                return NULL;
              x16 = XEXP (x14, 0);
              if (GET_CODE (x16) != REG)
                return NULL;
              x17 = XEXP (x15, 0);
              if (GET_CODE (x17) != REG)
                return NULL;
              x18 = XEXP (x2, 0);
              operands[0] = x18;
              x12 = XEXP (x8, 0);
              operands[3] = x12;
              x5 = XEXP (x2, 1);
              switch (GET_CODE (x5))
                {
                case DIV:
                  switch (pattern332 (x1, 
MOD))
                    {
                    case 0:
                      return gen_split_345 (insn, operands);

                    case 1:
                      return gen_split_349 (insn, operands);

                    case 2:
                      return gen_split_363 (insn, operands);

                    default:
                      return NULL;
                    }

                case UDIV:
                  switch (pattern332 (x1, 
UMOD))
                    {
                    case 0:
                      return gen_split_347 (insn, operands);

                    case 1:
                      return gen_split_351 (insn, operands);

                    case 2:
                      return gen_split_365 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x2, 0) != 2
                  || XINT (x2, 1) != 10)
                return NULL;
              x19 = XVECEXP (x2, 0, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
                return NULL;
              x9 = XEXP (x8, 1);
              if (pattern94 (x9) != 0
                  || pattern333 (x1) != 0
                  || !
#line 8854 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_627 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      res = peephole2_1 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      if (peep2_current_count < 2
          || x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern197 (x1) != 0)
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (pattern304 (x5, 
E_QImode, 
IOR) != 0)
        return NULL;
      x6 = XVECEXP (x5, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x9 = XEXP (x7, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return NULL;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_308 (insn, operands);

    case REG:
      return peephole2_5 (x1, insn, pmatch_len_);

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
      x11 = XEXP (x3, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 36
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x12 = XEXP (x2, 0);
      operands[0] = x12;
      switch (GET_CODE (x4))
        {
        case AND:
          res = peephole2_2 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case ASHIFT:
          x13 = XEXP (x4, 1);
          switch (GET_CODE (x13))
            {
            case REG:
            case SUBREG:
              operands[1] = x13;
              if (register_operand (operands[1], E_QImode)
                  && register_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode)
                {
                  x14 = XEXP (x4, 0);
                  if (rtx_equal_p (x14, operands[0]))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_85 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case CONST_INT:
              x14 = XEXP (x4, 0);
              if (rtx_equal_p (x14, operands[0]))
                {
                  switch (XWINT (x13, 0))
                    {
                    case 4L:
                      switch (pattern316 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_86 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_87 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_88 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 5L:
                      switch (pattern316 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_89 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_90 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_91 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 6L:
                      switch (pattern316 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_92 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_93 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_94 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    default:
                      break;
                    }
                }
              operands[2] = x13;
              switch (pattern306 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_97 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_100 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_103 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_106 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_109 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_112 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_115 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_118 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_121 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_124 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case LSHIFTRT:
          x13 = XEXP (x4, 1);
          if (GET_CODE (x13) == CONST_INT)
            {
              operands[2] = x13;
              switch (pattern306 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_95 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_98 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_101 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_104 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_107 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_110 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_113 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_116 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_119 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_122 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
              x14 = XEXP (x4, 0);
              if (rtx_equal_p (x14, operands[0]))
                {
                  switch (XWINT (x13, 0))
                    {
                    case 4L:
                      switch (pattern316 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_125 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_126 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_127 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 5L:
                      switch (pattern316 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_128 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_129 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_130 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 6L:
                      switch (pattern316 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_131 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_132 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_133 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        case ASHIFTRT:
          x14 = XEXP (x4, 0);
          operands[1] = x14;
          x13 = XEXP (x4, 1);
          operands[2] = x13;
          if (const_int_operand (operands[2], E_QImode))
            {
              switch (pattern305 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_96 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_99 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_102 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_105 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_108 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_111 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_114 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_117 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_120 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_123 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
            }
          break;

        case PLUS:
          res = peephole2_3 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case MINUS:
          res = peephole2_4 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (peep2_current_count < 2
          || peep2_current_count < 3
          || !register_operand (operands[0], E_QImode))
        return NULL;
      operands[2] = x4;
      if (!op8_ZN_operator (operands[2], E_QImode))
        return NULL;
      x13 = XEXP (x4, 1);
      operands[1] = x13;
      x14 = XEXP (x4, 0);
      if (!rtx_equal_p (x14, operands[0]))
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x5) != SET)
        return NULL;
      x15 = XEXP (x5, 1);
      if (GET_CODE (x15) != COMPARE
          || GET_MODE (x15) != E_CCmode)
        return NULL;
      x16 = XEXP (x5, 0);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 36
          || GET_MODE (x16) != E_CCmode)
        return NULL;
      x17 = XEXP (x15, 1);
      operands[4] = x17;
      if (!const0_operand (operands[4], E_QImode))
        return NULL;
      x18 = XEXP (x15, 0);
      if (!rtx_equal_p (x18, operands[0]))
        return NULL;
      x19 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x19) != SET)
        return NULL;
      x20 = XEXP (x19, 1);
      if (GET_CODE (x20) != IF_THEN_ELSE)
        return NULL;
      x21 = XEXP (x20, 1);
      if (GET_CODE (x21) != LABEL_REF)
        return NULL;
      x22 = XEXP (x20, 2);
      if (GET_CODE (x22) != PC)
        return NULL;
      x23 = XEXP (x19, 0);
      if (GET_CODE (x23) != PC)
        return NULL;
      x24 = XEXP (x21, 0);
      operands[3] = x24;
      x25 = XEXP (x20, 0);
      switch (GET_CODE (x25))
        {
        case EQ:
          if (pattern375 (x25) != 0
              || !
#line 7557 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_284 (insn, operands);

        case NE:
          if (pattern375 (x25) != 0
              || !
#line 7557 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_285 (insn, operands);

        case GE:
          if (pattern375 (x25) != 0
              || !
#line 7557 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_286 (insn, operands);

        case LT:
          if (pattern375 (x25) != 0
              || !
#line 7557 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_287 (insn, operands);

        case GT:
          if (pattern375 (x25) != 0
              || !
#line 7557 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_288 (insn, operands);

        case LE:
          if (pattern375 (x25) != 0
              || !
#line 7557 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_289 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (peep2_current_count < 2
          || pattern98 (x2, 
36, 
E_CCmode) != 0)
        return NULL;
      x11 = XEXP (x3, 0);
      operands[3] = x11;
      if (!scratch_operand (operands[3], E_QImode))
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (pattern200 (x5) != 0)
        return NULL;
      x14 = XEXP (x4, 0);
      switch (GET_MODE (x14))
        {
        case E_HImode:
          if (!register_operand (x14, E_HImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_HImode))
            {
            case 0:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_294 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_295 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_HImode) != 0
              || !
#line 10299 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_309 (insn, operands);

        case E_SImode:
          if (!register_operand (x14, E_SImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_SImode))
            {
            case 0:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_296 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_297 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_SImode) != 0
              || !
#line 10299 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_310 (insn, operands);

        case E_PSImode:
          if (!register_operand (x14, E_PSImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_PSImode))
            {
            case 0:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_298 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_299 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_PSImode) != 0
              || !
#line 10299 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_311 (insn, operands);

        case E_HQmode:
          if (!register_operand (x14, E_HQmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_HQmode))
            {
            case 0:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_300 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_301 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_HQmode) != 0
              || !
#line 10299 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_312 (insn, operands);

        case E_HAmode:
          if (!register_operand (x14, E_HAmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_HAmode))
            {
            case 0:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_302 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_303 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_HAmode) != 0
              || !
#line 10299 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_313 (insn, operands);

        case E_SQmode:
          if (!register_operand (x14, E_SQmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_SQmode))
            {
            case 0:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_304 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_305 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_SQmode) != 0
              || !
#line 10299 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_314 (insn, operands);

        case E_SAmode:
          if (!register_operand (x14, E_SAmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_SAmode))
            {
            case 0:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_306 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_307 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_SAmode) != 0
              || !
#line 10299 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_315 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
