/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return 0;

    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      return 1;

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              x7 = XEXP (x3, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || !register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || GET_MODE (x3) != E_HImode
                  || GET_MODE (x5) != E_HImode)
                return -1;
              x8 = XEXP (x2, 1);
              operands[2] = x8;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 2;

            case AND:
              res = pattern2 (x2);
              if (res >= 0)
                return res + 3; /* [3, 8] */
              return -1;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != AND)
            return -1;
          res = pattern2 (x2);
          if (res >= 0)
            return res + 9; /* [9, 14] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      res = pattern3 (x2);
      if (res >= 0)
        return res + 15; /* [15, 20] */
      return -1;

    case LSHIFTRT:
      res = pattern5 (x1);
      if (res >= 0)
        return res + 21; /* [21, 30] */
      return -1;

    case ASHIFTRT:
      res = pattern5 (x1);
      if (res >= 0)
        return res + 31; /* [31, 40] */
      return -1;

    case GE:
      res = pattern8 (x1);
      if (res >= 0)
        return res + 41; /* [41, 56] */
      return -1;

    case LT:
      res = pattern8 (x1);
      if (res >= 0)
        return res + 57; /* [57, 72] */
      return -1;

    case MULT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          return 73;

        case SIGN_EXTEND:
          return 74;

        case ZERO_EXTEND:
          return 75;

        case AND:
          return 76;

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTRACT:
          res = pattern11 (x2);
          if (res >= 0)
            return res + 77; /* [77, 92] */
          return -1;

        case ASHIFT:
          res = pattern12 (x2);
          if (res >= 0)
            return res + 93; /* [93, 95] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_PSImode
          || !register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      res = pattern4 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1
      || GET_MODE (x4) != i2)
    return -1;
  return 0;
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (REGNO (x4))
    {
    case 24:
      if (REGNO (x2) != 24)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_HQmode:
          if (GET_MODE (x3) != E_HQmode
              || GET_MODE (x4) != E_HQmode)
            return -1;
          return 0;

        case E_HAmode:
          if (GET_MODE (x3) != E_HAmode
              || GET_MODE (x4) != E_HAmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (REGNO (x2) != 22)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SAmode:
          if (GET_MODE (x3) != E_SAmode
              || GET_MODE (x4) != E_SAmode)
            return -1;
          return 2;

        case E_SQmode:
          if (GET_MODE (x3) != E_SQmode
              || GET_MODE (x4) != E_SQmode)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_8_16_24_operand (operands[3], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          return pattern41 (x1, 
E_HImode); /* [-1, 0] */

        case E_PSImode:
          if (pattern41 (x1, 
E_PSImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern41 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      res = pattern43 (x1);
      if (res >= 0)
        return res + 3; /* [3, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      return 0;

    case SIGN_EXTEND:
      return 1;

    case ZERO_EXTEND:
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x4, 2);
  operands[1] = x7;
  if (!const_0_to_7_operand (operands[1], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[4] = x9;
  if (!const_int_operand (operands[4], E_QImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[3] = x10;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  return 0;
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  return pattern100 (x1); /* [-1, 2] */
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (SUBREG_BYTE (x1))
    {
    case 0:
      x2 = XEXP (x1, 0);
      switch (GET_CODE (x2))
        {
        case ASHIFT:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 0;

            case ZERO_EXTEND:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 1;

            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!register_operand (operands[1], E_HImode)
                  || !nonimmediate_operand (operands[0], E_QImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        case ASHIFTRT:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != CONST_INT
              || XWINT (x4, 0) != 128L)
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != AND
              || GET_MODE (x3) != E_QImode)
            return -1;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || !register_operand (operands[0], E_QImode))
            return -1;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case ZERO_EXTRACT:
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_QImode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          x8 = XEXP (x2, 2);
          operands[2] = x8;
          switch (GET_MODE (x2))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_0_to_15_operand (operands[2], E_QImode))
                return -1;
              return 4;

            case E_PSImode:
              if (!register_operand (operands[1], E_PSImode)
                  || !const_0_to_23_operand (operands[2], E_QImode))
                return -1;
              return 5;

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_0_to_31_operand (operands[2], E_QImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != LO_SUM
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[0], E_QImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!nonmemory_operand (operands[1], E_QImode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QQmode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QQmode))
    return -1;
  return 0;
}

int
pattern143 (rtx x1, unsigned int i1, machine_mode i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i4
      || GET_MODE (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1
      || GET_MODE (x5) != i2)
    return -1;
  return 0;
}

int
pattern147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!memory_operand (operands[0], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!memory_operand (operands[0], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!memory_operand (operands[0], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!memory_operand (operands[0], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!memory_operand (operands[0], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!memory_operand (operands[0], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!memory_operand (operands[0], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!memory_operand (operands[0], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!memory_operand (operands[0], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!memory_operand (operands[0], E_USAmode))
        return -1;
      return 12;

    case E_SFmode:
      if (!memory_operand (operands[0], E_SFmode))
        return -1;
      return 13;

    case E_PSImode:
      if (!memory_operand (operands[0], E_PSImode))
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern167 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[2] = x2;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern166 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern166 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern166 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern166 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern173 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern176 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode
      || !register_operand (operands[3], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern181 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_PSImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_MODE (x4))
    {
    case E_QImode:
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_HImode:
      operands[2] = x4;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (x2))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_QImode)
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x5) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x7) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x5) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x7) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x7) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || GET_MODE (x5) != E_UDQmode)
            return -1;
          return 0;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || GET_MODE (x5) != E_UDAmode)
            return -1;
          return 1;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || GET_MODE (x5) != E_UTAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || !const_operand (operands[0], E_UDQmode))
            return -1;
          return 3;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || !const_operand (operands[0], E_UDAmode))
            return -1;
          return 4;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || !const_operand (operands[0], E_UTAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern244 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  operands[2] = x1;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern249 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i1
      || GET_MODE (x5) != i4)
    return -1;
  return 0;
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern251 (x8, 
E_SImode); /* [-1, 0] */

    case E_PSImode:
      if (pattern251 (x8, 
E_PSImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern259 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x11;
      return pattern256 (); /* [-1, 1] */

    case SIGN_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern258 (x12);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case ZERO_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern258 (x12);
      if (res >= 0)
        return res + 6; /* [6, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern277 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_SQmode:
      if (!register_operand (operands[1], E_SQmode)
          || !nonmemory_operand (operands[2], E_SQmode))
        return -1;
      return 1;

    case E_USQmode:
      if (!register_operand (operands[1], E_USQmode)
          || !nonmemory_operand (operands[2], E_USQmode))
        return -1;
      return 2;

    case E_SAmode:
      if (!register_operand (operands[1], E_SAmode)
          || !nonmemory_operand (operands[2], E_SAmode))
        return -1;
      return 3;

    case E_USAmode:
      if (!register_operand (operands[1], E_USAmode)
          || !nonmemory_operand (operands[2], E_USAmode))
        return -1;
      return 4;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !nonmemory_operand (operands[2], E_PSImode))
        return -1;
      return 5;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !nonmemory_operand (operands[2], E_HImode))
        return -1;
      return 6;

    case E_HQmode:
      if (!register_operand (operands[1], E_HQmode)
          || !nonmemory_operand (operands[2], E_HQmode))
        return -1;
      return 7;

    case E_UHQmode:
      if (!register_operand (operands[1], E_UHQmode)
          || !nonmemory_operand (operands[2], E_UHQmode))
        return -1;
      return 8;

    case E_HAmode:
      if (!register_operand (operands[1], E_HAmode)
          || !nonmemory_operand (operands[2], E_HAmode))
        return -1;
      return 9;

    case E_UHAmode:
      if (!register_operand (operands[1], E_UHAmode)
          || !nonmemory_operand (operands[2], E_UHAmode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern298 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!l_register_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x3, 1);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern309 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern313 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 24
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  return 0;
}

int
pattern321 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_QQmode)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 23
      || GET_MODE (x5) != E_QQmode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 24
      || GET_MODE (x7) != E_HImode
      || GET_MODE (x3) != E_QQmode)
    return -1;
  x8 = XEXP (x3, 0);
  if (GET_MODE (x8) != E_QQmode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != E_QImode)
    return -1;
  return 0;
}

int
pattern330 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  return pattern329 (x1); /* [-1, 2] */
}

int
pattern337 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!ordered_comparison_operator (x2, E_VOIDmode))
    return -1;
  operands[0] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  return 0;
}

int
pattern343 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern350 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern356 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != 18)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 22)
    return -1;
  x8 = XEXP (x6, 1);
  if (REGNO (x8) != 18)
    return -1;
  x9 = XEXP (x2, 0);
  switch (REGNO (x9))
    {
    case 22:
      if (GET_MODE (x9) != E_PSImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (REGNO (x10) != 18
          || GET_MODE (x10) != E_PSImode)
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      if (REGNO (x12) != 21
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 0);
      if (REGNO (x14) != 25
          || GET_MODE (x14) != E_QImode
          || pattern355 (x1, 
E_PSImode, 
E_QImode, 
26) != 0)
        return -1;
      return 0;

    case 18:
      if (GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (REGNO (x10) != 22
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      if (REGNO (x12) != 26
          || GET_MODE (x12) != E_HImode)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 0);
      if (REGNO (x14) != 30
          || GET_MODE (x14) != E_HImode
          || pattern355 (x1, 
E_SImode, 
E_CCmode, 
36) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern374 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern379 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonmemory_operand (operands[1], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case EQ:
      return pattern375 (x4); /* [-1, 0] */

    case NE:
      if (pattern375 (x4) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern375 (x4) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern375 (x4) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern375 (x4) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern375 (x4) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern64 (x3))
    {
    case 0:
      if (
#line 843 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode)))
        return 113; /* movqi_insn_split */
      if (pnum_clobbers == NULL
          || !
#line 857 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 116; /* movqi_insn */

    case 1:
      if (
#line 843 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode)))
        return 114; /* movqq_insn_split */
      if (pnum_clobbers == NULL
          || !
#line 857 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 117; /* movqq_insn */

    case 2:
      if (
#line 843 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode)))
        return 115; /* movuqq_insn_split */
      if (pnum_clobbers == NULL
          || !
#line 857 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 118; /* movuqq_insn */

    case 3:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !nox_general_operand (operands[1], E_HImode))
        return -1;
      if (
#line 954 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], HImode)
   || reg_or_0_operand (operands[1], HImode)))
        return 128; /* *movhi_split */
      if (pnum_clobbers == NULL
          || !
#line 966 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 133; /* *movhi */

    case 4:
      if (
#line 954 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], HQmode)
   || reg_or_0_operand (operands[1], HQmode)))
        return 129; /* *movhq_split */
      if (pnum_clobbers == NULL
          || !
#line 966 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], HQmode)
    || reg_or_0_operand (operands[1], HQmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 134; /* *movhq */

    case 5:
      if (
#line 954 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], UHQmode)
   || reg_or_0_operand (operands[1], UHQmode)))
        return 130; /* *movuhq_split */
      if (pnum_clobbers == NULL
          || !
#line 966 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], UHQmode)
    || reg_or_0_operand (operands[1], UHQmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 135; /* *movuhq */

    case 6:
      if (
#line 954 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], HAmode)
   || reg_or_0_operand (operands[1], HAmode)))
        return 131; /* *movha_split */
      if (pnum_clobbers == NULL
          || !
#line 966 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], HAmode)
    || reg_or_0_operand (operands[1], HAmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 136; /* *movha */

    case 7:
      if (
#line 954 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], UHAmode)
   || reg_or_0_operand (operands[1], UHAmode)))
        return 132; /* *movuha_split */
      if (pnum_clobbers == NULL
          || !
#line 966 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], UHAmode)
    || reg_or_0_operand (operands[1], UHAmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 137; /* *movuha */

    case 8:
      if (!nonimmediate_operand (operands[0], E_PSImode)
          || !nox_general_operand (operands[1], E_PSImode))
        return -1;
      if (
#line 1126 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], PSImode)
   || register_operand (operands[1], PSImode)
   || const0_rtx == operands[1]))
        return 139; /* *movpsi_split */
      if (pnum_clobbers == NULL
          || !
#line 1139 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], PSImode)
    || register_operand (operands[1], PSImode)
    || const0_rtx == operands[1])
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 140; /* *movpsi */

    case 9:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !nox_general_operand (operands[1], E_SImode))
        return -1;
      if (
#line 1187 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], SImode)
   || reg_or_0_operand (operands[1], SImode)))
        return 146; /* *movsi_split */
      if (pnum_clobbers == NULL
          || !
#line 1199 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 151; /* *movsi */

    case 10:
      if (!nonimmediate_operand (operands[0], E_SQmode)
          || !nox_general_operand (operands[1], E_SQmode))
        return -1;
      if (
#line 1187 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], SQmode)
   || reg_or_0_operand (operands[1], SQmode)))
        return 147; /* *movsq_split */
      if (pnum_clobbers == NULL
          || !
#line 1199 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SQmode)
    || reg_or_0_operand (operands[1], SQmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 152; /* *movsq */

    case 11:
      if (!nonimmediate_operand (operands[0], E_USQmode)
          || !nox_general_operand (operands[1], E_USQmode))
        return -1;
      if (
#line 1187 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], USQmode)
   || reg_or_0_operand (operands[1], USQmode)))
        return 148; /* *movusq_split */
      if (pnum_clobbers == NULL
          || !
#line 1199 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], USQmode)
    || reg_or_0_operand (operands[1], USQmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 153; /* *movusq */

    case 12:
      if (!nonimmediate_operand (operands[0], E_SAmode)
          || !nox_general_operand (operands[1], E_SAmode))
        return -1;
      if (
#line 1187 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], SAmode)
   || reg_or_0_operand (operands[1], SAmode)))
        return 149; /* *movsa_split */
      if (pnum_clobbers == NULL
          || !
#line 1199 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SAmode)
    || reg_or_0_operand (operands[1], SAmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 154; /* *movsa */

    case 13:
      if (!nonimmediate_operand (operands[0], E_USAmode)
          || !nox_general_operand (operands[1], E_USAmode))
        return -1;
      if (
#line 1187 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], USAmode)
   || reg_or_0_operand (operands[1], USAmode)))
        return 150; /* *movusa_split */
      if (pnum_clobbers == NULL
          || !
#line 1199 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], USAmode)
    || reg_or_0_operand (operands[1], USAmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 155; /* *movusa */

    case 14:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !nox_general_operand (operands[1], E_SFmode))
        return -1;
      if (
#line 1235 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], SFmode)
   || reg_or_0_operand (operands[1], SFmode)))
        return 157; /* *movsf_split */
      if (pnum_clobbers == NULL
          || !
#line 1247 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 158; /* *movsf */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ASHIFT:
          if (GET_MODE (x4) != E_QImode
              || pattern272 (x2) != 0
              || GET_MODE (x3) != E_QImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!register_operand (operands[3], E_QImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[4] = x6;
          if (!const_0_to_7_operand (operands[4], E_QImode))
            return -1;
          x7 = XEXP (x3, 1);
          operands[5] = x7;
          if (!single_one_operand (operands[5], E_QImode)
              || !
#line 9900 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) == exact_log2 (~INTVAL (operands[2]) & 0xff)
   && INTVAL (operands[4]) == exact_log2 (INTVAL (operands[5]) & 0xff)))
            return -1;
          return 1069; /* *movbitqi.1-6.a */

        case REG:
        case SUBREG:
          operands[3] = x4;
          x7 = XEXP (x3, 1);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern308 (x2, 
E_QImode) != 0
                  || !
#line 9927 "../../gcc/config/avr/avr.md"
(GET_MODE_MASK(QImode)
   == (GET_MODE_MASK(QImode) & (INTVAL(operands[2]) ^ INTVAL(operands[4])))))
                return -1;
              return 1071; /* *movbitqi.0-6 */

            case E_HImode:
              if (pattern308 (x2, 
E_HImode) != 0
                  || !
#line 9927 "../../gcc/config/avr/avr.md"
(GET_MODE_MASK(HImode)
   == (GET_MODE_MASK(HImode) & (INTVAL(operands[2]) ^ INTVAL(operands[4])))))
                return -1;
              return 1072; /* *movbithi.0-6 */

            case E_PSImode:
              if (pattern308 (x2, 
E_PSImode) != 0
                  || !
#line 9927 "../../gcc/config/avr/avr.md"
(GET_MODE_MASK(PSImode)
   == (GET_MODE_MASK(PSImode) & (INTVAL(operands[2]) ^ INTVAL(operands[4])))))
                return -1;
              return 1073; /* *movbitpsi.0-6 */

            case E_SImode:
              if (pattern308 (x2, 
E_SImode) != 0
                  || !
#line 9927 "../../gcc/config/avr/avr.md"
(GET_MODE_MASK(SImode)
   == (GET_MODE_MASK(SImode) & (INTVAL(operands[2]) ^ INTVAL(operands[4])))))
                return -1;
              return 1074; /* *movbitsi.0-6 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != AND
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern272 (x2) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[4] = x7;
      if (!const_0_to_7_operand (operands[4], E_QImode)
          || !
#line 9916 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) == exact_log2 (~INTVAL (operands[2]) & 0xff)))
        return -1;
      return 1070; /* *movbitqi.1-6.b */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      return recog_7 (x1, insn, pnum_clobbers);

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern3 (x2))
            {
            case 0:
              return 180; /* *addhi3_zero_extend_split */

            case 1:
              return 226; /* *addpsi3.zero_extend.qi_split */

            case 2:
              return 230; /* *addpsi3.zero_extend.hi_split */

            case 3:
              return 228; /* *addsi3.zero_extend.qi_split */

            case 4:
              return 232; /* *addsi3.zero_extend.hi_split */

            case 5:
              return 234; /* *addsi3.zero_extend.psi_split */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST:
        case SYMBOL_REF:
          operands[2] = x3;
          if (pattern175 (x2) != 0)
            return -1;
          if (const_m255_to_m1_operand (operands[2], E_HImode))
            return 184; /* *addhi3_zero_extend.const_split */
          if (!const_0mod256_operand (operands[2], E_HImode))
            return -1;
          return 186; /* *aligned_add_symbol */

        case ZERO_EXTEND:
          if (pattern149 (x2) != 0)
            return -1;
          return 189; /* *usum_widenqihi3_split */

        default:
          return -1;
        }

    case 2:
      return 187; /* *addhi3_zero_extend.ashift1.split */

    case 3:
      if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1369; /* *shl.ext.and1-to-skip.hi */

    case 4:
      if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1375; /* *shl.ext.and1-to-skip.psi */

    case 5:
      if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1387; /* *shl.ext.and1-to-skip.psi */

    case 6:
      if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1381; /* *shl.ext.and1-to-skip.si */

    case 7:
      if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1393; /* *shl.ext.and1-to-skip.si */

    case 8:
      if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1399; /* *shl.ext.and1-to-skip.si */

    case 9:
      if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1368; /* *shl.ext.and1-to-skip.hi */

    case 10:
      if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1374; /* *shl.ext.and1-to-skip.psi */

    case 11:
      if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1386; /* *shl.ext.and1-to-skip.psi */

    case 12:
      if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1380; /* *shl.ext.and1-to-skip.si */

    case 13:
      if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1392; /* *shl.ext.and1-to-skip.si */

    case 14:
      if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1398; /* *shl.ext.and1-to-skip.si */

    case 15:
      return 224; /* *addhi3.sign_extend.qi_split */

    case 16:
      return 225; /* *addpsi3.sign_extend.qi_split */

    case 17:
      return 229; /* *addpsi3.sign_extend.hi_split */

    case 18:
      return 227; /* *addsi3.sign_extend.qi_split */

    case 19:
      return 231; /* *addsi3.sign_extend.hi_split */

    case 20:
      return 233; /* *addsi3.sign_extend.psi_split */

    case 21:
      return 316; /* *addqi3.msbit_split */

    case 22:
      return 318; /* *addhi3.msbit_split */

    case 23:
      return 320; /* *addpsi3.msbit_split */

    case 24:
      return 322; /* *addsi3.msbit_split */

    case 25:
      return 324; /* *addhi3.sex.msbit_split */

    case 26:
      return 326; /* *addpsi3.sex.msbit_split */

    case 27:
      return 330; /* *addpsi3.sex.msbit_split */

    case 28:
      return 328; /* *addsi3.sex.msbit_split */

    case 29:
      return 332; /* *addsi3.sex.msbit_split */

    case 30:
      return 334; /* *addsi3.sex.msbit_split */

    case 31:
      return 317; /* *addqi3.msbit_split */

    case 32:
      return 319; /* *addhi3.msbit_split */

    case 33:
      return 321; /* *addpsi3.msbit_split */

    case 34:
      return 323; /* *addsi3.msbit_split */

    case 35:
      return 325; /* *addhi3.sex.msbit_split */

    case 36:
      return 327; /* *addpsi3.sex.msbit_split */

    case 37:
      return 331; /* *addpsi3.sex.msbit_split */

    case 38:
      return 329; /* *addsi3.sex.msbit_split */

    case 39:
      return 333; /* *addsi3.sex.msbit_split */

    case 40:
      return 335; /* *addsi3.sex.msbit_split */

    case 41:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 380; /* *addqi3.ge0 */
        }
      return 412; /* *addqi3.ge0_split */

    case 42:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 388; /* *addqi3.ge0 */
        }
      return 420; /* *addqi3.ge0_split */

    case 43:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 396; /* *addqi3.ge0 */
        }
      return 428; /* *addqi3.ge0_split */

    case 44:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 404; /* *addqi3.ge0 */
        }
      return 436; /* *addqi3.ge0_split */

    case 45:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 382; /* *addhi3.ge0 */
        }
      return 414; /* *addhi3.ge0_split */

    case 46:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 390; /* *addhi3.ge0 */
        }
      return 422; /* *addhi3.ge0_split */

    case 47:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 398; /* *addhi3.ge0 */
        }
      return 430; /* *addhi3.ge0_split */

    case 48:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 406; /* *addhi3.ge0 */
        }
      return 438; /* *addhi3.ge0_split */

    case 49:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 384; /* *addpsi3.ge0 */
        }
      return 416; /* *addpsi3.ge0_split */

    case 50:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 392; /* *addpsi3.ge0 */
        }
      return 424; /* *addpsi3.ge0_split */

    case 51:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 400; /* *addpsi3.ge0 */
        }
      return 432; /* *addpsi3.ge0_split */

    case 52:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 408; /* *addpsi3.ge0 */
        }
      return 440; /* *addpsi3.ge0_split */

    case 53:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 386; /* *addsi3.ge0 */
        }
      return 418; /* *addsi3.ge0_split */

    case 54:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 394; /* *addsi3.ge0 */
        }
      return 426; /* *addsi3.ge0_split */

    case 55:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 402; /* *addsi3.ge0 */
        }
      return 434; /* *addsi3.ge0_split */

    case 56:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 410; /* *addsi3.ge0 */
        }
      return 442; /* *addsi3.ge0_split */

    case 57:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 381; /* *addqi3.lt0 */
        }
      return 413; /* *addqi3.lt0_split */

    case 58:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 389; /* *addqi3.lt0 */
        }
      return 421; /* *addqi3.lt0_split */

    case 59:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 397; /* *addqi3.lt0 */
        }
      return 429; /* *addqi3.lt0_split */

    case 60:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 405; /* *addqi3.lt0 */
        }
      return 437; /* *addqi3.lt0_split */

    case 61:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 383; /* *addhi3.lt0 */
        }
      return 415; /* *addhi3.lt0_split */

    case 62:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 391; /* *addhi3.lt0 */
        }
      return 423; /* *addhi3.lt0_split */

    case 63:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 399; /* *addhi3.lt0 */
        }
      return 431; /* *addhi3.lt0_split */

    case 64:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 407; /* *addhi3.lt0 */
        }
      return 439; /* *addhi3.lt0_split */

    case 65:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 385; /* *addpsi3.lt0 */
        }
      return 417; /* *addpsi3.lt0_split */

    case 66:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 393; /* *addpsi3.lt0 */
        }
      return 425; /* *addpsi3.lt0_split */

    case 67:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 401; /* *addpsi3.lt0 */
        }
      return 433; /* *addpsi3.lt0_split */

    case 68:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 409; /* *addpsi3.lt0 */
        }
      return 441; /* *addpsi3.lt0_split */

    case 69:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 387; /* *addsi3.lt0 */
        }
      return 419; /* *addsi3.lt0_split */

    case 70:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 395; /* *addsi3.lt0 */
        }
      return 427; /* *addsi3.lt0_split */

    case 71:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 403; /* *addsi3.lt0 */
        }
      return 435; /* *addsi3.lt0_split */

    case 72:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 411; /* *addsi3.lt0 */
        }
      return 443; /* *addsi3.lt0_split */

    case 73:
      x2 = XEXP (x1, 1);
      if (pattern114 (x2, 
E_QImode) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x3 = XEXP (x2, 1);
      operands[3] = x3;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          if (
#line 2587 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 490; /* *maddqi4_split */
          if (pnum_clobbers == NULL
              || !
#line 2602 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 491; /* *maddqi4 */

        case CONST_INT:
          if (pnum_clobbers == NULL
              || !const_int_operand (operands[2], E_QImode)
              || !
#line 2640 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 494; /* *maddqi4.const */

        default:
          return -1;
        }

    case 74:
      x2 = XEXP (x1, 1);
      switch (pattern116 (x2))
        {
        case 0:
          if (!register_operand (operands[3], E_HImode))
            return -1;
          x4 = XEXP (x2, 0);
          x5 = XEXP (x4, 1);
          switch (GET_CODE (x5))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x5) != E_HImode)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2696 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 496; /* *maddqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2711 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 498; /* *maddqihi4 */

            case ZERO_EXTEND:
              if (GET_MODE (x5) != E_HImode)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2754 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return 505; /* *sumsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2771 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              *pnum_clobbers = 1;
              return 507; /* *sumsubqihi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x5;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2850 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 513; /* *maddqihi4.sconst */
                }
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2942 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 519; /* *sumaddqihi4.uconst */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1332; /* *mul.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1338; /* *mul.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1350; /* *mul.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1344; /* *mul.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1356; /* *mul.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1362; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case 75:
      x2 = XEXP (x1, 1);
      switch (pattern117 (x2))
        {
        case 0:
          if (
#line 2696 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 497; /* *umaddqihi4_split */
          if (pnum_clobbers == NULL
              || !
#line 2711 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 499; /* *umaddqihi4 */

        case 1:
          if (
#line 2754 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
            return 504; /* *usmsubqihi4_split */
          if (pnum_clobbers == NULL
              || !
#line 2771 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
            return -1;
          *pnum_clobbers = 1;
          return 506; /* *usmsubqihi4 */

        case 2:
          x4 = XEXP (x2, 0);
          x5 = XEXP (x4, 1);
          if (XWINT (x5, 0) == 2L)
            {
              x3 = XEXP (x2, 1);
              operands[2] = x3;
              if (
#line 2827 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
                return 512; /* *umaddqihi4.2 */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          if (!u8_operand (operands[2], E_HImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[3] = x3;
          if (!
#line 2850 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 514; /* *umaddqihi4.uconst */

        case 3:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1333; /* *mul.ext.and1-to-skip.hi */

        case 4:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1339; /* *mul.ext.and1-to-skip.psi */

        case 5:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1351; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1345; /* *mul.ext.and1-to-skip.si */

        case 7:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1357; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1363; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case 76:
      x2 = XEXP (x1, 1);
      switch (pattern118 (x2))
        {
        case 0:
          if (!
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1320; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1323; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1326; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1329; /* *mul.and1-to-skip.si */

        default:
          return -1;
        }

    case 77:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1272; /* *pixop-to-skip.qi */

    case 78:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1284; /* *pixop-to-skip.qi */

    case 79:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1296; /* *pixop-to-skip.qi */

    case 80:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1308; /* *pixop-to-skip.qi */

    case 81:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1275; /* *pixop-to-skip.hi */

    case 82:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1287; /* *pixop-to-skip.hi */

    case 83:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1299; /* *pixop-to-skip.hi */

    case 84:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1311; /* *pixop-to-skip.hi */

    case 85:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1278; /* *pixop-to-skip.psi */

    case 86:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1290; /* *pixop-to-skip.psi */

    case 87:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1302; /* *pixop-to-skip.psi */

    case 88:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1314; /* *pixop-to-skip.psi */

    case 89:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1281; /* *pixop-to-skip.si */

    case 90:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1293; /* *pixop-to-skip.si */

    case 91:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1305; /* *pixop-to-skip.si */

    case 92:
      if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1317; /* *pixop-to-skip.si */

    case 93:
      if (!
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
        return -1;
      return 1404; /* *shl.and-to-skip.hi */

    case 94:
      if (!
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
        return -1;
      return 1407; /* *shl.and-to-skip.psi */

    case 95:
      if (!
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
        return -1;
      return 1410; /* *shl.and-to-skip.si */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_CCNmode)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != E_CCNmode)
    return -1;
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  switch (GET_MODE (x8))
    {
    case E_HImode:
      if (pattern354 (x3, 
E_HImode) != 0
          || !
#line 7532 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 937; /* *ashift.for.ccn.hi */

    case E_PSImode:
      if (pattern354 (x3, 
E_PSImode) != 0
          || !
#line 7532 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 938; /* *ashift.for.ccn.psi */

    case E_SImode:
      if (pattern354 (x3, 
E_SImode) != 0
          || !
#line 7532 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 939; /* *ashift.for.ccn.si */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern93 (x1))
    {
    case 0:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode
   && reload_completed))
        return -1;
      return 1853; /* *fractuqqqq2 */

    case 1:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QQmode
   && reload_completed))
        return -1;
      return 1854; /* *fracthqqq2 */

    case 2:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode
   && reload_completed))
        return -1;
      return 1855; /* *fractuhqqq2 */

    case 3:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QQmode
   && reload_completed))
        return -1;
      return 1856; /* *fracthaqq2 */

    case 4:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode
   && reload_completed))
        return -1;
      return 1857; /* *fractuhaqq2 */

    case 5:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QQmode
   && reload_completed))
        return -1;
      return 1858; /* *fractsqqq2 */

    case 6:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QQmode
   && reload_completed))
        return -1;
      return 1859; /* *fractusqqq2 */

    case 7:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QQmode
   && reload_completed))
        return -1;
      return 1860; /* *fractsaqq2 */

    case 8:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QQmode
   && reload_completed))
        return -1;
      return 1861; /* *fractusaqq2 */

    case 9:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QQmode
   && reload_completed))
        return -1;
      return 1862; /* *fractdqqq2 */

    case 10:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode
   && reload_completed))
        return -1;
      return 1863; /* *fractudqqq2 */

    case 11:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QQmode
   && reload_completed))
        return -1;
      return 1864; /* *fractdaqq2 */

    case 12:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode
   && reload_completed))
        return -1;
      return 1865; /* *fractudaqq2 */

    case 13:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QQmode
   && reload_completed))
        return -1;
      return 1866; /* *fracttaqq2 */

    case 14:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode
   && reload_completed))
        return -1;
      return 1867; /* *fractutaqq2 */

    case 15:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != QQmode
   && reload_completed))
        return -1;
      return 1868; /* *fractqiqq2 */

    case 16:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != QQmode
   && reload_completed))
        return -1;
      return 1869; /* *fracthiqq2 */

    case 17:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != QQmode
   && reload_completed))
        return -1;
      return 1870; /* *fractsiqq2 */

    case 18:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != QQmode
   && reload_completed))
        return -1;
      return 1871; /* *fractdiqq2 */

    case 19:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode
   && reload_completed))
        return -1;
      return 1872; /* *fractqquqq2 */

    case 20:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode
   && reload_completed))
        return -1;
      return 1873; /* *fracthquqq2 */

    case 21:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode
   && reload_completed))
        return -1;
      return 1874; /* *fractuhquqq2 */

    case 22:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode
   && reload_completed))
        return -1;
      return 1875; /* *fracthauqq2 */

    case 23:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode
   && reload_completed))
        return -1;
      return 1876; /* *fractuhauqq2 */

    case 24:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode
   && reload_completed))
        return -1;
      return 1877; /* *fractsquqq2 */

    case 25:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode
   && reload_completed))
        return -1;
      return 1878; /* *fractusquqq2 */

    case 26:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode
   && reload_completed))
        return -1;
      return 1879; /* *fractsauqq2 */

    case 27:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode
   && reload_completed))
        return -1;
      return 1880; /* *fractusauqq2 */

    case 28:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode
   && reload_completed))
        return -1;
      return 1881; /* *fractdquqq2 */

    case 29:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode
   && reload_completed))
        return -1;
      return 1882; /* *fractudquqq2 */

    case 30:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode
   && reload_completed))
        return -1;
      return 1883; /* *fractdauqq2 */

    case 31:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode
   && reload_completed))
        return -1;
      return 1884; /* *fractudauqq2 */

    case 32:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode
   && reload_completed))
        return -1;
      return 1885; /* *fracttauqq2 */

    case 33:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode
   && reload_completed))
        return -1;
      return 1886; /* *fractutauqq2 */

    case 34:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UQQmode
   && reload_completed))
        return -1;
      return 1887; /* *fractqiuqq2 */

    case 35:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UQQmode
   && reload_completed))
        return -1;
      return 1888; /* *fracthiuqq2 */

    case 36:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UQQmode
   && reload_completed))
        return -1;
      return 1889; /* *fractsiuqq2 */

    case 37:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UQQmode
   && reload_completed))
        return -1;
      return 1890; /* *fractdiuqq2 */

    case 38:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HQmode
   && reload_completed))
        return -1;
      return 1891; /* *fractqqhq2 */

    case 39:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode
   && reload_completed))
        return -1;
      return 1892; /* *fractuqqhq2 */

    case 40:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode
   && reload_completed))
        return -1;
      return 1893; /* *fractuhqhq2 */

    case 41:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HQmode
   && reload_completed))
        return -1;
      return 1894; /* *fracthahq2 */

    case 42:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode
   && reload_completed))
        return -1;
      return 1895; /* *fractuhahq2 */

    case 43:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HQmode
   && reload_completed))
        return -1;
      return 1896; /* *fractsqhq2 */

    case 44:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HQmode
   && reload_completed))
        return -1;
      return 1897; /* *fractusqhq2 */

    case 45:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HQmode
   && reload_completed))
        return -1;
      return 1898; /* *fractsahq2 */

    case 46:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HQmode
   && reload_completed))
        return -1;
      return 1899; /* *fractusahq2 */

    case 47:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HQmode
   && reload_completed))
        return -1;
      return 1900; /* *fractdqhq2 */

    case 48:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode
   && reload_completed))
        return -1;
      return 1901; /* *fractudqhq2 */

    case 49:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HQmode
   && reload_completed))
        return -1;
      return 1902; /* *fractdahq2 */

    case 50:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode
   && reload_completed))
        return -1;
      return 1903; /* *fractudahq2 */

    case 51:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HQmode
   && reload_completed))
        return -1;
      return 1904; /* *fracttahq2 */

    case 52:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode
   && reload_completed))
        return -1;
      return 1905; /* *fractutahq2 */

    case 53:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != HQmode
   && reload_completed))
        return -1;
      return 1906; /* *fractqihq2 */

    case 54:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != HQmode
   && reload_completed))
        return -1;
      return 1907; /* *fracthihq2 */

    case 55:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != HQmode
   && reload_completed))
        return -1;
      return 1908; /* *fractsihq2 */

    case 56:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != HQmode
   && reload_completed))
        return -1;
      return 1909; /* *fractdihq2 */

    case 57:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode
   && reload_completed))
        return -1;
      return 1910; /* *fractqquhq2 */

    case 58:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode
   && reload_completed))
        return -1;
      return 1911; /* *fractuqquhq2 */

    case 59:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode
   && reload_completed))
        return -1;
      return 1912; /* *fracthquhq2 */

    case 60:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode
   && reload_completed))
        return -1;
      return 1913; /* *fracthauhq2 */

    case 61:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode
   && reload_completed))
        return -1;
      return 1914; /* *fractuhauhq2 */

    case 62:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode
   && reload_completed))
        return -1;
      return 1915; /* *fractsquhq2 */

    case 63:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode
   && reload_completed))
        return -1;
      return 1916; /* *fractusquhq2 */

    case 64:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode
   && reload_completed))
        return -1;
      return 1917; /* *fractsauhq2 */

    case 65:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode
   && reload_completed))
        return -1;
      return 1918; /* *fractusauhq2 */

    case 66:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode
   && reload_completed))
        return -1;
      return 1919; /* *fractdquhq2 */

    case 67:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode
   && reload_completed))
        return -1;
      return 1920; /* *fractudquhq2 */

    case 68:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode
   && reload_completed))
        return -1;
      return 1921; /* *fractdauhq2 */

    case 69:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode
   && reload_completed))
        return -1;
      return 1922; /* *fractudauhq2 */

    case 70:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode
   && reload_completed))
        return -1;
      return 1923; /* *fracttauhq2 */

    case 71:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode
   && reload_completed))
        return -1;
      return 1924; /* *fractutauhq2 */

    case 72:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHQmode
   && reload_completed))
        return -1;
      return 1925; /* *fractqiuhq2 */

    case 73:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHQmode
   && reload_completed))
        return -1;
      return 1926; /* *fracthiuhq2 */

    case 74:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHQmode
   && reload_completed))
        return -1;
      return 1927; /* *fractsiuhq2 */

    case 75:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHQmode
   && reload_completed))
        return -1;
      return 1928; /* *fractdiuhq2 */

    case 76:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HAmode
   && reload_completed))
        return -1;
      return 1929; /* *fractqqha2 */

    case 77:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode
   && reload_completed))
        return -1;
      return 1930; /* *fractuqqha2 */

    case 78:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HAmode
   && reload_completed))
        return -1;
      return 1931; /* *fracthqha2 */

    case 79:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode
   && reload_completed))
        return -1;
      return 1932; /* *fractuhqha2 */

    case 80:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode
   && reload_completed))
        return -1;
      return 1933; /* *fractuhaha2 */

    case 81:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HAmode
   && reload_completed))
        return -1;
      return 1934; /* *fractsqha2 */

    case 82:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HAmode
   && reload_completed))
        return -1;
      return 1935; /* *fractusqha2 */

    case 83:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HAmode
   && reload_completed))
        return -1;
      return 1936; /* *fractsaha2 */

    case 84:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HAmode
   && reload_completed))
        return -1;
      return 1937; /* *fractusaha2 */

    case 85:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HAmode
   && reload_completed))
        return -1;
      return 1938; /* *fractdqha2 */

    case 86:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode
   && reload_completed))
        return -1;
      return 1939; /* *fractudqha2 */

    case 87:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HAmode
   && reload_completed))
        return -1;
      return 1940; /* *fractdaha2 */

    case 88:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode
   && reload_completed))
        return -1;
      return 1941; /* *fractudaha2 */

    case 89:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HAmode
   && reload_completed))
        return -1;
      return 1942; /* *fracttaha2 */

    case 90:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode
   && reload_completed))
        return -1;
      return 1943; /* *fractutaha2 */

    case 91:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != HAmode
   && reload_completed))
        return -1;
      return 1944; /* *fractqiha2 */

    case 92:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != HAmode
   && reload_completed))
        return -1;
      return 1945; /* *fracthiha2 */

    case 93:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != HAmode
   && reload_completed))
        return -1;
      return 1946; /* *fractsiha2 */

    case 94:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != HAmode
   && reload_completed))
        return -1;
      return 1947; /* *fractdiha2 */

    case 95:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode
   && reload_completed))
        return -1;
      return 1948; /* *fractqquha2 */

    case 96:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode
   && reload_completed))
        return -1;
      return 1949; /* *fractuqquha2 */

    case 97:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode
   && reload_completed))
        return -1;
      return 1950; /* *fracthquha2 */

    case 98:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode
   && reload_completed))
        return -1;
      return 1951; /* *fractuhquha2 */

    case 99:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode
   && reload_completed))
        return -1;
      return 1952; /* *fracthauha2 */

    case 100:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode
   && reload_completed))
        return -1;
      return 1953; /* *fractsquha2 */

    case 101:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode
   && reload_completed))
        return -1;
      return 1954; /* *fractusquha2 */

    case 102:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode
   && reload_completed))
        return -1;
      return 1955; /* *fractsauha2 */

    case 103:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode
   && reload_completed))
        return -1;
      return 1956; /* *fractusauha2 */

    case 104:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode
   && reload_completed))
        return -1;
      return 1957; /* *fractdquha2 */

    case 105:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode
   && reload_completed))
        return -1;
      return 1958; /* *fractudquha2 */

    case 106:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode
   && reload_completed))
        return -1;
      return 1959; /* *fractdauha2 */

    case 107:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode
   && reload_completed))
        return -1;
      return 1960; /* *fractudauha2 */

    case 108:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode
   && reload_completed))
        return -1;
      return 1961; /* *fracttauha2 */

    case 109:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode
   && reload_completed))
        return -1;
      return 1962; /* *fractutauha2 */

    case 110:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHAmode
   && reload_completed))
        return -1;
      return 1963; /* *fractqiuha2 */

    case 111:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHAmode
   && reload_completed))
        return -1;
      return 1964; /* *fracthiuha2 */

    case 112:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHAmode
   && reload_completed))
        return -1;
      return 1965; /* *fractsiuha2 */

    case 113:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHAmode
   && reload_completed))
        return -1;
      return 1966; /* *fractdiuha2 */

    case 114:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SQmode
   && reload_completed))
        return -1;
      return 1967; /* *fractqqsq2 */

    case 115:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode
   && reload_completed))
        return -1;
      return 1968; /* *fractuqqsq2 */

    case 116:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SQmode
   && reload_completed))
        return -1;
      return 1969; /* *fracthqsq2 */

    case 117:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode
   && reload_completed))
        return -1;
      return 1970; /* *fractuhqsq2 */

    case 118:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SQmode
   && reload_completed))
        return -1;
      return 1971; /* *fracthasq2 */

    case 119:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode
   && reload_completed))
        return -1;
      return 1972; /* *fractuhasq2 */

    case 120:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SQmode
   && reload_completed))
        return -1;
      return 1973; /* *fractusqsq2 */

    case 121:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SQmode
   && reload_completed))
        return -1;
      return 1974; /* *fractsasq2 */

    case 122:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SQmode
   && reload_completed))
        return -1;
      return 1975; /* *fractusasq2 */

    case 123:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SQmode
   && reload_completed))
        return -1;
      return 1976; /* *fractdqsq2 */

    case 124:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode
   && reload_completed))
        return -1;
      return 1977; /* *fractudqsq2 */

    case 125:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SQmode
   && reload_completed))
        return -1;
      return 1978; /* *fractdasq2 */

    case 126:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode
   && reload_completed))
        return -1;
      return 1979; /* *fractudasq2 */

    case 127:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SQmode
   && reload_completed))
        return -1;
      return 1980; /* *fracttasq2 */

    case 128:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode
   && reload_completed))
        return -1;
      return 1981; /* *fractutasq2 */

    case 129:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != SQmode
   && reload_completed))
        return -1;
      return 1982; /* *fractqisq2 */

    case 130:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != SQmode
   && reload_completed))
        return -1;
      return 1983; /* *fracthisq2 */

    case 131:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != SQmode
   && reload_completed))
        return -1;
      return 1984; /* *fractsisq2 */

    case 132:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != SQmode
   && reload_completed))
        return -1;
      return 1985; /* *fractdisq2 */

    case 133:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USQmode
   && reload_completed))
        return -1;
      return 1986; /* *fractqqusq2 */

    case 134:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode
   && reload_completed))
        return -1;
      return 1987; /* *fractuqqusq2 */

    case 135:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USQmode
   && reload_completed))
        return -1;
      return 1988; /* *fracthqusq2 */

    case 136:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode
   && reload_completed))
        return -1;
      return 1989; /* *fractuhqusq2 */

    case 137:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USQmode
   && reload_completed))
        return -1;
      return 1990; /* *fracthausq2 */

    case 138:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode
   && reload_completed))
        return -1;
      return 1991; /* *fractuhausq2 */

    case 139:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USQmode
   && reload_completed))
        return -1;
      return 1992; /* *fractsqusq2 */

    case 140:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USQmode
   && reload_completed))
        return -1;
      return 1993; /* *fractsausq2 */

    case 141:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != USQmode
   && reload_completed))
        return -1;
      return 1994; /* *fractusausq2 */

    case 142:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USQmode
   && reload_completed))
        return -1;
      return 1995; /* *fractdqusq2 */

    case 143:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode
   && reload_completed))
        return -1;
      return 1996; /* *fractudqusq2 */

    case 144:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USQmode
   && reload_completed))
        return -1;
      return 1997; /* *fractdausq2 */

    case 145:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode
   && reload_completed))
        return -1;
      return 1998; /* *fractudausq2 */

    case 146:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USQmode
   && reload_completed))
        return -1;
      return 1999; /* *fracttausq2 */

    case 147:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode
   && reload_completed))
        return -1;
      return 2000; /* *fractutausq2 */

    case 148:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != USQmode
   && reload_completed))
        return -1;
      return 2001; /* *fractqiusq2 */

    case 149:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != USQmode
   && reload_completed))
        return -1;
      return 2002; /* *fracthiusq2 */

    case 150:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != USQmode
   && reload_completed))
        return -1;
      return 2003; /* *fractsiusq2 */

    case 151:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != USQmode
   && reload_completed))
        return -1;
      return 2004; /* *fractdiusq2 */

    case 152:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SAmode
   && reload_completed))
        return -1;
      return 2005; /* *fractqqsa2 */

    case 153:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode
   && reload_completed))
        return -1;
      return 2006; /* *fractuqqsa2 */

    case 154:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SAmode
   && reload_completed))
        return -1;
      return 2007; /* *fracthqsa2 */

    case 155:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode
   && reload_completed))
        return -1;
      return 2008; /* *fractuhqsa2 */

    case 156:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SAmode
   && reload_completed))
        return -1;
      return 2009; /* *fracthasa2 */

    case 157:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode
   && reload_completed))
        return -1;
      return 2010; /* *fractuhasa2 */

    case 158:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SAmode
   && reload_completed))
        return -1;
      return 2011; /* *fractsqsa2 */

    case 159:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SAmode
   && reload_completed))
        return -1;
      return 2012; /* *fractusqsa2 */

    case 160:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SAmode
   && reload_completed))
        return -1;
      return 2013; /* *fractusasa2 */

    case 161:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SAmode
   && reload_completed))
        return -1;
      return 2014; /* *fractdqsa2 */

    case 162:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode
   && reload_completed))
        return -1;
      return 2015; /* *fractudqsa2 */

    case 163:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SAmode
   && reload_completed))
        return -1;
      return 2016; /* *fractdasa2 */

    case 164:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode
   && reload_completed))
        return -1;
      return 2017; /* *fractudasa2 */

    case 165:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SAmode
   && reload_completed))
        return -1;
      return 2018; /* *fracttasa2 */

    case 166:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode
   && reload_completed))
        return -1;
      return 2019; /* *fractutasa2 */

    case 167:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != SAmode
   && reload_completed))
        return -1;
      return 2020; /* *fractqisa2 */

    case 168:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != SAmode
   && reload_completed))
        return -1;
      return 2021; /* *fracthisa2 */

    case 169:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != SAmode
   && reload_completed))
        return -1;
      return 2022; /* *fractsisa2 */

    case 170:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != SAmode
   && reload_completed))
        return -1;
      return 2023; /* *fractdisa2 */

    case 171:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USAmode
   && reload_completed))
        return -1;
      return 2024; /* *fractqqusa2 */

    case 172:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode
   && reload_completed))
        return -1;
      return 2025; /* *fractuqqusa2 */

    case 173:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USAmode
   && reload_completed))
        return -1;
      return 2026; /* *fracthqusa2 */

    case 174:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode
   && reload_completed))
        return -1;
      return 2027; /* *fractuhqusa2 */

    case 175:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USAmode
   && reload_completed))
        return -1;
      return 2028; /* *fracthausa2 */

    case 176:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode
   && reload_completed))
        return -1;
      return 2029; /* *fractuhausa2 */

    case 177:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USAmode
   && reload_completed))
        return -1;
      return 2030; /* *fractsqusa2 */

    case 178:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != USAmode
   && reload_completed))
        return -1;
      return 2031; /* *fractusqusa2 */

    case 179:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USAmode
   && reload_completed))
        return -1;
      return 2032; /* *fractsausa2 */

    case 180:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USAmode
   && reload_completed))
        return -1;
      return 2033; /* *fractdqusa2 */

    case 181:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode
   && reload_completed))
        return -1;
      return 2034; /* *fractudqusa2 */

    case 182:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USAmode
   && reload_completed))
        return -1;
      return 2035; /* *fractdausa2 */

    case 183:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode
   && reload_completed))
        return -1;
      return 2036; /* *fractudausa2 */

    case 184:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USAmode
   && reload_completed))
        return -1;
      return 2037; /* *fracttausa2 */

    case 185:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode
   && reload_completed))
        return -1;
      return 2038; /* *fractutausa2 */

    case 186:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != USAmode
   && reload_completed))
        return -1;
      return 2039; /* *fractqiusa2 */

    case 187:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != USAmode
   && reload_completed))
        return -1;
      return 2040; /* *fracthiusa2 */

    case 188:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != USAmode
   && reload_completed))
        return -1;
      return 2041; /* *fractsiusa2 */

    case 189:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != USAmode
   && reload_completed))
        return -1;
      return 2042; /* *fractdiusa2 */

    case 190:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DQmode
   && reload_completed))
        return -1;
      return 2043; /* *fractqqdq2 */

    case 191:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode
   && reload_completed))
        return -1;
      return 2044; /* *fractuqqdq2 */

    case 192:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DQmode
   && reload_completed))
        return -1;
      return 2045; /* *fracthqdq2 */

    case 193:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode
   && reload_completed))
        return -1;
      return 2046; /* *fractuhqdq2 */

    case 194:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DQmode
   && reload_completed))
        return -1;
      return 2047; /* *fracthadq2 */

    case 195:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode
   && reload_completed))
        return -1;
      return 2048; /* *fractuhadq2 */

    case 196:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DQmode
   && reload_completed))
        return -1;
      return 2049; /* *fractsqdq2 */

    case 197:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DQmode
   && reload_completed))
        return -1;
      return 2050; /* *fractusqdq2 */

    case 198:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DQmode
   && reload_completed))
        return -1;
      return 2051; /* *fractsadq2 */

    case 199:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DQmode
   && reload_completed))
        return -1;
      return 2052; /* *fractusadq2 */

    case 200:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode
   && reload_completed))
        return -1;
      return 2053; /* *fractudqdq2 */

    case 201:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DQmode
   && reload_completed))
        return -1;
      return 2054; /* *fractdadq2 */

    case 202:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode
   && reload_completed))
        return -1;
      return 2055; /* *fractudadq2 */

    case 203:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DQmode
   && reload_completed))
        return -1;
      return 2056; /* *fracttadq2 */

    case 204:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode
   && reload_completed))
        return -1;
      return 2057; /* *fractutadq2 */

    case 205:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != DQmode
   && reload_completed))
        return -1;
      return 2058; /* *fractqidq2 */

    case 206:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != DQmode
   && reload_completed))
        return -1;
      return 2059; /* *fracthidq2 */

    case 207:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != DQmode
   && reload_completed))
        return -1;
      return 2060; /* *fractsidq2 */

    case 208:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != DQmode
   && reload_completed))
        return -1;
      return 2061; /* *fractdidq2 */

    case 209:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode
   && reload_completed))
        return -1;
      return 2062; /* *fractqqudq2 */

    case 210:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode
   && reload_completed))
        return -1;
      return 2063; /* *fractuqqudq2 */

    case 211:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode
   && reload_completed))
        return -1;
      return 2064; /* *fracthqudq2 */

    case 212:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode
   && reload_completed))
        return -1;
      return 2065; /* *fractuhqudq2 */

    case 213:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode
   && reload_completed))
        return -1;
      return 2066; /* *fracthaudq2 */

    case 214:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode
   && reload_completed))
        return -1;
      return 2067; /* *fractuhaudq2 */

    case 215:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode
   && reload_completed))
        return -1;
      return 2068; /* *fractsqudq2 */

    case 216:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode
   && reload_completed))
        return -1;
      return 2069; /* *fractusqudq2 */

    case 217:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode
   && reload_completed))
        return -1;
      return 2070; /* *fractsaudq2 */

    case 218:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode
   && reload_completed))
        return -1;
      return 2071; /* *fractusaudq2 */

    case 219:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode
   && reload_completed))
        return -1;
      return 2072; /* *fractdqudq2 */

    case 220:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode
   && reload_completed))
        return -1;
      return 2073; /* *fractdaudq2 */

    case 221:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode
   && reload_completed))
        return -1;
      return 2074; /* *fractudaudq2 */

    case 222:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode
   && reload_completed))
        return -1;
      return 2075; /* *fracttaudq2 */

    case 223:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode
   && reload_completed))
        return -1;
      return 2076; /* *fractutaudq2 */

    case 224:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDQmode
   && reload_completed))
        return -1;
      return 2077; /* *fractqiudq2 */

    case 225:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDQmode
   && reload_completed))
        return -1;
      return 2078; /* *fracthiudq2 */

    case 226:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDQmode
   && reload_completed))
        return -1;
      return 2079; /* *fractsiudq2 */

    case 227:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDQmode
   && reload_completed))
        return -1;
      return 2080; /* *fractdiudq2 */

    case 228:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DAmode
   && reload_completed))
        return -1;
      return 2081; /* *fractqqda2 */

    case 229:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode
   && reload_completed))
        return -1;
      return 2082; /* *fractuqqda2 */

    case 230:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DAmode
   && reload_completed))
        return -1;
      return 2083; /* *fracthqda2 */

    case 231:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode
   && reload_completed))
        return -1;
      return 2084; /* *fractuhqda2 */

    case 232:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DAmode
   && reload_completed))
        return -1;
      return 2085; /* *fracthada2 */

    case 233:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode
   && reload_completed))
        return -1;
      return 2086; /* *fractuhada2 */

    case 234:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DAmode
   && reload_completed))
        return -1;
      return 2087; /* *fractsqda2 */

    case 235:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DAmode
   && reload_completed))
        return -1;
      return 2088; /* *fractusqda2 */

    case 236:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DAmode
   && reload_completed))
        return -1;
      return 2089; /* *fractsada2 */

    case 237:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DAmode
   && reload_completed))
        return -1;
      return 2090; /* *fractusada2 */

    case 238:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DAmode
   && reload_completed))
        return -1;
      return 2091; /* *fractdqda2 */

    case 239:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode
   && reload_completed))
        return -1;
      return 2092; /* *fractudqda2 */

    case 240:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode
   && reload_completed))
        return -1;
      return 2093; /* *fractudada2 */

    case 241:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DAmode
   && reload_completed))
        return -1;
      return 2094; /* *fracttada2 */

    case 242:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode
   && reload_completed))
        return -1;
      return 2095; /* *fractutada2 */

    case 243:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != DAmode
   && reload_completed))
        return -1;
      return 2096; /* *fractqida2 */

    case 244:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != DAmode
   && reload_completed))
        return -1;
      return 2097; /* *fracthida2 */

    case 245:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != DAmode
   && reload_completed))
        return -1;
      return 2098; /* *fractsida2 */

    case 246:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != DAmode
   && reload_completed))
        return -1;
      return 2099; /* *fractdida2 */

    case 247:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode
   && reload_completed))
        return -1;
      return 2100; /* *fractqquda2 */

    case 248:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode
   && reload_completed))
        return -1;
      return 2101; /* *fractuqquda2 */

    case 249:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode
   && reload_completed))
        return -1;
      return 2102; /* *fracthquda2 */

    case 250:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode
   && reload_completed))
        return -1;
      return 2103; /* *fractuhquda2 */

    case 251:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode
   && reload_completed))
        return -1;
      return 2104; /* *fracthauda2 */

    case 252:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode
   && reload_completed))
        return -1;
      return 2105; /* *fractuhauda2 */

    case 253:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode
   && reload_completed))
        return -1;
      return 2106; /* *fractsquda2 */

    case 254:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode
   && reload_completed))
        return -1;
      return 2107; /* *fractusquda2 */

    case 255:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode
   && reload_completed))
        return -1;
      return 2108; /* *fractsauda2 */

    case 256:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode
   && reload_completed))
        return -1;
      return 2109; /* *fractusauda2 */

    case 257:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode
   && reload_completed))
        return -1;
      return 2110; /* *fractdquda2 */

    case 258:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode
   && reload_completed))
        return -1;
      return 2111; /* *fractudquda2 */

    case 259:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode
   && reload_completed))
        return -1;
      return 2112; /* *fractdauda2 */

    case 260:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode
   && reload_completed))
        return -1;
      return 2113; /* *fracttauda2 */

    case 261:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode
   && reload_completed))
        return -1;
      return 2114; /* *fractutauda2 */

    case 262:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDAmode
   && reload_completed))
        return -1;
      return 2115; /* *fractqiuda2 */

    case 263:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDAmode
   && reload_completed))
        return -1;
      return 2116; /* *fracthiuda2 */

    case 264:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDAmode
   && reload_completed))
        return -1;
      return 2117; /* *fractsiuda2 */

    case 265:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDAmode
   && reload_completed))
        return -1;
      return 2118; /* *fractdiuda2 */

    case 266:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != TAmode
   && reload_completed))
        return -1;
      return 2119; /* *fractqqta2 */

    case 267:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode
   && reload_completed))
        return -1;
      return 2120; /* *fractuqqta2 */

    case 268:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != TAmode
   && reload_completed))
        return -1;
      return 2121; /* *fracthqta2 */

    case 269:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode
   && reload_completed))
        return -1;
      return 2122; /* *fractuhqta2 */

    case 270:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != TAmode
   && reload_completed))
        return -1;
      return 2123; /* *fracthata2 */

    case 271:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode
   && reload_completed))
        return -1;
      return 2124; /* *fractuhata2 */

    case 272:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != TAmode
   && reload_completed))
        return -1;
      return 2125; /* *fractsqta2 */

    case 273:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != TAmode
   && reload_completed))
        return -1;
      return 2126; /* *fractusqta2 */

    case 274:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != TAmode
   && reload_completed))
        return -1;
      return 2127; /* *fractsata2 */

    case 275:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != TAmode
   && reload_completed))
        return -1;
      return 2128; /* *fractusata2 */

    case 276:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != TAmode
   && reload_completed))
        return -1;
      return 2129; /* *fractdqta2 */

    case 277:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode
   && reload_completed))
        return -1;
      return 2130; /* *fractudqta2 */

    case 278:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != TAmode
   && reload_completed))
        return -1;
      return 2131; /* *fractdata2 */

    case 279:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode
   && reload_completed))
        return -1;
      return 2132; /* *fractudata2 */

    case 280:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode
   && reload_completed))
        return -1;
      return 2133; /* *fractutata2 */

    case 281:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != TAmode
   && reload_completed))
        return -1;
      return 2134; /* *fractqita2 */

    case 282:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != TAmode
   && reload_completed))
        return -1;
      return 2135; /* *fracthita2 */

    case 283:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != TAmode
   && reload_completed))
        return -1;
      return 2136; /* *fractsita2 */

    case 284:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != TAmode
   && reload_completed))
        return -1;
      return 2137; /* *fractdita2 */

    case 285:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode
   && reload_completed))
        return -1;
      return 2138; /* *fractqquta2 */

    case 286:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode
   && reload_completed))
        return -1;
      return 2139; /* *fractuqquta2 */

    case 287:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode
   && reload_completed))
        return -1;
      return 2140; /* *fracthquta2 */

    case 288:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode
   && reload_completed))
        return -1;
      return 2141; /* *fractuhquta2 */

    case 289:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode
   && reload_completed))
        return -1;
      return 2142; /* *fracthauta2 */

    case 290:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode
   && reload_completed))
        return -1;
      return 2143; /* *fractuhauta2 */

    case 291:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode
   && reload_completed))
        return -1;
      return 2144; /* *fractsquta2 */

    case 292:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode
   && reload_completed))
        return -1;
      return 2145; /* *fractusquta2 */

    case 293:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode
   && reload_completed))
        return -1;
      return 2146; /* *fractsauta2 */

    case 294:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode
   && reload_completed))
        return -1;
      return 2147; /* *fractusauta2 */

    case 295:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode
   && reload_completed))
        return -1;
      return 2148; /* *fractdquta2 */

    case 296:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode
   && reload_completed))
        return -1;
      return 2149; /* *fractudquta2 */

    case 297:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode
   && reload_completed))
        return -1;
      return 2150; /* *fractdauta2 */

    case 298:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode
   && reload_completed))
        return -1;
      return 2151; /* *fractudauta2 */

    case 299:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode
   && reload_completed))
        return -1;
      return 2152; /* *fracttauta2 */

    case 300:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UTAmode
   && reload_completed))
        return -1;
      return 2153; /* *fractqiuta2 */

    case 301:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UTAmode
   && reload_completed))
        return -1;
      return 2154; /* *fracthiuta2 */

    case 302:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UTAmode
   && reload_completed))
        return -1;
      return 2155; /* *fractsiuta2 */

    case 303:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UTAmode
   && reload_completed))
        return -1;
      return 2156; /* *fractdiuta2 */

    case 304:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != QImode
   && reload_completed))
        return -1;
      return 2157; /* *fractqqqi2 */

    case 305:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QImode
   && reload_completed))
        return -1;
      return 2158; /* *fractuqqqi2 */

    case 306:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QImode
   && reload_completed))
        return -1;
      return 2159; /* *fracthqqi2 */

    case 307:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QImode
   && reload_completed))
        return -1;
      return 2160; /* *fractuhqqi2 */

    case 308:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QImode
   && reload_completed))
        return -1;
      return 2161; /* *fracthaqi2 */

    case 309:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QImode
   && reload_completed))
        return -1;
      return 2162; /* *fractuhaqi2 */

    case 310:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QImode
   && reload_completed))
        return -1;
      return 2163; /* *fractsqqi2 */

    case 311:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QImode
   && reload_completed))
        return -1;
      return 2164; /* *fractusqqi2 */

    case 312:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QImode
   && reload_completed))
        return -1;
      return 2165; /* *fractsaqi2 */

    case 313:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QImode
   && reload_completed))
        return -1;
      return 2166; /* *fractusaqi2 */

    case 314:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QImode
   && reload_completed))
        return -1;
      return 2167; /* *fractdqqi2 */

    case 315:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QImode
   && reload_completed))
        return -1;
      return 2168; /* *fractudqqi2 */

    case 316:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QImode
   && reload_completed))
        return -1;
      return 2169; /* *fractdaqi2 */

    case 317:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QImode
   && reload_completed))
        return -1;
      return 2170; /* *fractudaqi2 */

    case 318:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QImode
   && reload_completed))
        return -1;
      return 2171; /* *fracttaqi2 */

    case 319:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QImode
   && reload_completed))
        return -1;
      return 2172; /* *fractutaqi2 */

    case 320:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != QImode
   && reload_completed))
        return -1;
      return 2173; /* *fracthiqi2 */

    case 321:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != QImode
   && reload_completed))
        return -1;
      return 2174; /* *fractsiqi2 */

    case 322:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != QImode
   && reload_completed))
        return -1;
      return 2175; /* *fractdiqi2 */

    case 323:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HImode
   && reload_completed))
        return -1;
      return 2176; /* *fractqqhi2 */

    case 324:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HImode
   && reload_completed))
        return -1;
      return 2177; /* *fractuqqhi2 */

    case 325:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HImode
   && reload_completed))
        return -1;
      return 2178; /* *fracthqhi2 */

    case 326:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HImode
   && reload_completed))
        return -1;
      return 2179; /* *fractuhqhi2 */

    case 327:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HImode
   && reload_completed))
        return -1;
      return 2180; /* *fracthahi2 */

    case 328:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HImode
   && reload_completed))
        return -1;
      return 2181; /* *fractuhahi2 */

    case 329:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HImode
   && reload_completed))
        return -1;
      return 2182; /* *fractsqhi2 */

    case 330:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HImode
   && reload_completed))
        return -1;
      return 2183; /* *fractusqhi2 */

    case 331:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HImode
   && reload_completed))
        return -1;
      return 2184; /* *fractsahi2 */

    case 332:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HImode
   && reload_completed))
        return -1;
      return 2185; /* *fractusahi2 */

    case 333:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HImode
   && reload_completed))
        return -1;
      return 2186; /* *fractdqhi2 */

    case 334:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HImode
   && reload_completed))
        return -1;
      return 2187; /* *fractudqhi2 */

    case 335:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HImode
   && reload_completed))
        return -1;
      return 2188; /* *fractdahi2 */

    case 336:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HImode
   && reload_completed))
        return -1;
      return 2189; /* *fractudahi2 */

    case 337:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HImode
   && reload_completed))
        return -1;
      return 2190; /* *fracttahi2 */

    case 338:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HImode
   && reload_completed))
        return -1;
      return 2191; /* *fractutahi2 */

    case 339:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != HImode
   && reload_completed))
        return -1;
      return 2192; /* *fractqihi2 */

    case 340:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != HImode
   && reload_completed))
        return -1;
      return 2193; /* *fractsihi2 */

    case 341:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != HImode
   && reload_completed))
        return -1;
      return 2194; /* *fractdihi2 */

    case 342:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SImode
   && reload_completed))
        return -1;
      return 2195; /* *fractqqsi2 */

    case 343:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SImode
   && reload_completed))
        return -1;
      return 2196; /* *fractuqqsi2 */

    case 344:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SImode
   && reload_completed))
        return -1;
      return 2197; /* *fracthqsi2 */

    case 345:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SImode
   && reload_completed))
        return -1;
      return 2198; /* *fractuhqsi2 */

    case 346:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SImode
   && reload_completed))
        return -1;
      return 2199; /* *fracthasi2 */

    case 347:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SImode
   && reload_completed))
        return -1;
      return 2200; /* *fractuhasi2 */

    case 348:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SImode
   && reload_completed))
        return -1;
      return 2201; /* *fractsqsi2 */

    case 349:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SImode
   && reload_completed))
        return -1;
      return 2202; /* *fractusqsi2 */

    case 350:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SImode
   && reload_completed))
        return -1;
      return 2203; /* *fractsasi2 */

    case 351:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SImode
   && reload_completed))
        return -1;
      return 2204; /* *fractusasi2 */

    case 352:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SImode
   && reload_completed))
        return -1;
      return 2205; /* *fractdqsi2 */

    case 353:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SImode
   && reload_completed))
        return -1;
      return 2206; /* *fractudqsi2 */

    case 354:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SImode
   && reload_completed))
        return -1;
      return 2207; /* *fractdasi2 */

    case 355:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SImode
   && reload_completed))
        return -1;
      return 2208; /* *fractudasi2 */

    case 356:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SImode
   && reload_completed))
        return -1;
      return 2209; /* *fracttasi2 */

    case 357:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SImode
   && reload_completed))
        return -1;
      return 2210; /* *fractutasi2 */

    case 358:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != SImode
   && reload_completed))
        return -1;
      return 2211; /* *fractqisi2 */

    case 359:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != SImode
   && reload_completed))
        return -1;
      return 2212; /* *fracthisi2 */

    case 360:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != SImode
   && reload_completed))
        return -1;
      return 2213; /* *fractdisi2 */

    case 361:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DImode
   && reload_completed))
        return -1;
      return 2214; /* *fractqqdi2 */

    case 362:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DImode
   && reload_completed))
        return -1;
      return 2215; /* *fractuqqdi2 */

    case 363:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DImode
   && reload_completed))
        return -1;
      return 2216; /* *fracthqdi2 */

    case 364:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DImode
   && reload_completed))
        return -1;
      return 2217; /* *fractuhqdi2 */

    case 365:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DImode
   && reload_completed))
        return -1;
      return 2218; /* *fracthadi2 */

    case 366:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DImode
   && reload_completed))
        return -1;
      return 2219; /* *fractuhadi2 */

    case 367:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DImode
   && reload_completed))
        return -1;
      return 2220; /* *fractsqdi2 */

    case 368:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DImode
   && reload_completed))
        return -1;
      return 2221; /* *fractusqdi2 */

    case 369:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DImode
   && reload_completed))
        return -1;
      return 2222; /* *fractsadi2 */

    case 370:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DImode
   && reload_completed))
        return -1;
      return 2223; /* *fractusadi2 */

    case 371:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DImode
   && reload_completed))
        return -1;
      return 2224; /* *fractdqdi2 */

    case 372:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DImode
   && reload_completed))
        return -1;
      return 2225; /* *fractudqdi2 */

    case 373:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DImode
   && reload_completed))
        return -1;
      return 2226; /* *fractdadi2 */

    case 374:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DImode
   && reload_completed))
        return -1;
      return 2227; /* *fractudadi2 */

    case 375:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DImode
   && reload_completed))
        return -1;
      return 2228; /* *fracttadi2 */

    case 376:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DImode
   && reload_completed))
        return -1;
      return 2229; /* *fractutadi2 */

    case 377:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != DImode
   && reload_completed))
        return -1;
      return 2230; /* *fractqidi2 */

    case 378:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != DImode
   && reload_completed))
        return -1;
      return 2231; /* *fracthidi2 */

    case 379:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != DImode
   && reload_completed))
        return -1;
      return 2232; /* *fractsidi2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      switch (pattern86 (x1))
        {
        case 0:
          if (!(
#line 10128 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))) && 
#line 10130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_666 (insn, operands);

        case 1:
          if (!(
#line 10504 "../../gcc/config/avr/avr.md"
(! reload_completed
   && ((1 << INTVAL (operands[3])) & INTVAL (operands[2])) != 0) && 
#line 10507 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_742 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern168 (x2))
        {
        case 0:
          if (
#line 10382 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_720 (insn, operands);
          break;

        case 1:
          if (
#line 10382 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_721 (insn, operands);
          break;

        case 2:
          if (
#line 10382 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_722 (insn, operands);
          break;

        case 3:
          if (
#line 10382 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_723 (insn, operands);
          break;

        case 4:
          return gen_split_724 (insn, operands);

        case 5:
          return gen_split_725 (insn, operands);

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG)
        return NULL;
      switch (pattern128 (x1))
        {
        case 0:
          if (!(
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10487 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_730 (insn, operands);

        case 1:
          if (!(
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10487 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_734 (insn, operands);

        case 2:
          if (!(
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10487 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_738 (insn, operands);

        case 3:
          if (!(
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10487 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_731 (insn, operands);

        case 4:
          if (!(
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10487 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_735 (insn, operands);

        case 5:
          if (!(
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10487 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_739 (insn, operands);

        case 6:
          if (!(
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10487 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_732 (insn, operands);

        case 7:
          if (!(
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10487 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_736 (insn, operands);

        case 8:
          if (!(
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10487 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_740 (insn, operands);

        case 9:
          if (!(
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10487 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_733 (insn, operands);

        case 10:
          if (!(
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10487 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_737 (insn, operands);

        case 11:
          if (!(
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10487 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_741 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      if (pattern87 (x1) != 0
          || !
#line 10436 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_726 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG)
        return NULL;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case MEM:
          if (pattern95 (x3) != 0)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 21
              || GET_MODE (x7) != E_QImode)
            return NULL;
          switch (pattern363 (x1))
            {
            case 0:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_47 (insn, operands);

            case 1:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_48 (insn, operands);

            case 2:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_49 (insn, operands);

            case 3:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_50 (insn, operands);

            case 4:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_51 (insn, operands);

            case 5:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_52 (insn, operands);

            case 6:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_53 (insn, operands);

            case 7:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_54 (insn, operands);

            case 8:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_55 (insn, operands);

            case 9:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_56 (insn, operands);

            case 10:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_57 (insn, operands);

            case 11:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_58 (insn, operands);

            case 12:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_59 (insn, operands);

            case 13:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_60 (insn, operands);

            case 14:
              if (!(
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_61 (insn, operands);

            default:
              return NULL;
            }

        case MULT:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          x8 = XEXP (x5, 0);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) == REG)
                {
                  switch (pattern255 (x1))
                    {
                    case 0:
                      if ((
#line 2432 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 2434 "../../gcc/config/avr/avr.md"
( reload_completed)))
                        return gen_split_270 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL) && 
#line 678 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                        return gen_split_1948 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (GET_MODE (x8) != E_SImode)
                return NULL;
              switch (pattern259 (x1))
                {
                case 0:
                  if (!(
#line 3478 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3480 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_314 (insn, operands);

                case 1:
                  if (!(
#line 3478 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3480 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_315 (insn, operands);

                case 2:
                  if (!(
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_320 (insn, operands);

                case 3:
                  if (!(
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_328 (insn, operands);

                case 4:
                  if (!(
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_324 (insn, operands);

                case 5:
                  if (!(
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_332 (insn, operands);

                case 6:
                  if (!(
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_322 (insn, operands);

                case 7:
                  if (!(
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_330 (insn, operands);

                case 8:
                  if (!(
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_326 (insn, operands);

                case 9:
                  if (!(
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_334 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              if (GET_CODE (x8) == REG
                  && REGNO (x8) == 24)
                {
                  res = split_30 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              operands[1] = x8;
              switch (pattern252 (x1))
                {
                case 0:
                  if (!(
#line 3398 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3400 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_312 (insn, operands);

                case 1:
                  if (!(
#line 4192 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 4194 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_356 (insn, operands);

                default:
                  return NULL;
                }

            case SIGN_EXTEND:
              if (REGNO (x7) != 26
                  || GET_MODE (x7) != E_HImode)
                return NULL;
              if (REGNO (x4) == 18)
                {
                  switch (pattern292 (x1))
                    {
                    case 0:
                      if ((
#line 3530 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3532 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_316 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 3530 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3532 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_317 (insn, operands);
                      break;

                    case 2:
                      if ((
#line 4173 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 4175 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_355 (insn, operands);
                      break;

                    case 3:
                      if ((
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_319 (insn, operands);
                      break;

                    case 4:
                      if ((
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_327 (insn, operands);
                      break;

                    case 5:
                      if ((
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_323 (insn, operands);
                      break;

                    case 6:
                      if ((
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_331 (insn, operands);
                      break;

                    case 7:
                      if ((
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_321 (insn, operands);
                      break;

                    case 8:
                      if ((
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_329 (insn, operands);
                      break;

                    case 9:
                      if ((
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_325 (insn, operands);
                      break;

                    case 10:
                      if ((
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc/config/avr/avr.md"
( 1)))
                        return gen_split_333 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != REG
                  || pattern293 (x1) != 0
                  || !(
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL) && 
#line 678 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1947 (insn, operands);

            case NOT:
              if (pattern233 (x1) != 0
                  || !(
#line 3589 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3591 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_318 (insn, operands);

            default:
              return NULL;
            }

        case UDIV:
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != REG)
            return NULL;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG)
            return NULL;
          switch (REGNO (x8))
            {
            case 24:
              switch (pattern263 (x1))
                {
                case 0:
                  if (!
#line 3962 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_348 (insn, operands);

                case 1:
                  if (!
#line 610 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1826 (insn, operands);

                case 2:
                  if (!
#line 610 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1828 (insn, operands);

                default:
                  return NULL;
                }

            case 26:
              switch (pattern266 (x1))
                {
                case 0:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1818 (insn, operands);

                case 1:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1820 (insn, operands);

                case 2:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1822 (insn, operands);

                case 3:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1824 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case XOR:
          switch (pattern170 (x1))
            {
            case 0:
              if (!
#line 4910 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_387 (insn, operands);

            case 1:
              if (!
#line 4910 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_390 (insn, operands);

            case 2:
              if (!
#line 4910 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_393 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern170 (x1))
            {
            case 0:
              if (!
#line 4910 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_388 (insn, operands);

            case 1:
              if (!
#line 4910 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_391 (insn, operands);

            case 2:
              if (!
#line 4910 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_394 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern170 (x1))
            {
            case 0:
              if (!
#line 4910 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_389 (insn, operands);

            case 1:
              if (!
#line 4910 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_392 (insn, operands);

            case 2:
              if (!
#line 4910 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_395 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern172 (x1))
            {
            case 0:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_468 (insn, operands);

            case 1:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_471 (insn, operands);

            case 2:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3r (operands[2])))
                return NULL;
              return gen_split_474 (insn, operands);

            case 3:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_477 (insn, operands);

            case 4:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_480 (insn, operands);

            case 5:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_483 (insn, operands);

            case 6:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_486 (insn, operands);

            case 7:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_489 (insn, operands);

            case 8:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_492 (insn, operands);

            case 9:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_495 (insn, operands);

            case 10:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_498 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern172 (x1))
            {
            case 0:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_469 (insn, operands);

            case 1:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_472 (insn, operands);

            case 2:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3a (operands[2])))
                return NULL;
              return gen_split_475 (insn, operands);

            case 3:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_478 (insn, operands);

            case 4:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_481 (insn, operands);

            case 5:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_484 (insn, operands);

            case 6:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_487 (insn, operands);

            case 7:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_490 (insn, operands);

            case 8:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_493 (insn, operands);

            case 9:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_496 (insn, operands);

            case 10:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_499 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern172 (x1))
            {
            case 0:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_470 (insn, operands);

            case 1:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_473 (insn, operands);

            case 2:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3l (operands[2])))
                return NULL;
              return gen_split_476 (insn, operands);

            case 3:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_479 (insn, operands);

            case 4:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_482 (insn, operands);

            case 5:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_485 (insn, operands);

            case 6:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_488 (insn, operands);

            case 7:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_491 (insn, operands);

            case 8:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_494 (insn, operands);

            case 9:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_497 (insn, operands);

            case 10:
              if (!
#line 5615 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_500 (insn, operands);

            default:
              return NULL;
            }

        case TRUNCATE:
          if (pattern98 (x3, 
24, 
E_HImode) != 0)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || pattern297 (x1, 
E_QImode, 
26, 
22) != 0)
            return NULL;
          x8 = XEXP (x5, 0);
          switch (pattern341 (x8))
            {
            case 0:
              if (!
#line 9470 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_649 (insn, operands);

            case 1:
              if (!
#line 9542 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_651 (insn, operands);

            default:
              return NULL;
            }

        case DIV:
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != REG)
            return NULL;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern91 (x6, 
26, 
E_HImode) != 0)
            return NULL;
          switch (REGNO (x8))
            {
            case 26:
              if (REGNO (x10) != 22
                  || REGNO (x11) != 24)
                return NULL;
              switch (pattern264 (x1, 
E_QImode, 
21))
                {
                case 0:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1819 (insn, operands);

                case 1:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1821 (insn, operands);

                case 2:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1823 (insn, operands);

                case 3:
                  if (!
#line 562 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1825 (insn, operands);

                default:
                  return NULL;
                }

            case 24:
              if (REGNO (x10) != 18
                  || REGNO (x11) != 22)
                return NULL;
              switch (pattern261 (x1))
                {
                case 0:
                  if (!
#line 610 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1827 (insn, operands);

                case 1:
                  if (!
#line 610 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1829 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 10)
        return NULL;
      x12 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x12) != CONST_INT)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return NULL;
      x13 = XEXP (x6, 1);
      if (pattern94 (x13) != 0)
        return NULL;
      x14 = XVECEXP (x3, 0, 0);
      operands[0] = x14;
      switch (pattern234 (x1))
        {
        case 0:
          if (!
#line 8742 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_624 (insn, operands);

        case 1:
          if (!
#line 8774 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_625 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
