/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x8 = XEXP (x1, 1);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode
          || GET_MODE (x4) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || GET_MODE (x2) != E_PSImode
          || GET_MODE (x3) != E_PSImode)
        return -1;
      res = pattern0 (x4);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      res = pattern1 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 24)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 24)
    return -1;
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 0;

    case E_QImode:
      if (GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 0
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  return 0;
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case AND:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !nonmemory_operand (operands[2], E_HImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x2) != E_PSImode
              || GET_MODE (x3) != E_PSImode
              || !nonmemory_operand (operands[2], E_PSImode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 2;

            case E_HImode:
              if (!register_operand (operands[1], E_HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || !nonmemory_operand (operands[2], E_SImode))
            return -1;
          res = pattern30 (x4);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || GET_MODE (x5) != E_DQmode)
            return -1;
          return 0;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || GET_MODE (x5) != E_DAmode)
            return -1;
          return 1;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || GET_MODE (x5) != E_TAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || !const_operand (operands[0], E_DQmode))
            return -1;
          return 3;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || !const_operand (operands[0], E_DAmode))
            return -1;
          return 4;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || !const_operand (operands[0], E_TAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern72 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern58 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern58 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_PSImode:
      if (pattern50 (x3, pnum_clobbers, 
E_PSImode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern58 (x3, 
E_SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          return pattern77 (x1, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern77 (x1, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_PSImode:
          if (pattern77 (x1, 
E_PSImode) != 0)
            return -1;
          return 2;

        case E_SImode:
          if (pattern77 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern79 (x1);
      if (res >= 0)
        return res + 4; /* [4, 9] */
      return -1;

    case ZERO_EXTEND:
      res = pattern79 (x1);
      if (res >= 0)
        return res + 10; /* [10, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC_VOLATILE
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 6
      || GET_MODE (x1) != E_BLKmode)
    return -1;
  return 0;
}

int
pattern98 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != i2)
    return -1;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode
      || !register_operand (operands[1], E_PSImode)
      || !nonmemory_operand (operands[2], E_QImode)
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 24
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 24
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 26
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  return pattern107 (x8); /* [-1, 0] */
}

int
pattern117 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XEXP (x1, 1);
      if (!register_operand (x5, E_HImode))
        return -1;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_HImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          operands[3] = x5;
          return 0;

        case SIGN_EXTEND:
          if (GET_MODE (x6) != E_HImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          operands[3] = x5;
          return 1;

        case CONST_INT:
          return 2;

        default:
          return -1;
        }

    case AND:
      x8 = XEXP (x4, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      res = pattern78 (x1);
      if (res >= 0)
        return res + 3; /* [3, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x8 = XEXP (x6, 2);
  operands[3] = x8;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 22)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22)
    return -1;
  return 0;
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nop_general_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode
          || !register_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode
          || !register_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x3) != E_HImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern177 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || !register_operand (operands[3], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern182 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!pseudo_register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!pseudo_register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i3
      || GET_MODE (x5) != i1
      || pattern184 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 18)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  return 0;
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  return 0;
}

int
pattern201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_or_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case LSHIFTRT:
      return pattern203 (x3); /* [-1, 2] */

    case ASHIFTRT:
      res = pattern203 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern211 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  return 0;
}

int
pattern215 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG)
    return -1;
  return 0;
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[3], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      return 0;

    case SIGN_EXTEND:
      if (pattern222 (x1) != 0)
        return -1;
      return 1;

    case ZERO_EXTEND:
      if (pattern222 (x1) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern229 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i4
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i3
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern234 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  x7 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XVECEXP (x8, 0, 1);
  switch (XWINT (x9, 0))
    {
    case 1L:
      if (!const_int_operand (operands[0], E_QImode)
          || !scratch_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case 2L:
      if (!const_int_operand (operands[0], E_HImode)
          || !scratch_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern235 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (XINT (x5, 1) != 6
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return pattern234 (x1); /* [-1, 1] */
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern240 (x5, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!scratch_operand (operands[3], E_HImode))
            return -1;
          return 1;

        case E_QImode:
          if (!scratch_operand (operands[3], E_QImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_PSImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern240 (x5, 
E_PSImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern251 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !pseudo_register_operand (operands[1], i1)
      || !pseudo_register_or_const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern255 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  return pattern254 (x1); /* [-1, 1] */
}

int
pattern258 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      return pattern257 (
E_QImode); /* [-1, 1] */

    case E_HImode:
      res = pattern257 (
E_HImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != 22)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 24)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  return pattern265 (x1, 
E_QImode, 
21, 
26); /* [-1, 3] */
}

int
pattern272 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode
      || !register_operand (operands[1], E_QImode)
      || !single_zero_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern276 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_HImode))
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_HImode))
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !scratch_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !scratch_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern284 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern287 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern293 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 22
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 18
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  if (REGNO (x10) != 30
      || GET_MODE (x10) != E_HImode
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 1;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 2;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 3;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 4;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 5;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 6;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 7;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 8;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern327 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[1] = x5;
  if (!const_int_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!register_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x7, 1);
  operands[5] = x9;
  if (!const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern332 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern329 (x1); /* [-1, 2] */
}

int
pattern339 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x4, 0);
  operands[2] = x10;
  switch (GET_MODE (x7))
    {
    case E_HImode:
      if (!register_operand (operands[3], E_HImode)
          || GET_MODE (x8) != E_HImode
          || !register_operand (operands[4], E_QImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x4) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[3], E_PSImode)
          || GET_MODE (x8) != E_PSImode
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x4) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          if (!register_operand (operands[4], E_QImode)
              || !register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[4], E_HImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[3], E_SImode)
          || GET_MODE (x8) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          if (!register_operand (operands[4], E_QImode)
              || !register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[4], E_HImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[4], E_PSImode)
              || !register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern369 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[3] = x6;
  x7 = XEXP (x5, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != IF_THEN_ELSE)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != LABEL_REF)
    return -1;
  x11 = XEXP (x9, 2);
  if (GET_CODE (x11) != PC)
    return -1;
  x12 = XEXP (x8, 0);
  if (GET_CODE (x12) != PC)
    return -1;
  x13 = XEXP (x10, 0);
  operands[2] = x13;
  return 0;
}

int
pattern380 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  return pattern376 (x4, 
i1); /* [-1, 5] */
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == REG
      && REGNO (x2) == 22)
    {
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (pattern147 (x2))
        {
        case 0:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 5; /* load_qi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 20; /* *load_qi_libgcc */
            }
          break;

        case 1:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 6; /* load_qq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 21; /* *load_qq_libgcc */
            }
          break;

        case 2:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 7; /* load_uqq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 22; /* *load_uqq_libgcc */
            }
          break;

        case 3:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 8; /* load_hi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 23; /* *load_hi_libgcc */
            }
          break;

        case 4:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 9; /* load_hq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 24; /* *load_hq_libgcc */
            }
          break;

        case 5:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 10; /* load_uhq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 25; /* *load_uhq_libgcc */
            }
          break;

        case 6:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 11; /* load_ha_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 26; /* *load_ha_libgcc */
            }
          break;

        case 7:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 12; /* load_uha_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 27; /* *load_uha_libgcc */
            }
          break;

        case 8:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 13; /* load_si_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 28; /* *load_si_libgcc */
            }
          break;

        case 9:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 14; /* load_sq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 29; /* *load_sq_libgcc */
            }
          break;

        case 10:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 15; /* load_usq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 30; /* *load_usq_libgcc */
            }
          break;

        case 11:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 16; /* load_sa_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 31; /* *load_sa_libgcc */
            }
          break;

        case 12:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 17; /* load_usa_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 32; /* *load_usa_libgcc */
            }
          break;

        case 13:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 18; /* load_sf_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 33; /* *load_sf_libgcc */
            }
          break;

        case 14:
          if (
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 19; /* load_psi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 34; /* *load_psi_libgcc */
            }
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern111 (x3))
    {
    case 0:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 35; /* fxmovqi_A */

    case 1:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 36; /* fxmovqq_A */

    case 2:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 37; /* fxmovuqq_A */

    case 3:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 38; /* fxmovhi_A */

    case 4:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 39; /* fxmovhq_A */

    case 5:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 40; /* fxmovuhq_A */

    case 6:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 41; /* fxmovha_A */

    case 7:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 42; /* fxmovuha_A */

    case 8:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 43; /* fxmovsi_A */

    case 9:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 44; /* fxmovsq_A */

    case 10:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 45; /* fxmovusq_A */

    case 11:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 46; /* fxmovsa_A */

    case 12:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 47; /* fxmovusa_A */

    case 13:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 48; /* fxmovsf_A */

    case 14:
      if (!
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 49; /* fxmovpsi_A */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern65 (x2))
        {
        case 0:
          return 172; /* *strlenhi_split */

        case 1:
          return 1011; /* insert_bits */

        case 2:
          return 3103; /* roundqq3_const */

        case 3:
          return 3104; /* roundhq3_const */

        case 4:
          return 3105; /* roundha3_const */

        case 5:
          return 3106; /* roundsa3_const */

        case 6:
          return 3107; /* roundsq3_const */

        case 7:
          return 3108; /* rounduqq3_const */

        case 8:
          return 3109; /* rounduhq3_const */

        case 9:
          return 3110; /* rounduha3_const */

        case 10:
          return 3111; /* roundusa3_const */

        case 11:
          return 3112; /* roundusq3_const */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 3:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9698 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1057; /* fmul_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9713 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1058; /* *fmul_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern148 (x1) != 0)
            return -1;
          if (
#line 9724 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1059; /* *fmul.call_split */
            }
          if (!
#line 9739 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1060; /* *fmul.call */

        case 4:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9770 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1061; /* fmuls_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9785 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1062; /* *fmuls_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern148 (x1) != 0)
            return -1;
          if (
#line 9796 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1063; /* *fmuls.call_split */
            }
          if (!
#line 9811 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1064; /* *fmuls.call */

        case 5:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9842 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1065; /* fmulsu_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9857 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1066; /* *fmulsu_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern148 (x1) != 0)
            return -1;
          if (
#line 9868 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1067; /* *fmulsu.call_split */
            }
          if (!
#line 9883 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1068; /* *fmulsu.call */

        case 7:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != REG)
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 24
              || GET_MODE (x5) != E_QImode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG)
            return -1;
          switch (REGNO (x4))
            {
            case 22:
              if (REGNO (x3) != 24)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_QQmode:
                  if (GET_MODE (x2) != E_QQmode
                      || GET_MODE (x4) != E_QQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3123; /* *roundqq3.libgcc_split */

                case E_UQQmode:
                  if (GET_MODE (x2) != E_UQQmode
                      || GET_MODE (x4) != E_UQQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3124; /* *rounduqq3.libgcc_split */

                case E_HQmode:
                  if (GET_MODE (x2) != E_HQmode
                      || GET_MODE (x4) != E_HQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3127; /* *roundhq3.libgcc_split */

                case E_UHQmode:
                  if (GET_MODE (x2) != E_UHQmode
                      || GET_MODE (x4) != E_UHQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3128; /* *rounduhq3.libgcc_split */

                case E_HAmode:
                  if (GET_MODE (x2) != E_HAmode
                      || GET_MODE (x4) != E_HAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3129; /* *roundha3.libgcc_split */

                case E_UHAmode:
                  if (GET_MODE (x2) != E_UHAmode
                      || GET_MODE (x4) != E_UHAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3130; /* *rounduha3.libgcc_split */

                default:
                  return -1;
                }

            case 18:
              if (REGNO (x3) != 22)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_SQmode:
                  if (GET_MODE (x2) != E_SQmode
                      || GET_MODE (x4) != E_SQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3135; /* *roundsq3.libgcc_split */

                case E_USQmode:
                  if (GET_MODE (x2) != E_USQmode
                      || GET_MODE (x4) != E_USQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3136; /* *roundusq3.libgcc_split */

                case E_SAmode:
                  if (GET_MODE (x2) != E_SAmode
                      || GET_MODE (x4) != E_SAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3137; /* *roundsa3.libgcc_split */

                case E_USAmode:
                  if (GET_MODE (x2) != E_USAmode
                      || GET_MODE (x4) != E_USAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3138; /* *roundusa3.libgcc_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern14 (x1))
    {
    case 0:
      return 191; /* *udiff_widenqihi3_split */

    case 1:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      res = recog_8 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern70 (x1))
        {
        case 0:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3173; /* subdi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3180; /* *subdi3_insn */

        case 1:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3174; /* subdq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3181; /* *subdq3_insn */

        case 2:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3175; /* subudq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3182; /* *subudq3_insn */

        case 3:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3176; /* subda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3183; /* *subda3_insn */

        case 4:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3177; /* subuda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3184; /* *subuda3_insn */

        case 5:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3178; /* subta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3185; /* *subta3_insn */

        case 6:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3179; /* subuta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3186; /* *subuta3_insn */

        case 7:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3187; /* subdi3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3194; /* *subdi3_const_insn */

        case 8:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3188; /* subdq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3195; /* *subdq3_const_insn */

        case 9:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3189; /* subudq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3196; /* *subudq3_const_insn */

        case 10:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3190; /* subda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3197; /* *subda3_const_insn */

        case 11:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3191; /* subuda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3198; /* *subuda3_const_insn */

        case 12:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3192; /* subta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3199; /* *subta3_const_insn */

        case 13:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3193; /* subuta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3200; /* *subuta3_const_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x1, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTRACT:
          if (pattern126 (x1) == 0)
            return 1081; /* *insv.extract */
          break;

        case REG:
        case SUBREG:
          operands[0] = x5;
          operands[1] = x4;
          switch (pattern168 (x2))
            {
            case 0:
              return 1145; /* *extzvqi_split */

            case 1:
              return 1146; /* *extzvhi_split */

            case 2:
              return 1147; /* *extzvpsi_split */

            case 3:
              return 1148; /* *extzvsi_split */

            case 4:
              return 1153; /* *extzv.qihi1 */

            case 5:
              return 1154; /* *extzv.qihi1 */

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG)
        return -1;
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 0 + INTVAL (operands[3])))
            return -1;
          return 1160; /* *extzv.hi.subreg0 */

        case 1:
          if (!
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 0 + INTVAL (operands[3])))
            return -1;
          return 1164; /* *extzv.psi.subreg0 */

        case 2:
          if (!
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 0 + INTVAL (operands[3])))
            return -1;
          return 1168; /* *extzv.si.subreg0 */

        case 3:
          if (!
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 1 + INTVAL (operands[3])))
            return -1;
          return 1161; /* *extzv.hi.subreg1 */

        case 4:
          if (!
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 1 + INTVAL (operands[3])))
            return -1;
          return 1165; /* *extzv.psi.subreg1 */

        case 5:
          if (!
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 1 + INTVAL (operands[3])))
            return -1;
          return 1169; /* *extzv.si.subreg1 */

        case 6:
          if (!
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 2 + INTVAL (operands[3])))
            return -1;
          return 1162; /* *extzv.hi.subreg2 */

        case 7:
          if (!
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 2 + INTVAL (operands[3])))
            return -1;
          return 1166; /* *extzv.psi.subreg2 */

        case 8:
          if (!
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 2 + INTVAL (operands[3])))
            return -1;
          return 1170; /* *extzv.si.subreg2 */

        case 9:
          if (!
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 3 + INTVAL (operands[3])))
            return -1;
          return 1163; /* *extzv.hi.subreg3 */

        case 10:
          if (!
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 3 + INTVAL (operands[3])))
            return -1;
          return 1167; /* *extzv.psi.subreg3 */

        case 11:
          if (!
#line 10481 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 3 + INTVAL (operands[3])))
            return -1;
          return 1171; /* *extzv.si.subreg3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern86 (x1))
        {
        case 0:
          if (!
#line 10128 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))))
            return -1;
          return 1091; /* *insv.xor-extract_split */

        case 1:
          if (!
#line 10504 "../../gcc/config/avr/avr.md"
(! reload_completed
   && ((1 << INTVAL (operands[3])) & INTVAL (operands[2])) != 0))
            return -1;
          return 1172; /* *extzv.xor */

        default:
          return -1;
        }

    case NOT:
      if (pattern87 (x1) != 0)
        return -1;
      return 1155; /* *extzv.not_split */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  operands[2] = x4;
  if (const_0_to_7_operand (operands[2], E_QImode))
    {
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 36
          && GET_MODE (x6) == E_CCmode)
        {
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          if (register_operand (operands[0], E_QImode)
              && GET_MODE (x3) == E_QImode
              && register_operand (operands[1], E_QImode)
              && 
#line 5030 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 643; /* *rotlqi3 */
        }
    }
  if (const_int_operand (operands[2], E_VOIDmode))
    {
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      switch (pattern241 (x1))
        {
        case 0:
          if (
#line 5227 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
            return 656; /* *rotwhi */
          if (
#line 5250 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
            return 658; /* *rotbhi */
          break;

        case 1:
          if (
#line 5227 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
            return 657; /* *rotwsi */
          break;

        case 2:
          if (
#line 5250 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
            return 660; /* *rotbsi */
          break;

        case 3:
          if (
#line 5250 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
            return 659; /* *rotbpsi */
          break;

        default:
          break;
        }
    }
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  switch (XWINT (x4, 0))
    {
    case 1L:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 5103 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 645; /* *rotlhi2.1 */

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || !
#line 5145 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 649; /* *rotlpsi2.1 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 5187 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 653; /* *rotlsi2.1 */

        default:
          return -1;
        }

    case 15L:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !
#line 5124 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 647; /* *rotlhi2.15 */

    case 23L:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !
#line 5166 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 651; /* *rotlpsi2.23 */

    case 31L:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 5208 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 655; /* *rotlsi2.31 */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 36
          || GET_MODE (x5) != E_CCmode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      switch (XINT (x3, 1))
        {
        case 0:
          if (GET_MODE (x3) != E_HImode)
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XVECEXP (x3, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_HImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_HImode)
              || !
#line 1559 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 173; /* *strlenhi */

        case 6:
          if (GET_MODE (x3) != E_QImode
              || !register_operand (operands[0], E_QImode))
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          operands[1] = x7;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          operands[3] = x10;
          if (!nonmemory_operand (operands[3], E_QImode)
              || !
#line 8915 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1012; /* *insert_bits */

        case 7:
          x10 = XVECEXP (x3, 0, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          operands[1] = x7;
          x8 = XVECEXP (x3, 0, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_HImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QQmode:
              if (!register_operand (operands[0], E_QQmode)
                  || GET_MODE (x3) != E_QQmode
                  || !register_operand (operands[1], E_QQmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3113; /* *roundqq3_const */

            case E_HQmode:
              if (!register_operand (operands[0], E_HQmode)
                  || GET_MODE (x3) != E_HQmode
                  || !register_operand (operands[1], E_HQmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3114; /* *roundhq3_const */

            case E_HAmode:
              if (!register_operand (operands[0], E_HAmode)
                  || GET_MODE (x3) != E_HAmode
                  || !register_operand (operands[1], E_HAmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3115; /* *roundha3_const */

            case E_SAmode:
              if (!register_operand (operands[0], E_SAmode)
                  || GET_MODE (x3) != E_SAmode
                  || !register_operand (operands[1], E_SAmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3116; /* *roundsa3_const */

            case E_SQmode:
              if (!register_operand (operands[0], E_SQmode)
                  || GET_MODE (x3) != E_SQmode
                  || !register_operand (operands[1], E_SQmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3117; /* *roundsq3_const */

            case E_UQQmode:
              if (!register_operand (operands[0], E_UQQmode)
                  || GET_MODE (x3) != E_UQQmode
                  || !register_operand (operands[1], E_UQQmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3118; /* *rounduqq3_const */

            case E_UHQmode:
              if (!register_operand (operands[0], E_UHQmode)
                  || GET_MODE (x3) != E_UHQmode
                  || !register_operand (operands[1], E_UHQmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3119; /* *rounduhq3_const */

            case E_UHAmode:
              if (!register_operand (operands[0], E_UHAmode)
                  || GET_MODE (x3) != E_UHAmode
                  || !register_operand (operands[1], E_UHAmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3120; /* *rounduha3_const */

            case E_USAmode:
              if (!register_operand (operands[0], E_USAmode)
                  || GET_MODE (x3) != E_USAmode
                  || !register_operand (operands[1], E_USAmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3121; /* *roundusa3_const */

            case E_USQmode:
              if (!register_operand (operands[0], E_USQmode)
                  || GET_MODE (x3) != E_USQmode
                  || !register_operand (operands[1], E_USQmode)
                  || !
#line 701 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3122; /* *roundusq3_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pnum_clobbers == NULL
          || XINT (x3, 1) != 2
          || GET_MODE (x3) != E_HImode)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 30
          || GET_MODE (x7) != E_HImode)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x11 = XEXP (x5, 0);
      operands[0] = x11;
      if (
#line 7960 "../../gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL))
        {
          *pnum_clobbers = 2;
          return 976; /* *tablejump.3byte-pc_split */
        }
      if (!
#line 7982 "../../gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL && reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 977; /* *tablejump.3byte-pc */

    case 2:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (XINT (x3, 1))
        {
        case 3:
          if (GET_MODE (x3) != E_HImode)
            return -1;
          if (REGNO (x5) == 36
              && pattern248 (x1) == 0
              && 
#line 9713 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 1058; /* *fmul_insn */
          x7 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x7) != REG
              || pattern250 (x1) != 0
              || !
#line 9724 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            return -1;
          return 1059; /* *fmul.call_split */

        case 4:
          if (GET_MODE (x3) != E_HImode)
            return -1;
          if (REGNO (x5) == 36
              && pattern248 (x1) == 0
              && 
#line 9785 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 1062; /* *fmuls_insn */
          x7 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x7) != REG
              || pattern250 (x1) != 0
              || !
#line 9796 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            return -1;
          return 1063; /* *fmuls.call_split */

        case 5:
          if (GET_MODE (x3) != E_HImode)
            return -1;
          if (REGNO (x5) == 36
              && pattern248 (x1) == 0
              && 
#line 9857 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 1066; /* *fmulsu_insn */
          x7 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x7) != REG
              || pattern250 (x1) != 0
              || !
#line 9868 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            return -1;
          return 1067; /* *fmulsu.call_split */

        case 7:
          x7 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x7) != REG)
            return -1;
          x8 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 24
              || GET_MODE (x8) != E_QImode)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG)
            return -1;
          switch (pattern280 (x1))
            {
            case 0:
              return 3123; /* *roundqq3.libgcc_split */

            case 1:
              return 3124; /* *rounduqq3.libgcc_split */

            case 2:
              return 3127; /* *roundhq3.libgcc_split */

            case 3:
              return 3128; /* *rounduhq3.libgcc_split */

            case 4:
              return 3129; /* *roundha3.libgcc_split */

            case 5:
              return 3130; /* *rounduha3.libgcc_split */

            case 6:
              return 3135; /* *roundsq3.libgcc_split */

            case 7:
              return 3136; /* *roundusq3.libgcc_split */

            case 8:
              return 3137; /* *roundsa3.libgcc_split */

            case 9:
              return 3138; /* *roundusa3.libgcc_split */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER
      || pattern197 (x1) != 0)
    return -1;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!reg_or_low_io_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode)
              || !
#line 10403 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1149; /* *extzvqi */

        case E_HImode:
          if (!reg_or_low_io_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !
#line 10403 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1150; /* *extzvhi */

        case E_PSImode:
          if (!reg_or_low_io_operand (operands[1], E_PSImode)
              || !const_0_to_23_operand (operands[2], E_QImode)
              || !
#line 10403 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1151; /* *extzvpsi */

        case E_SImode:
          if (!reg_or_low_io_operand (operands[1], E_SImode)
              || !const_0_to_31_operand (operands[2], E_QImode)
              || !
#line 10403 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1152; /* *extzvsi */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!reg_or_low_io_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !
#line 10449 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1156; /* *extzv.not */

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (pattern231 (x1, 
UMOD))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UMOD)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 22)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 0);
      switch (REGNO (x8))
        {
        case 24:
          if (pattern367 (x1, 
E_QImode, 
E_CCmode, 
36, 
23, 
25) != 0
              || !
#line 3973 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 589; /* *udivmodqi4_call */

        case 22:
          if (pattern367 (x1, 
E_HImode, 
E_QImode, 
21, 
26, 
24) != 0)
            return -1;
          return 594; /* *udivmodhi4_call_split */

        default:
          return -1;
        }

    case 1:
      switch (pattern312 (x1))
        {
        case 0:
          if (!
#line 625 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3099; /* *udivsa3.call */

        case 1:
          if (!
#line 625 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3101; /* *udivusa3.call */

        default:
          return -1;
        }

    case 2:
      return 616; /* *udivmodsi4_call_split */

    case 3:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3087; /* *udivhq3.call */

    case 4:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3089; /* *udivuhq3.call */

    case 5:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3091; /* *udivha3.call */

    case 6:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3093; /* *udivuha3.call */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pattern97 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      if (GET_CODE (x4) == REG)
        {
          res = recog_80 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      switch (pattern252 (x1))
        {
        case 0:
          if (!
#line 3398 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 541; /* *mulsi3 */

        case 1:
          if (!
#line 4192 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 601; /* *mulpsi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) == REG)
        {
          switch (pattern255 (x1))
            {
            case 0:
              if (
#line 2432 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                return 476; /* *umulqihi3.call_split */
              break;

            case 1:
              if (
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
                return 3338; /* umulsidi3_insn */
              break;

            default:
              break;
            }
        }
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (pattern259 (x1))
        {
        case 0:
          if (!
#line 3478 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 543; /* *muluqisi3 */

        case 1:
          if (!
#line 3478 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 544; /* *muluhisi3 */

        case 2:
          if (!
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 549; /* *usmulqiqisi3 */

        case 3:
          if (!
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 557; /* *usmulqihisi3 */

        case 4:
          if (!
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 553; /* *usmulhiqisi3 */

        case 5:
          if (!
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 561; /* *usmulhihisi3 */

        case 6:
          if (!
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 551; /* *uumulqiqisi3 */

        case 7:
          if (!
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 559; /* *uumulqihisi3 */

        case 8:
          if (!
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 555; /* *uumulhiqisi3 */

        case 9:
          if (!
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 563; /* *uumulhihisi3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 26
          || GET_MODE (x7) != E_HImode)
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) == 18)
        {
          switch (pattern292 (x1))
            {
            case 0:
              if (
#line 3530 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 545; /* *mulsqisi3 */
              break;

            case 1:
              if (
#line 3530 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 546; /* *mulshisi3 */
              break;

            case 2:
              if (
#line 4173 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 600; /* *mulsqipsi3 */
              break;

            case 3:
              if (
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 548; /* *ssmulqiqisi3 */
              break;

            case 4:
              if (
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 556; /* *ssmulqihisi3 */
              break;

            case 5:
              if (
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 552; /* *ssmulhiqisi3 */
              break;

            case 6:
              if (
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 560; /* *ssmulhihisi3 */
              break;

            case 7:
              if (
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 550; /* *sumulqiqisi3 */
              break;

            case 8:
              if (
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 558; /* *sumulqihisi3 */
              break;

            case 9:
              if (
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 554; /* *sumulhiqisi3 */
              break;

            case 10:
              if (
#line 3641 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 562; /* *sumulhihisi3 */
              break;

            default:
              break;
            }
        }
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || pattern293 (x1) != 0
          || !
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
        return -1;
      return 3337; /* mulsidi3_insn */

    case NOT:
      if (pattern233 (x1) != 0
          || !
#line 3589 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
        return -1;
      return 547; /* *mulohisi3 */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == REG)
    {
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (REGNO (x2))
        {
        case 32:
          if (GET_MODE (x2) == E_HImode
              && register_operand (operands[0], E_HImode)
              && 
#line 532 "../../gcc/config/avr/avr.md"
(reload_completed
   && frame_pointer_needed
   && !cfun->calls_alloca
   && find_reg_note (insn, REG_ARGS_SIZE, const0_rtx)
   && REGNO (operands[0]) != REG_Y))
            return gen_split_1 (insn, operands);
          break;

        case 22:
          switch (pattern147 (x2))
            {
            case 0:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_2 (insn, operands);
              break;

            case 1:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_3 (insn, operands);
              break;

            case 2:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_4 (insn, operands);
              break;

            case 3:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_5 (insn, operands);
              break;

            case 4:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_6 (insn, operands);
              break;

            case 5:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_7 (insn, operands);
              break;

            case 6:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_8 (insn, operands);
              break;

            case 7:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_9 (insn, operands);
              break;

            case 8:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_10 (insn, operands);
              break;

            case 9:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_11 (insn, operands);
              break;

            case 10:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_12 (insn, operands);
              break;

            case 11:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_13 (insn, operands);
              break;

            case 12:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_14 (insn, operands);
              break;

            case 13:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_15 (insn, operands);
              break;

            case 14:
              if ((
#line 567 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 571 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_16 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern64 (x3))
    {
    case 0:
      if (!(
#line 843 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode)) && 
#line 846 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_62 (insn, operands);

    case 1:
      if (!(
#line 843 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode)) && 
#line 846 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_63 (insn, operands);

    case 2:
      if (!(
#line 843 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode)) && 
#line 846 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_64 (insn, operands);

    case 3:
      if (nonimmediate_operand (operands[0], E_HImode)
          && nox_general_operand (operands[1], E_HImode)
          && (
#line 954 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], HImode)
   || reg_or_0_operand (operands[1], HImode)) && 
#line 957 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_65 (insn, operands);
      if (!register_operand (operands[0], E_HImode)
          || !reg_or_0_operand (operands[1], E_HImode)
          || !
#line 4886 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed
   && GENERAL_REG_P (operands[0])
   && (operands[1] == const0_rtx || GENERAL_REG_P (operands[1]))
   && (!AVR_HAVE_MOVW
       || const0_rtx == operands[1])))
        return NULL;
      return gen_split_386 (insn, operands);

    case 4:
      if (!(
#line 954 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], HQmode)
   || reg_or_0_operand (operands[1], HQmode)) && 
#line 957 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_66 (insn, operands);

    case 5:
      if (!(
#line 954 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], UHQmode)
   || reg_or_0_operand (operands[1], UHQmode)) && 
#line 957 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_67 (insn, operands);

    case 6:
      if (!(
#line 954 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], HAmode)
   || reg_or_0_operand (operands[1], HAmode)) && 
#line 957 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_68 (insn, operands);

    case 7:
      if (!(
#line 954 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], UHAmode)
   || reg_or_0_operand (operands[1], UHAmode)) && 
#line 957 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_69 (insn, operands);

    case 8:
      if (nonimmediate_operand (operands[0], E_PSImode)
          && nox_general_operand (operands[1], E_PSImode)
          && (
#line 1126 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], PSImode)
   || register_operand (operands[1], PSImode)
   || const0_rtx == operands[1]) && 
#line 1130 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_85 (insn, operands);
      if (!register_operand (operands[0], E_PSImode)
          || !register_operand (operands[1], E_PSImode)
          || !
#line 4865 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_381 (insn, operands);

    case 9:
      if (nonimmediate_operand (operands[0], E_SImode)
          && nox_general_operand (operands[1], E_SImode)
          && (
#line 1187 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], SImode)
   || reg_or_0_operand (operands[1], SImode)) && 
#line 1190 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_86 (insn, operands);
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode)
          || !
#line 4865 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_379 (insn, operands);

    case 10:
      if (nonimmediate_operand (operands[0], E_SQmode)
          && nox_general_operand (operands[1], E_SQmode)
          && (
#line 1187 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], SQmode)
   || reg_or_0_operand (operands[1], SQmode)) && 
#line 1190 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_87 (insn, operands);
      if (!register_operand (operands[0], E_SQmode)
          || !register_operand (operands[1], E_SQmode)
          || !
#line 4865 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_382 (insn, operands);

    case 11:
      if (nonimmediate_operand (operands[0], E_USQmode)
          && nox_general_operand (operands[1], E_USQmode)
          && (
#line 1187 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], USQmode)
   || reg_or_0_operand (operands[1], USQmode)) && 
#line 1190 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_88 (insn, operands);
      if (!register_operand (operands[0], E_USQmode)
          || !register_operand (operands[1], E_USQmode)
          || !
#line 4865 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_383 (insn, operands);

    case 12:
      if (nonimmediate_operand (operands[0], E_SAmode)
          && nox_general_operand (operands[1], E_SAmode)
          && (
#line 1187 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], SAmode)
   || reg_or_0_operand (operands[1], SAmode)) && 
#line 1190 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_89 (insn, operands);
      if (!register_operand (operands[0], E_SAmode)
          || !register_operand (operands[1], E_SAmode)
          || !
#line 4865 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_384 (insn, operands);

    case 13:
      if (nonimmediate_operand (operands[0], E_USAmode)
          && nox_general_operand (operands[1], E_USAmode)
          && (
#line 1187 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], USAmode)
   || reg_or_0_operand (operands[1], USAmode)) && 
#line 1190 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_90 (insn, operands);
      if (!register_operand (operands[0], E_USAmode)
          || !register_operand (operands[1], E_USAmode)
          || !
#line 4865 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_385 (insn, operands);

    case 14:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && nox_general_operand (operands[1], E_SFmode)
          && (
#line 1235 "../../gcc/config/avr/avr.md"
(register_operand (operands[0], SFmode)
   || reg_or_0_operand (operands[1], SFmode)) && 
#line 1238 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_91 (insn, operands);
      if (!register_operand (operands[0], E_SFmode)
          || !register_operand (operands[1], E_SFmode)
          || !
#line 4865 "../../gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_380 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x4 = XEXP (x1, 0);
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (pattern113 (x1, 
E_QImode) == 0
                  && 
#line 1574 "../../gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_99 (insn, operands);
              break;

            case E_QQmode:
              if (pattern113 (x1, 
E_QQmode) == 0
                  && 
#line 1574 "../../gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_100 (insn, operands);
              break;

            case E_UQQmode:
              if (pattern113 (x1, 
E_UQQmode) == 0
                  && 
#line 1574 "../../gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_101 (insn, operands);
              break;

            case E_HImode:
              if (GET_MODE (x2) == E_HImode)
                {
                  operands[1] = x4;
                  if (stack_register_operand (operands[1], E_HImode))
                    {
                      x5 = XEXP (x2, 0);
                      operands[2] = x5;
                      if (stack_register_operand (operands[2], E_HImode))
                        {
                          operands[0] = x3;
                          if (avr_sp_immediate_operand (operands[0], E_HImode))
                            return gen_split_108 (insn, operands);
                        }
                    }
                  operands[0] = x4;
                  if (register_operand (operands[0], E_HImode))
                    {
                      x5 = XEXP (x2, 0);
                      operands[1] = x5;
                      if (register_operand (operands[1], E_HImode))
                        {
                          operands[2] = x3;
                          if (nonmemory_or_const_operand (operands[2], E_HImode))
                            return gen_split_109 (insn, operands);
                        }
                    }
                }
              break;

            case E_HQmode:
              if (pattern140 (x1, 
E_HQmode) == 0)
                return gen_split_110 (insn, operands);
              break;

            case E_UHQmode:
              if (pattern140 (x1, 
E_UHQmode) == 0)
                return gen_split_111 (insn, operands);
              break;

            case E_HAmode:
              if (pattern140 (x1, 
E_HAmode) == 0)
                return gen_split_112 (insn, operands);
              break;

            case E_UHAmode:
              if (pattern140 (x1, 
E_UHAmode) == 0)
                return gen_split_113 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case ZERO_EXTEND:
          if (pattern66 (x1) == 0
              && 
#line 1656 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_103 (insn, operands);
          break;

        default:
          break;
        }
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG)
        return NULL;
      switch (pattern69 (x1))
        {
        case 0:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1850 (insn, operands);

        case 1:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1851 (insn, operands);

        case 2:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1852 (insn, operands);

        case 3:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1853 (insn, operands);

        case 4:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1854 (insn, operands);

        case 5:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1855 (insn, operands);

        case 6:
          if (!(
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1856 (insn, operands);

        case 7:
          if (!(
#line 122 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 124 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1857 (insn, operands);

        case 8:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1858 (insn, operands);

        case 9:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1859 (insn, operands);

        case 10:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1860 (insn, operands);

        case 11:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1861 (insn, operands);

        case 12:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1862 (insn, operands);

        case 13:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1863 (insn, operands);

        case 14:
          if (!(
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1864 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern3 (x2))
            {
            case 0:
              if (!
#line 1633 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_102 (insn, operands);

            case 1:
              if (!(
#line 1969 "../../gcc/config/avr/avr.md"
(3 > 1
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1972 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_126 (insn, operands);

            case 2:
              if (!(
#line 1969 "../../gcc/config/avr/avr.md"
(3 > 2
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1972 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_130 (insn, operands);

            case 3:
              if (!(
#line 1969 "../../gcc/config/avr/avr.md"
(4 > 1
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1972 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_128 (insn, operands);

            case 4:
              if (!(
#line 1969 "../../gcc/config/avr/avr.md"
(4 > 2
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1972 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_132 (insn, operands);

            case 5:
              if (!(
#line 1969 "../../gcc/config/avr/avr.md"
(4 > 3
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1972 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_134 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
          operands[2] = x3;
          if (!const_m255_to_m1_operand (operands[2], E_HImode)
              || pattern175 (x2) != 0
              || !
#line 1677 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_104 (insn, operands);

        case ZERO_EXTEND:
          if (pattern149 (x2) != 0
              || !
#line 1745 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_106 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (!
#line 1716 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_105 (insn, operands);

    case 3:
      if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_911 (insn, operands);

    case 4:
      if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_917 (insn, operands);

    case 5:
      if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_929 (insn, operands);

    case 6:
      if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_923 (insn, operands);

    case 7:
      if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_935 (insn, operands);

    case 8:
      if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_941 (insn, operands);

    case 9:
      if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_910 (insn, operands);

    case 10:
      if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_916 (insn, operands);

    case 11:
      if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_928 (insn, operands);

    case 12:
      if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_922 (insn, operands);

    case 13:
      if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_934 (insn, operands);

    case 14:
      if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_940 (insn, operands);

    case 15:
      if (!(
#line 1969 "../../gcc/config/avr/avr.md"
(2 > 1
   && (2 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1972 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_124 (insn, operands);

    case 16:
      if (!(
#line 1969 "../../gcc/config/avr/avr.md"
(3 > 1
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1972 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_125 (insn, operands);

    case 17:
      if (!(
#line 1969 "../../gcc/config/avr/avr.md"
(3 > 2
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1972 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_129 (insn, operands);

    case 18:
      if (!(
#line 1969 "../../gcc/config/avr/avr.md"
(4 > 1
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1972 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_127 (insn, operands);

    case 19:
      if (!(
#line 1969 "../../gcc/config/avr/avr.md"
(4 > 2
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1972 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_131 (insn, operands);

    case 20:
      if (!(
#line 1969 "../../gcc/config/avr/avr.md"
(4 > 3
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1972 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_133 (insn, operands);

    case 21:
      if (!
#line 2311 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_174 (insn, operands);

    case 22:
      if (!
#line 2311 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_176 (insn, operands);

    case 23:
      if (!
#line 2311 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_178 (insn, operands);

    case 24:
      if (!
#line 2311 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_180 (insn, operands);

    case 25:
      if (!(
#line 2327 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2329 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_182 (insn, operands);

    case 26:
      if (!(
#line 2327 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2329 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_184 (insn, operands);

    case 27:
      if (!(
#line 2327 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2329 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_188 (insn, operands);

    case 28:
      if (!(
#line 2327 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2329 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_186 (insn, operands);

    case 29:
      if (!(
#line 2327 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2329 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_190 (insn, operands);

    case 30:
      if (!(
#line 2327 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2329 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_192 (insn, operands);

    case 31:
      if (!
#line 2311 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_175 (insn, operands);

    case 32:
      if (!
#line 2311 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_177 (insn, operands);

    case 33:
      if (!
#line 2311 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_179 (insn, operands);

    case 34:
      if (!
#line 2311 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_181 (insn, operands);

    case 35:
      if (!(
#line 2327 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2329 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_183 (insn, operands);

    case 36:
      if (!(
#line 2327 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2329 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_185 (insn, operands);

    case 37:
      if (!(
#line 2327 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2329 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_189 (insn, operands);

    case 38:
      if (!(
#line 2327 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2329 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_187 (insn, operands);

    case 39:
      if (!(
#line 2327 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2329 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_191 (insn, operands);

    case 40:
      if (!(
#line 2327 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2329 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_193 (insn, operands);

    case 41:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_206 (insn, operands);

    case 42:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_214 (insn, operands);

    case 43:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_222 (insn, operands);

    case 44:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_230 (insn, operands);

    case 45:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_208 (insn, operands);

    case 46:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_216 (insn, operands);

    case 47:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_224 (insn, operands);

    case 48:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_232 (insn, operands);

    case 49:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_210 (insn, operands);

    case 50:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_218 (insn, operands);

    case 51:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_226 (insn, operands);

    case 52:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_234 (insn, operands);

    case 53:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_212 (insn, operands);

    case 54:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_220 (insn, operands);

    case 55:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_228 (insn, operands);

    case 56:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_236 (insn, operands);

    case 57:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_207 (insn, operands);

    case 58:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_215 (insn, operands);

    case 59:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_223 (insn, operands);

    case 60:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_231 (insn, operands);

    case 61:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_209 (insn, operands);

    case 62:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_217 (insn, operands);

    case 63:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_225 (insn, operands);

    case 64:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_233 (insn, operands);

    case 65:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_211 (insn, operands);

    case 66:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_219 (insn, operands);

    case 67:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_227 (insn, operands);

    case 68:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_235 (insn, operands);

    case 69:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_213 (insn, operands);

    case 70:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_221 (insn, operands);

    case 71:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_229 (insn, operands);

    case 72:
      if (!
#line 2398 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_237 (insn, operands);

    case 73:
      x2 = XEXP (x1, 1);
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[3] = x3;
      if (!register_operand (operands[3], E_QImode)
          || !(
#line 2587 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2589 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_277 (insn, operands);

    case 74:
      x2 = XEXP (x1, 1);
      switch (pattern116 (x2))
        {
        case 0:
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          if (GET_MODE (x7) != E_HImode
              || !register_operand (operands[3], E_HImode))
            return NULL;
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2696 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2698 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_281 (insn, operands);

            case ZERO_EXTEND:
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2754 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND) && 
#line 2758 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_286 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_874 (insn, operands);

        case 2:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_880 (insn, operands);

        case 3:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_892 (insn, operands);

        case 4:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_886 (insn, operands);

        case 5:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_898 (insn, operands);

        case 6:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_904 (insn, operands);

        default:
          return NULL;
        }

    case 75:
      x2 = XEXP (x1, 1);
      switch (pattern117 (x2))
        {
        case 0:
          if (!(
#line 2696 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2698 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_282 (insn, operands);

        case 1:
          if (!(
#line 2754 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND) && 
#line 2758 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_285 (insn, operands);

        case 2:
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          if (XWINT (x7, 0) != 2L)
            return NULL;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!(
#line 2827 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 2830 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_289 (insn, operands);

        case 3:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_875 (insn, operands);

        case 4:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_881 (insn, operands);

        case 5:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_893 (insn, operands);

        case 6:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_887 (insn, operands);

        case 7:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_899 (insn, operands);

        case 8:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_905 (insn, operands);

        default:
          return NULL;
        }

    case 76:
      x2 = XEXP (x1, 1);
      switch (pattern118 (x2))
        {
        case 0:
          if (!(
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_862 (insn, operands);

        case 1:
          if (!(
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_865 (insn, operands);

        case 2:
          if (!(
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_868 (insn, operands);

        case 3:
          if (!(
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_871 (insn, operands);

        default:
          return NULL;
        }

    case 77:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_814 (insn, operands);

    case 78:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_826 (insn, operands);

    case 79:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_838 (insn, operands);

    case 80:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_850 (insn, operands);

    case 81:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_817 (insn, operands);

    case 82:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_829 (insn, operands);

    case 83:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_841 (insn, operands);

    case 84:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_853 (insn, operands);

    case 85:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_820 (insn, operands);

    case 86:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_832 (insn, operands);

    case 87:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_844 (insn, operands);

    case 88:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_856 (insn, operands);

    case 89:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_823 (insn, operands);

    case 90:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_835 (insn, operands);

    case 91:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_847 (insn, operands);

    case 92:
      if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_859 (insn, operands);

    case 93:
      if (!(
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10813 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_946 (insn, operands);

    case 94:
      if (!(
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10813 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_949 (insn, operands);

    case 95:
      if (!(
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10813 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_952 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_29 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (pattern282 (x1) != 0)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (REGNO (x4))
    {
    case 24:
      x5 = XEXP (x3, 1);
      if (REGNO (x5) != 22)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      if (REGNO (x8) != 24)
        return NULL;
      x9 = XEXP (x7, 1);
      if (REGNO (x9) != 22)
        return NULL;
      switch (pattern362 (x1))
        {
        case 0:
          if (!
#line 3918 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_346 (insn, operands);

        case 1:
          if (!
#line 4006 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_350 (insn, operands);

        default:
          return NULL;
        }

    case 22:
      if (pattern349 (x1, 
E_SImode, 
18, 
22) != 0
          || pattern344 (x1, 
E_HImode, 
26, 
E_SImode, 
22) != 0
          || pattern358 (x1, 
E_SImode, 
E_HImode, 
30) != 0
          || !
#line 4404 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_364 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return split_24 (x1, insn);

    case PLUS:
      return split_25 (x1, insn);

    case MINUS:
      return split_26 (x1, insn);

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != REG)
            return NULL;
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          x8 = XEXP (x3, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          switch (REGNO (x5))
            {
            case 24:
              if (pattern269 (x1) != 0
                  || !(
#line 2234 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 2236 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_163 (insn, operands);

            case 22:
              if (pattern270 (x1) != 0
                  || !(
#line 3710 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3712 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_335 (insn, operands);

            case 18:
              switch (pattern271 (x1))
                {
                case 0:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1808 (insn, operands);

                case 1:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1809 (insn, operands);

                case 2:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1810 (insn, operands);

                case 3:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1811 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern169 (x1) != 0)
            return NULL;
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2989 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2991 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_298 (insn, operands);
          if (u8_operand (operands[2], E_HImode)
              && (
#line 3025 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3027 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_301 (insn, operands);
          if (!o8_operand (operands[2], E_HImode)
              || !(
#line 3043 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3045 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_302 (insn, operands);

        case ZERO_EXTEND:
          if (pattern169 (x1) != 0)
            return NULL;
          if (u8_operand (operands[2], E_HImode)
              && (
#line 2989 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2991 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_299 (insn, operands);
          if (!s8_operand (operands[2], E_HImode)
              || !(
#line 3007 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3009 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_300 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      return split_27 (x1, insn);

    case TRUNCATE:
      if (pattern98 (x2, 
24, 
E_HImode) != 0)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != MULT
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || REGNO (x8) != 22
              || GET_MODE (x8) != E_HImode)
            return NULL;
          switch (pattern346 (x9))
            {
            case 0:
              if (!(
#line 3795 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3797 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_339 (insn, operands);

            case 1:
              if (!(
#line 3795 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3797 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_340 (insn, operands);

            default:
              return NULL;
            }

        case CLZ:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 22
              || GET_MODE (x9) != E_SImode
              || REGNO (x8) != 26
              || GET_MODE (x8) != E_QImode
              || !
#line 9400 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_647 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 4504 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_368 (insn, operands);

        case 1:
          if (!
#line 4538 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_369 (insn, operands);

        case 2:
          if (!
#line 4573 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_370 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 4652 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_372 (insn, operands);

        case 1:
          if (!
#line 4684 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_373 (insn, operands);

        case 2:
          if (!
#line 4716 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_374 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 4773 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_376 (insn, operands);

        case 1:
          if (!
#line 4803 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_377 (insn, operands);

        case 2:
          if (!
#line 4835 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_378 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (pattern241 (x1))
        {
        case 0:
          if ((
#line 5227 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5232 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_403 (insn, operands);
          if (!(
#line 5250 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5256 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_405 (insn, operands);

        case 1:
          if (!(
#line 5227 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5232 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_404 (insn, operands);

        case 2:
          if (!(
#line 5250 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5256 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_407 (insn, operands);

        case 3:
          if (!(
#line 5250 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5256 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_406 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern242 (x1))
            {
            case 0:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_435 (insn, operands);
              break;

            case 1:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_438 (insn, operands);
              break;

            case 2:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3r (operands[2])))
                return gen_split_441 (insn, operands);
              break;

            case 3:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_444 (insn, operands);
              break;

            case 4:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_447 (insn, operands);
              break;

            case 5:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_450 (insn, operands);
              break;

            case 6:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_453 (insn, operands);
              break;

            case 7:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_456 (insn, operands);
              break;

            case 8:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_459 (insn, operands);
              break;

            case 9:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_462 (insn, operands);
              break;

            case 10:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_465 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern243 (x1) != 0
          || !
#line 6024 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_532 (insn, operands);

    case ASHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern242 (x1))
            {
            case 0:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_436 (insn, operands);
              break;

            case 1:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_439 (insn, operands);
              break;

            case 2:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3a (operands[2])))
                return gen_split_442 (insn, operands);
              break;

            case 3:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_445 (insn, operands);
              break;

            case 4:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_448 (insn, operands);
              break;

            case 5:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_451 (insn, operands);
              break;

            case 6:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_454 (insn, operands);
              break;

            case 7:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_457 (insn, operands);
              break;

            case 8:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_460 (insn, operands);
              break;

            case 9:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_463 (insn, operands);
              break;

            case 10:
              if (
#line 5586 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_466 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern243 (x1) != 0
          || !
#line 5824 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_511 (insn, operands);

    case LO_SUM:
      if (GET_MODE (x4) != E_PSImode
          || pattern158 (x1) != 0
          || !
#line 6629 "../../gcc/config/avr/avr.md"
(reload_completed))
        return NULL;
      return gen_split_560 (insn, operands);

    case COMPARE:
      if (GET_MODE (x4) != E_CCmode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LSHIFTRT)
        return NULL;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 36
          || GET_MODE (x7) != E_CCmode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != SCRATCH
          || GET_MODE (x8) != E_QImode)
        return NULL;
      switch (pattern311 (x5))
        {
        case 0:
          if (!(
#line 6903 "../../gcc/config/avr/avr.md"
(reload_completed) && 
#line 6907 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_566 (insn, operands);

        case 1:
          if (!(
#line 6903 "../../gcc/config/avr/avr.md"
(reload_completed) && 
#line 6907 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_567 (insn, operands);

        case 2:
          if (!(
#line 6903 "../../gcc/config/avr/avr.md"
(reload_completed) && 
#line 6907 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_568 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x5 = XEXP (x4, 0);
      if (!ordered_comparison_operator (x5, E_VOIDmode))
        return NULL;
      operands[0] = x5;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return NULL;
      x11 = XEXP (x4, 2);
      if (GET_CODE (x11) != PC)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PC)
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      switch (pattern277 (x1))
        {
        case 0:
          if (
#line 7011 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_572 (insn, operands);
          break;

        case 1:
          if (
#line 7011 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_573 (insn, operands);
          break;

        case 2:
          if (
#line 7011 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_574 (insn, operands);
          break;

        case 3:
          if (
#line 7011 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_575 (insn, operands);
          break;

        case 4:
          if (
#line 7011 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_576 (insn, operands);
          break;

        case 5:
          if (
#line 7038 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_577 (insn, operands);
          break;

        case 6:
          if (
#line 7066 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_578 (insn, operands);
          break;

        case 7:
          if (
#line 7066 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_579 (insn, operands);
          break;

        case 8:
          if (
#line 7066 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_580 (insn, operands);
          break;

        case 9:
          if (
#line 7066 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_581 (insn, operands);
          break;

        case 10:
          if (
#line 7066 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_582 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x9) != REG)
        return NULL;
      switch (pattern278 (x1))
        {
        case 0:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1912 (insn, operands);

        case 1:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1913 (insn, operands);

        case 2:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1914 (insn, operands);

        case 3:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1915 (insn, operands);

        case 4:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1916 (insn, operands);

        case 5:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1917 (insn, operands);

        case 6:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1918 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24)
        return NULL;
      switch (pattern214 (x1))
        {
        case 0:
          if (!(
#line 9135 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9137 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_635 (insn, operands);

        case 1:
          if (!(
#line 9164 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9166 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_637 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PARITY
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_HImode)
        return NULL;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode))
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 9150 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9152 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_636 (insn, operands);

    case CLZ:
      if (pattern144 (x1) != 0
          || !
#line 9379 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_646 (insn, operands);

    case CTZ:
      if (pattern144 (x1) != 0
          || !
#line 9448 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_648 (insn, operands);

    case FFS:
      if (pattern144 (x1) != 0
          || !
#line 9520 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_650 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2)
        return NULL;
      x12 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x12) != REG)
        return NULL;
      x13 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x13) != REG
          || GET_MODE (x13) != E_QImode)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return NULL;
      switch (pattern281 (x1))
        {
        case 0:
          if (!(
#line 9724 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9726 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_654 (insn, operands);

        case 1:
          if (!(
#line 9796 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9798 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_656 (insn, operands);

        case 2:
          if (!(
#line 9868 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9870 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_658 (insn, operands);

        case 3:
          if (!
#line 716 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1840 (insn, operands);

        case 4:
          if (!
#line 716 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1841 (insn, operands);

        case 5:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1842 (insn, operands);

        case 6:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1843 (insn, operands);

        case 7:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1844 (insn, operands);

        case 8:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1845 (insn, operands);

        case 9:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1846 (insn, operands);

        case 10:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1847 (insn, operands);

        case 11:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1848 (insn, operands);

        case 12:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1849 (insn, operands);

        default:
          return NULL;
        }

    case UDIV:
      switch (pattern145 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1814 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1816 (insn, operands);

        default:
          return NULL;
        }

    case DIV:
      switch (pattern145 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1815 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1817 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
