/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[4], E_QImode)
          || !single_one_operand (operands[2], E_HImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || GET_MODE (x2) != E_PSImode
          || GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[4], E_QImode)
          || !single_one_operand (operands[2], E_PSImode)
          || !register_operand (operands[3], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[4], E_QImode)
          || !single_one_operand (operands[2], E_SImode)
          || !register_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 26
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 1)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != USE
      || pattern27 (x1) != 0)
    return -1;
  return 0;
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern32 (x2, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern32 (x2, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern32 (x2, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern32 (x2, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_8_16_24_operand (operands[3], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  return pattern43 (x1); /* [-1, 5] */
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || GET_MODE (x5) != E_UDQmode)
            return -1;
          return 0;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || GET_MODE (x5) != E_UDAmode)
            return -1;
          return 1;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || GET_MODE (x5) != E_UTAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || !const_operand (operands[0], E_UDQmode))
            return -1;
          return 3;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || !const_operand (operands[0], E_UDAmode))
            return -1;
          return 4;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || !const_operand (operands[0], E_UTAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[2] = x1;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !nonmemory_operand (operands[2], E_HImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_PSImode
          || !nonmemory_operand (operands[2], E_PSImode))
        return -1;
      x4 = XEXP (x3, 0);
      res = pattern0 (x4);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      res = pattern1 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i2)
    return -1;
  return 0;
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LO_SUM
      || GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 21
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 22)
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  return pattern101 (x1); /* [-1, 2] */
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !memory_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !memory_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !memory_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !memory_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !memory_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !memory_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !memory_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !memory_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !memory_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !memory_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !memory_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_SFmode))
        return -1;
      return 13;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !memory_operand (operands[1], E_PSImode))
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode
      || GET_MODE (x3) != E_QImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  switch (SUBREG_BYTE (x3))
    {
    case 0:
      return pattern127 (x4); /* [-1, 2] */

    case 1:
      res = pattern127 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case 2:
      res = pattern127 (x4);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case 3:
      res = pattern127 (x4);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (REGNO (x7))
    {
    case 24:
      if (REGNO (x3) != 24)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_HQmode:
          if (GET_MODE (x6) != E_HQmode
              || GET_MODE (x7) != E_HQmode)
            return -1;
          return 0;

        case E_HAmode:
          if (GET_MODE (x6) != E_HAmode
              || GET_MODE (x7) != E_HAmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (REGNO (x3) != 22)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SAmode:
          if (GET_MODE (x6) != E_SAmode
              || GET_MODE (x7) != E_SAmode)
            return -1;
          return 2;

        case E_SQmode:
          if (GET_MODE (x6) != E_SQmode
              || GET_MODE (x7) != E_SQmode)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern151 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 26
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_SImode
      || pattern150 (x1, 
E_SImode, 
22) != 0)
    return -1;
  return 0;
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  return 0;
}

int
pattern164 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  return pattern163 (x4); /* [-1, 0] */
}

int
pattern168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!reg_or_low_io_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!reg_or_low_io_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!reg_or_low_io_operand (operands[1], E_PSImode)
              || !const_0_to_23_operand (operands[2], E_QImode))
            return -1;
          return 2;

        case E_SImode:
          if (!reg_or_low_io_operand (operands[1], E_SImode)
              || !const_0_to_31_operand (operands[2], E_QImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          return 4;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern183 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_MODE (x4) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (pnum_clobbers == NULL
          || !pseudo_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_MODE (x4) != E_SImode
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          res = pattern182 (
E_QImode);
          if (res >= 0)
            return res + 1; /* [1, 2] */
          return -1;

        case E_HImode:
          res = pattern182 (
E_HImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern196 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_QImode)
    return -1;
  return 0;
}

int
pattern202 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_QImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], E_HImode))
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  return 0;
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern224 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QQmode
          || !register_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UQQmode
          || !register_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern254 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  switch (REGNO (x7))
    {
    case 22:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x5, 1);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) != 24
          || GET_MODE (x9) != E_QImode
          || pattern253 (x1, 
E_HImode, 
22, 
E_QImode, 
21, 
24) != 0)
        return -1;
      return 0;

    case 18:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x5, 1);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) != 22
          || GET_MODE (x9) != E_SImode
          || pattern253 (x1, 
E_DImode, 
30, 
E_HImode, 
26, 
18) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern264 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern230 (x4); /* [-1, 3] */
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != 22
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (REGNO (x6) != 24
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (REGNO (x8) != 22
      || GET_MODE (x8) != E_QImode
      || GET_MODE (x3) != E_QImode)
    return -1;
  return 0;
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18)
    return -1;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      if (!const_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_DQmode:
      if (!const_operand (operands[1], E_DQmode))
        return -1;
      return 1;

    case E_UDQmode:
      if (!const_operand (operands[1], E_UDQmode))
        return -1;
      return 2;

    case E_DAmode:
      if (!const_operand (operands[1], E_DAmode))
        return -1;
      return 3;

    case E_UDAmode:
      if (!const_operand (operands[1], E_UDAmode))
        return -1;
      return 4;

    case E_TAmode:
      if (!const_operand (operands[1], E_TAmode))
        return -1;
      return 5;

    case E_UTAmode:
      if (!const_operand (operands[1], E_UTAmode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern286 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != SIGN_EXTEND
      || pattern285 (x4, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 1);
  switch (GET_CODE (x9))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || GET_MODE (x7) != E_SImode)
            return -1;
          return pattern256 (); /* [-1, 1] */

        case E_PSImode:
          if (!pseudo_register_operand (operands[0], E_PSImode)
              || GET_MODE (x6) != E_PSImode
              || GET_MODE (x7) != E_PSImode
              || !pseudo_register_operand (operands[1], E_QImode)
              || !pseudo_register_or_const_int_operand (operands[2], E_PSImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern291 (x6);
      if (res >= 0)
        return res + 3; /* [3, 6] */
      return -1;

    case ZERO_EXTEND:
      res = pattern291 (x6);
      if (res >= 0)
        return res + 7; /* [7, 10] */
      return -1;

    default:
      return -1;
    }
}

int
pattern311 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!const_8_16_24_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern318 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (REGNO (x3) != 10)
    return -1;
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x2) != E_DQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DQmode
          || GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x2) != E_UDQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDQmode
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x2) != E_DAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DAmode
          || GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x2) != E_UDAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDAmode
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x2) != E_TAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_TAmode
          || GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x2) != E_UTAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UTAmode
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern331 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 22
      || GET_MODE (x6) != E_PSImode)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_PSImode)
    return -1;
  x8 = XEXP (x4, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 22
      || GET_MODE (x8) != E_PSImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 22
      || GET_MODE (x11) != E_PSImode)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 18
      || GET_MODE (x12) != E_PSImode)
    return -1;
  x13 = XEXP (x9, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 18
      || GET_MODE (x13) != E_PSImode)
    return -1;
  x14 = XVECEXP (x1, 0, 2);
  x15 = XEXP (x14, 0);
  if (REGNO (x15) != 21
      || GET_MODE (x15) != E_QImode)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (REGNO (x17) != 25
      || GET_MODE (x17) != E_QImode)
    return -1;
  x18 = XVECEXP (x1, 0, 5);
  x19 = XEXP (x18, 0);
  if (REGNO (x19) != 36
      || GET_MODE (x19) != E_CCmode
      || GET_MODE (x5) != E_PSImode
      || GET_MODE (x10) != E_PSImode)
    return -1;
  return 0;
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UQQmode)
        return -1;
      return 2;

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      return 3;

    case E_HQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      return 4;

    case E_UHQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      return 5;

    case E_HAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      return 6;

    case E_UHAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      return 7;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 8;

    case E_SQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SQmode)
        return -1;
      return 9;

    case E_USQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USQmode)
        return -1;
      return 10;

    case E_SAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      return 11;

    case E_USAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      return 12;

    case E_SFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      return 13;

    case E_PSImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern373 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 6);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern383 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern375 (x1); /* [-1, 0] */

    case NE:
      if (pattern375 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern375 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern375 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern375 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern375 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      if (pattern66 (x1) == 0)
        return 182; /* *addhi3_zero_extend1_split */
      break;

    default:
      break;
    }
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern69 (x1))
    {
    case 0:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3143; /* adddi3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3150; /* *adddi3_insn */

    case 1:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3144; /* adddq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3151; /* *adddq3_insn */

    case 2:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3145; /* addudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3152; /* *addudq3_insn */

    case 3:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3146; /* addda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3153; /* *addda3_insn */

    case 4:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3147; /* adduda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3154; /* *adduda3_insn */

    case 5:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3148; /* addta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3155; /* *addta3_insn */

    case 6:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3149; /* adduta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3156; /* *adduta3_insn */

    case 7:
      if (
#line 122 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3157; /* adddi3_const8_insn */
      if (pnum_clobbers == NULL
          || !
#line 135 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3158; /* *adddi3_const8_insn */

    case 8:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3159; /* adddi3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3166; /* *adddi3_const_insn */

    case 9:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3160; /* adddq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3167; /* *adddq3_const_insn */

    case 10:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3161; /* addudq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3168; /* *addudq3_const_insn */

    case 11:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3162; /* addda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3169; /* *addda3_const_insn */

    case 12:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3163; /* adduda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3170; /* *adduda3_const_insn */

    case 13:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3164; /* addta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3171; /* *addta3_const_insn */

    case 14:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3165; /* adduta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3172; /* *adduta3_const_insn */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (pattern202 (x2) != 0)
        return -1;
      if (
#line 2533 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 486; /* *osmulqihi3_split */
      if (pnum_clobbers == NULL
          || !
#line 2546 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 487; /* *osmulqihi3 */

    case ZERO_EXTEND:
      if (pattern202 (x2) != 0)
        return -1;
      if (
#line 2557 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 488; /* *oumulqihi3_split */
      if (pnum_clobbers == NULL
          || !
#line 2570 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 489; /* *oumulqihi3 */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          if (
#line 3196 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 535; /* muloqihi3 */
          if (pnum_clobbers == NULL
              || !
#line 3209 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 536; /* *muloqihi3 */

        case E_SImode:
          if (pnum_clobbers == NULL
              || !pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x5) != E_HImode
              || !pseudo_register_operand (operands[1], E_HImode)
              || !pseudo_register_or_const_int_operand (operands[2], E_SImode)
              || !
#line 3589 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 547; /* *mulohisi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[2] = x3;
  if (pattern152 (x1) == 0)
    return 642; /* *rotlqi3_split */
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (XWINT (x3, 0))
    {
    case 1L:
      switch (pattern188 (x2))
        {
        case 0:
          return 644; /* *rotlhi2.1_split */

        case 1:
          return 648; /* *rotlpsi2.1_split */

        case 2:
          return 652; /* *rotlsi2.1_split */

        default:
          break;
        }
      break;

    case 15L:
      if (register_operand (operands[0], E_HImode)
          && GET_MODE (x2) == E_HImode
          && register_operand (operands[1], E_HImode))
        return 646; /* *rotlhi2.15_split */
      break;

    case 23L:
      if (register_operand (operands[0], E_PSImode)
          && GET_MODE (x2) == E_PSImode
          && register_operand (operands[1], E_PSImode))
        return 650; /* *rotlpsi2.23_split */
      break;

    case 31L:
      if (register_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode
          && register_operand (operands[1], E_SImode))
        return 654; /* *rotlsi2.31_split */
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      if (
#line 5227 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
        {
          *pnum_clobbers = 1;
          return 656; /* *rotwhi */
        }
      if (!
#line 5250 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 658; /* *rotbhi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 5227 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
        {
          *pnum_clobbers = 1;
          return 657; /* *rotwsi */
        }
      if (!
#line 5250 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 660; /* *rotbsi */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !
#line 5250 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 659; /* *rotbpsi */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (pattern72 (x1, pnum_clobbers))
        {
        case 0:
          return 626; /* iorqi3 */

        case 1:
          *pnum_clobbers = 1;
          return 628; /* iorhi3 */

        case 2:
          *pnum_clobbers = 1;
          return 630; /* iorpsi3 */

        case 3:
          *pnum_clobbers = 1;
          return 632; /* iorsi3 */

        default:
          return -1;
        }

    case MEM:
      if (pattern40 (x1) != 0
          || !single_one_operand (operands[1], E_QImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 981; /* *sbi */

    case AND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          operands[2] = x6;
          res = recog_17 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (XWINT (x6, 0) != 127L)
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != ASHIFT
              || GET_MODE (x7) != E_QImode)
            return -1;
          x8 = XEXP (x7, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || pattern205 (x2, 
E_QImode) != 0)
            return -1;
          return 1075; /* *movbitqi.7 */

        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1273; /* *pixop-to-skip.qi */

            case 1:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1285; /* *pixop-to-skip.qi */

            case 2:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1297; /* *pixop-to-skip.qi */

            case 3:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1309; /* *pixop-to-skip.qi */

            case 4:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1276; /* *pixop-to-skip.hi */

            case 5:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1288; /* *pixop-to-skip.hi */

            case 6:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1300; /* *pixop-to-skip.hi */

            case 7:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1312; /* *pixop-to-skip.hi */

            case 8:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1279; /* *pixop-to-skip.psi */

            case 9:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1291; /* *pixop-to-skip.psi */

            case 10:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1303; /* *pixop-to-skip.psi */

            case 11:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1315; /* *pixop-to-skip.psi */

            case 12:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1282; /* *pixop-to-skip.si */

            case 13:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1294; /* *pixop-to-skip.si */

            case 14:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1306; /* *pixop-to-skip.si */

            case 15:
              if (!
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1318; /* *pixop-to-skip.si */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1405; /* *shl.and-to-skip.hi */

            case 1:
              if (!
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1408; /* *shl.and-to-skip.psi */

            case 2:
              if (!
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1411; /* *shl.and-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern74 (x2))
        {
        case 0:
          if (!
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1093; /* *iorhi.lshiftrt */

        case 1:
          if (!
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1097; /* *iorpsi.lshiftrt */

        case 2:
          if (!
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1101; /* *iorsi.lshiftrt */

        case 3:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1117; /* *iorhiqi.lshiftrt */

        case 4:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1121; /* *iorpsiqi.lshiftrt */

        case 5:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1129; /* *iorpsihi.lshiftrt */

        case 6:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1125; /* *iorsiqi.lshiftrt */

        case 7:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1133; /* *iorsihi.lshiftrt */

        case 8:
          if (!
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1137; /* *iorsipsi.lshiftrt */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern76 (x2))
        {
        case 0:
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (pattern42 (x2))
            {
            case 0:
              if (
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
                return 1095; /* *iorhi.ashift */
              break;

            case 1:
              if (
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
                return 1099; /* *iorpsi.ashift */
              break;

            case 2:
              if (
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
                return 1103; /* *iorsi.ashift */
              break;

            default:
              break;
            }
          if (XWINT (x6, 0) != 8L
              || pattern206 (x2) != 0
              || !
#line 10259 "../../gcc/config/avr/avr.md"
(optimize))
            return -1;
          return 1144; /* *iorhi3.ashift8-reg.zerox */

        case 1:
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (pattern44 (x2))
            {
            case 0:
              if (
#line 10193 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
                return 1119; /* *iorhiqi.ashift */
              break;

            case 1:
              if (
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
                return 1123; /* *iorpsiqi.ashift */
              break;

            case 2:
              if (
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
                return 1131; /* *iorpsihi.ashift */
              break;

            case 3:
              if (
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
                return 1127; /* *iorsiqi.ashift */
              break;

            case 4:
              if (
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
                return 1135; /* *iorsihi.ashift */
              break;

            case 5:
              if (
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
                return 1139; /* *iorsipsi.ashift */
              break;

            default:
              break;
            }
          if (XWINT (x6, 0) != 8L)
            return -1;
          switch (pattern217 (x2))
            {
            case 0:
              if (!
#line 10210 "../../gcc/config/avr/avr.md"
(optimize))
                return -1;
              return 1141; /* *iorhi3.ashift8-ext.zerox */

            case 1:
              if (!
#line 10243 "../../gcc/config/avr/avr.md"
(optimize))
                return -1;
              return 1143; /* *iorhi3.ashift8-ext.reg */

            default:
              return -1;
            }

        case 2:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1371; /* *shl.ext.and1-to-skip.hi */

        case 3:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1377; /* *shl.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1389; /* *shl.ext.and1-to-skip.psi */

        case 5:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1383; /* *shl.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1395; /* *shl.ext.and1-to-skip.si */

        case 7:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1401; /* *shl.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10210 "../../gcc/config/avr/avr.md"
(optimize))
            return -1;
          return 1140; /* *iorhi3.ashift8-ext.zerox */

        case 9:
          if (!
#line 10243 "../../gcc/config/avr/avr.md"
(optimize))
            return -1;
          return 1142; /* *iorhi3.ashift8-ext.reg */

        case 10:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1370; /* *shl.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1376; /* *shl.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1388; /* *shl.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1382; /* *shl.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1394; /* *shl.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1400; /* *shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern3 (x2))
        {
        case 0:
          return 1105; /* *iorhiqi.0 */

        case 1:
          return 1107; /* *iorpsiqi.0 */

        case 2:
          return 1111; /* *iorpsihi.0 */

        case 3:
          return 1109; /* *iorsiqi.0 */

        case 4:
          return 1113; /* *iorsihi.0 */

        case 5:
          return 1115; /* *iorsipsi.0 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern80 (x2))
        {
        case 0:
          if (!
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1321; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1324; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1327; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1330; /* *mul.and1-to-skip.si */

        case 4:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1334; /* *mul.ext.and1-to-skip.hi */

        case 5:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1340; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1352; /* *mul.ext.and1-to-skip.psi */

        case 7:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1346; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1358; /* *mul.ext.and1-to-skip.si */

        case 9:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1364; /* *mul.ext.and1-to-skip.si */

        case 10:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1335; /* *mul.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1341; /* *mul.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1353; /* *mul.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1347; /* *mul.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1359; /* *mul.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1365; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == REG)
    {
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) == REG
      && REGNO (x6) == 30)
    {
      switch (pattern239 (x6))
        {
        case 0:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 35; /* fxmovqi_A */
          break;

        case 1:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 36; /* fxmovqq_A */
          break;

        case 2:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 37; /* fxmovuqq_A */
          break;

        case 3:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 38; /* fxmovhi_A */
          break;

        case 4:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 39; /* fxmovhq_A */
          break;

        case 5:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 40; /* fxmovuhq_A */
          break;

        case 6:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 41; /* fxmovha_A */
          break;

        case 7:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 42; /* fxmovuha_A */
          break;

        case 8:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 43; /* fxmovsi_A */
          break;

        case 9:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 44; /* fxmovsq_A */
          break;

        case 10:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 45; /* fxmovusq_A */
          break;

        case 11:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 46; /* fxmovsa_A */
          break;

        case 12:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 47; /* fxmovusa_A */
          break;

        case 13:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 48; /* fxmovsf_A */
          break;

        case 14:
          if (
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 49; /* fxmovpsi_A */
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !const_operand (operands[1], E_QImode)
          || !
#line 876 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 119; /* *reload_inqi */

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !const_operand (operands[1], E_QQmode)
          || !
#line 876 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 120; /* *reload_inqq */

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !const_operand (operands[1], E_UQQmode)
          || !
#line 876 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 121; /* *reload_inuqq */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !immediate_operand (operands[1], E_PSImode)
          || !
#line 1116 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 138; /* *reload_inpsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !immediate_operand (operands[1], E_SImode)
          || !
#line 1173 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 141; /* *reload_insi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !immediate_operand (operands[1], E_SQmode)
          || !
#line 1173 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 142; /* *reload_insi */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !immediate_operand (operands[1], E_USQmode)
          || !
#line 1173 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 143; /* *reload_insi */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !immediate_operand (operands[1], E_SAmode)
          || !
#line 1173 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 144; /* *reload_insi */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !immediate_operand (operands[1], E_USAmode)
          || !
#line 1173 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 145; /* *reload_insi */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 1274 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 159; /* *reload_insf */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || pattern190 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
          switch (pattern318 (x3))
            {
            case 0:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3150; /* *adddi3_insn */

            case 1:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3151; /* *adddq3_insn */

            case 2:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3152; /* *addudq3_insn */

            case 3:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3153; /* *addda3_insn */

            case 4:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3154; /* *adduda3_insn */

            case 5:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3155; /* *addta3_insn */

            case 6:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3156; /* *adduta3_insn */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern285 (x6, 
E_QImode, 
26, 
E_DImode) != 0)
            return -1;
          x7 = XEXP (x3, 0);
          if (GET_MODE (x7) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode
              || !
#line 135 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3158; /* *adddi3_const8_insn */

        case CONST_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
          switch (pattern319 (x3))
            {
            case 0:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3166; /* *adddi3_const_insn */

            case 1:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3167; /* *adddq3_const_insn */

            case 2:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3168; /* *addudq3_const_insn */

            case 3:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3169; /* *addda3_const_insn */

            case 4:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3170; /* *adduda3_const_insn */

            case 5:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3171; /* *addta3_const_insn */

            case 6:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3172; /* *adduta3_const_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 36
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern273 (x4))
            {
            case 0:
              if (!
#line 1644 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 181; /* *addhi3_zero_extend */

            case 1:
              if (!
#line 1989 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 237; /* *addpsi3.zero_extend.qi */

            case 2:
              if (!
#line 1989 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 241; /* *addpsi3.zero_extend.hi */

            case 3:
              if (!
#line 1989 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 239; /* *addsi3.zero_extend.qi */

            case 4:
              if (!
#line 1989 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 243; /* *addsi3.zero_extend.hi */

            case 5:
              if (!
#line 1989 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 245; /* *addsi3.zero_extend.psi */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x6;
          if (!const_m255_to_m1_operand (operands[2], E_HImode)
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 1688 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 185; /* *addhi3_zero_extend.const */

        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_HImode
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_QImode))
            return -1;
          x10 = XEXP (x6, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_QImode)
              || !
#line 1757 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 190; /* *usum_widenqihi3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != ZERO_EXTEND
          || GET_MODE (x9) != E_HImode)
        return -1;
      x11 = XEXP (x5, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern156 (x1, 
E_HImode) != 0)
        return -1;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 1729 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 188; /* *addhi3_zero_extend.ashift1 */

    case SIGN_EXTEND:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 36
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      switch (pattern273 (x4))
        {
        case 0:
          if (!
#line 1989 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1
   && (2 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 235; /* *addhi3.sign_extend.qi */

        case 1:
          if (!
#line 1989 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 236; /* *addpsi3.sign_extend.qi */

        case 2:
          if (!
#line 1989 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 240; /* *addpsi3.sign_extend.hi */

        case 3:
          if (!
#line 1989 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 238; /* *addsi3.sign_extend.qi */

        case 4:
          if (!
#line 1989 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 242; /* *addsi3.sign_extend.hi */

        case 5:
          if (!
#line 1989 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 244; /* *addsi3.sign_extend.psi */

        default:
          return -1;
        }

    case GE:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 380; /* *addqi3.ge0 */

        case 1:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 388; /* *addqi3.ge0 */

        case 2:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 396; /* *addqi3.ge0 */

        case 3:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 404; /* *addqi3.ge0 */

        case 4:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 382; /* *addhi3.ge0 */

        case 5:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 390; /* *addhi3.ge0 */

        case 6:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 398; /* *addhi3.ge0 */

        case 7:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 406; /* *addhi3.ge0 */

        case 8:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 384; /* *addpsi3.ge0 */

        case 9:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 392; /* *addpsi3.ge0 */

        case 10:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 400; /* *addpsi3.ge0 */

        case 11:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 408; /* *addpsi3.ge0 */

        case 12:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 386; /* *addsi3.ge0 */

        case 13:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 394; /* *addsi3.ge0 */

        case 14:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 402; /* *addsi3.ge0 */

        case 15:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 410; /* *addsi3.ge0 */

        default:
          return -1;
        }

    case LT:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 381; /* *addqi3.lt0 */

        case 1:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 389; /* *addqi3.lt0 */

        case 2:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 397; /* *addqi3.lt0 */

        case 3:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 405; /* *addqi3.lt0 */

        case 4:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 383; /* *addhi3.lt0 */

        case 5:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 391; /* *addhi3.lt0 */

        case 6:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 399; /* *addhi3.lt0 */

        case 7:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 407; /* *addhi3.lt0 */

        case 8:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 385; /* *addpsi3.lt0 */

        case 9:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 393; /* *addpsi3.lt0 */

        case 10:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 401; /* *addpsi3.lt0 */

        case 11:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 409; /* *addpsi3.lt0 */

        case 12:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 387; /* *addsi3.lt0 */

        case 13:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 395; /* *addsi3.lt0 */

        case 14:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 403; /* *addsi3.lt0 */

        case 15:
          if (!
#line 2381 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 411; /* *addsi3.lt0 */

        default:
          return -1;
        }

    case MULT:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x9 = XEXP (x5, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          if (pattern220 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          operands[2] = x11;
          if (!register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x8 = XEXP (x2, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 36
                  || GET_MODE (x8) != E_CCmode
                  || !
#line 2602 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 491; /* *maddqi4 */

            case CONST_INT:
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2640 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 494; /* *maddqi4.const */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern221 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          switch (GET_CODE (x11))
            {
            case SIGN_EXTEND:
              if (pattern342 (x1) != 0
                  || !
#line 2711 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 498; /* *maddqihi4 */

            case ZERO_EXTEND:
              if (pattern342 (x1) != 0
                  || !
#line 2771 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              return 507; /* *sumsubqihi4 */

            case CONST_INT:
              operands[2] = x11;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode))
                return -1;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2850 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 513; /* *maddqihi4.sconst */
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2942 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              return 519; /* *sumaddqihi4.uconst */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern221 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          switch (GET_CODE (x11))
            {
            case ZERO_EXTEND:
              if (pattern342 (x1) != 0
                  || !
#line 2711 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 499; /* *umaddqihi4 */

            case SIGN_EXTEND:
              if (pattern342 (x1) != 0
                  || !
#line 2771 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              return 506; /* *usmsubqihi4 */

            case CONST_INT:
              operands[2] = x11;
              if (!u8_operand (operands[2], E_HImode))
                return -1;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2850 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 514; /* *umaddqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_84 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (pnum_clobbers == NULL
              || pattern162 (x1) != 0)
            return -1;
          x4 = XEXP (x3, 1);
          x5 = XEXP (x4, 1);
          operands[0] = x5;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          x7 = XEXP (x6, 1);
          x8 = XEXP (x7, 1);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          *pnum_clobbers = 2;
          return 997; /* epilogue_restores */

        case 2:
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != UNSPEC_VOLATILE
              || XVECLEN (x4, 0) != 1)
            return -1;
          x9 = XVECEXP (x2, 0, 0);
          operands[0] = x9;
          switch (XINT (x2, 1))
            {
            case 3:
              if (pnum_clobbers == NULL
                  || pattern267 (x1) != 0
                  || !
#line 8668 "../../gcc/config/avr/avr.md"
(avropt_gasisr_prologues))
                return -1;
              *pnum_clobbers = 1;
              return 998; /* *gasisr */

            case 10:
              switch (pattern235 (x1))
                {
                case 0:
                  return 1003; /* delay_cycles_1 */

                case 1:
                  return 1005; /* delay_cycles_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L
              || pattern161 (x1) != 0
              || REGNO (x6) != 36
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (pattern276 (x1))
            {
            case 0:
              if (!
#line 1471 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 169; /* *clrmemqi */

            case 1:
              if (!
#line 1505 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 171; /* *clrmemhi */

            default:
              return -1;
            }

        case DIV:
          if (pattern215 (x1, 
MOD) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          switch (pattern330 (x1))
            {
            case 0:
              return 584; /* divmodqi4 */

            case 1:
              return 590; /* divmodhi4 */

            case 2:
              return 612; /* divmodsi4 */

            default:
              break;
            }
          x9 = XEXP (x2, 0);
          if (REGNO (x9) != 26
              || pattern331 (x1) != 0
              || !
#line 4319 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 608; /* *divmodpsi4_call */

        case UDIV:
          if (pattern215 (x1, 
UMOD) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          switch (pattern330 (x1))
            {
            case 0:
              return 587; /* udivmodqi4 */

            case 1:
              return 593; /* udivmodhi4 */

            case 2:
              return 615; /* udivmodsi4 */

            default:
              break;
            }
          x9 = XEXP (x2, 0);
          if (REGNO (x9) != 26
              || pattern331 (x1) != 0
              || !
#line 4368 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 611; /* *udivmodpsi4_call */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (pattern138 (x1) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          x11 = XEXP (x10, 0);
          if (GET_MODE (x11) != E_HImode)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != USE
              || pattern357 (x1, 
E_CCmode, 
36) != 0)
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          operands[0] = x12;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x13 = XEXP (x10, 1);
          x14 = XEXP (x13, 1);
          operands[1] = x14;
          if (!immediate_operand (operands[1], E_HImode))
            return -1;
          return 996; /* call_prologue_saves */

        case 2:
          if (XINT (x4, 1) != 10)
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x12) != SET)
            return -1;
          x16 = XEXP (x12, 1);
          if (GET_CODE (x16) != UNSPEC_VOLATILE
              || XVECLEN (x16, 0) != 1
              || XINT (x16, 1) != 6
              || GET_MODE (x16) != E_BLKmode)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != CLOBBER
              || pattern236 (x1) != 0)
            return -1;
          switch (XWINT (x15, 0))
            {
            case 3L:
              x6 = XEXP (x3, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 36
                  || GET_MODE (x6) != E_CCmode
                  || !
#line 8832 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1008; /* *delay_cycles_3 */

            case 4L:
              x6 = XEXP (x3, 0);
              operands[5] = x6;
              if (!scratch_operand (operands[5], E_QImode))
                return -1;
              return 1009; /* delay_cycles_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern119 (x2))
        {
        case 0:
          if (!(
#line 2010 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2012 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_135 (insn, operands);

        case 1:
          if (!(
#line 2010 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2012 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_137 (insn, operands);

        case 2:
          if (!(
#line 2010 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2012 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_141 (insn, operands);

        case 3:
          if (!(
#line 2010 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2012 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_139 (insn, operands);

        case 4:
          if (!(
#line 2010 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2012 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_143 (insn, operands);

        case 5:
          if (!(
#line 2010 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2012 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_145 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern119 (x2))
        {
        case 0:
          if (!(
#line 2010 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2012 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_136 (insn, operands);

        case 1:
          if (!(
#line 2010 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2012 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_138 (insn, operands);

        case 2:
          if (!(
#line 2010 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2012 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_142 (insn, operands);

        case 3:
          if (!(
#line 2010 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2012 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_140 (insn, operands);

        case 4:
          if (!(
#line 2010 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2012 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_144 (insn, operands);

        case 5:
          if (!(
#line 2010 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2012 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_146 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_PSImode:
          if (pattern178 (x2, 
E_PSImode) != 0
              || !
#line 2072 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_148 (insn, operands);

        case E_QImode:
          if (pattern201 (x2, 
E_QImode) != 0
              || !
#line 2099 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_149 (insn, operands);

        case E_QQmode:
          if (pattern201 (x2, 
E_QQmode) != 0
              || !
#line 2099 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_150 (insn, operands);

        case E_UQQmode:
          if (pattern201 (x2, 
E_UQQmode) != 0
              || !
#line 2099 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_151 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern120 (x2))
        {
        case 0:
          if (!
#line 2294 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_166 (insn, operands);

        case 1:
          if (!
#line 2294 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_168 (insn, operands);

        case 2:
          if (!
#line 2294 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_170 (insn, operands);

        case 3:
          if (!
#line 2294 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_172 (insn, operands);

        case 4:
          if (!(
#line 2345 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2347 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 5:
          if (!(
#line 2345 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2347 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 6:
          if (!(
#line 2345 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2347 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 7:
          if (!(
#line 2345 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2347 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_198 (insn, operands);

        case 8:
          if (!(
#line 2345 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2347 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_202 (insn, operands);

        case 9:
          if (!(
#line 2345 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2347 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_204 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern120 (x2))
        {
        case 0:
          if (!
#line 2294 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_167 (insn, operands);

        case 1:
          if (!
#line 2294 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_169 (insn, operands);

        case 2:
          if (!
#line 2294 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_171 (insn, operands);

        case 3:
          if (!
#line 2294 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_173 (insn, operands);

        case 4:
          if (!(
#line 2345 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2347 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 5:
          if (!(
#line 2345 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2347 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_197 (insn, operands);

        case 6:
          if (!(
#line 2345 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2347 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_201 (insn, operands);

        case 7:
          if (!(
#line 2345 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2347 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 8:
          if (!(
#line 2345 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2347 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_203 (insn, operands);

        case 9:
          if (!(
#line 2345 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2347 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_205 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      switch (pattern122 (x2))
        {
        case 0:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_238 (insn, operands);

        case 1:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_246 (insn, operands);

        case 2:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_254 (insn, operands);

        case 3:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_262 (insn, operands);

        case 4:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_240 (insn, operands);

        case 5:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_248 (insn, operands);

        case 6:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_256 (insn, operands);

        case 7:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_264 (insn, operands);

        case 8:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_242 (insn, operands);

        case 9:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_250 (insn, operands);

        case 10:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_258 (insn, operands);

        case 11:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_266 (insn, operands);

        case 12:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_244 (insn, operands);

        case 13:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_252 (insn, operands);

        case 14:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_260 (insn, operands);

        case 15:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_268 (insn, operands);

        default:
          return NULL;
        }

    case LT:
      switch (pattern122 (x2))
        {
        case 0:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_239 (insn, operands);

        case 1:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_247 (insn, operands);

        case 2:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_255 (insn, operands);

        case 3:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_263 (insn, operands);

        case 4:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_241 (insn, operands);

        case 5:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_249 (insn, operands);

        case 6:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_257 (insn, operands);

        case 7:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_265 (insn, operands);

        case 8:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_243 (insn, operands);

        case 9:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_251 (insn, operands);

        case 10:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_259 (insn, operands);

        case 11:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_267 (insn, operands);

        case 12:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_245 (insn, operands);

        case 13:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_253 (insn, operands);

        case 14:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_261 (insn, operands);

        case 15:
          if (!
#line 2417 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_269 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (pattern176 (x2) != 0
              || !register_operand (operands[2], E_QImode)
              || !(
#line 2613 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2615 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_278 (insn, operands);

        case SIGN_EXTEND:
          if (pattern199 (x2) != 0)
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2725 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2727 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_283 (insn, operands);

            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2789 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND) && 
#line 2793 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_288 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (pattern199 (x2) != 0)
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2725 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2727 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_284 (insn, operands);

            case SIGN_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2789 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND) && 
#line 2793 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_287 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern178 (x2, 
E_QImode) == 0
              && (
#line 2200 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2202 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_162 (insn, operands);
          break;

        case E_HImode:
          if (pattern178 (x2, 
E_HImode) == 0
              && (
#line 3268 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3270 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_310 (insn, operands);
          break;

        case E_QQmode:
          if (pattern178 (x2, 
E_QQmode) == 0
              && (
#line 296 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 298 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return gen_split_1805 (insn, operands);
          break;

        case E_UQQmode:
          if (pattern178 (x2, 
E_UQQmode) == 0
              && (
#line 317 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 319 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return gen_split_1806 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 16
          || GET_CODE (x5) != REG
          || REGNO (x5) != 20
          || GET_CODE (x4) != REG)
        return NULL;
      switch (pattern25 (x1, 
24))
        {
        case 0:
          if (!(
#line 468 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 470 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return NULL;
          return gen_split_1812 (insn, operands);

        case 1:
          if (!(
#line 468 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 470 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return NULL;
          return gen_split_1813 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (register_operand (operands[1], E_QImode))
            {
              res = split_3 (x1, insn);
              if (res != NULL_RTX)
                return res;
            }
          if (GET_CODE (x6) != REG)
            return NULL;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG)
            return NULL;
          switch (REGNO (x6))
            {
            case 18:
              if (GET_MODE (x6) != E_HImode)
                return NULL;
              x5 = XEXP (x2, 1);
              if (GET_CODE (x5) != SIGN_EXTEND
                  || pattern238 (x5, 
E_HImode, 
E_SImode) != 0
                  || pattern184 (x1, 
E_SImode, 
22) != 0
                  || !(
#line 3770 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3772 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_337 (insn, operands);

            case 26:
              if (pattern185 (x1, 
E_SImode, 
22, 
18, 
E_HImode) != 0
                  || !(
#line 3841 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3843 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_342 (insn, operands);

            case 25:
              if (pattern185 (x1, 
E_PSImode, 
18, 
22, 
E_QImode) != 0
                  || !(
#line 4220 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4222 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_357 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10865 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10869 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_975 (insn, operands);

        case 2:
          if (!(
#line 10865 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10869 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_977 (insn, operands);

        case 3:
          if (!(
#line 10865 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10869 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_981 (insn, operands);

        case 4:
          if (!(
#line 10865 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10869 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_979 (insn, operands);

        case 5:
          if (!(
#line 10865 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10869 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_983 (insn, operands);

        case 6:
          if (!(
#line 10865 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10869 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_985 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          res = split_4 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG)
            return NULL;
          switch (pattern123 (x1))
            {
            case 0:
              if (!(
#line 3770 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3772 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_338 (insn, operands);

            case 1:
              if (!(
#line 3820 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3822 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_341 (insn, operands);

            case 2:
              if (!(
#line 3841 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3843 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_343 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10865 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10869 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_976 (insn, operands);

        case 2:
          if (!(
#line 10865 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10869 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_978 (insn, operands);

        case 3:
          if (!(
#line 10865 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10869 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_982 (insn, operands);

        case 4:
          if (!(
#line 10865 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10869 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_980 (insn, operands);

        case 5:
          if (!(
#line 10865 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10869 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_984 (insn, operands);

        case 6:
          if (!(
#line 10865 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10869 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_986 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != ZERO_EXTEND)
        return NULL;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != NOT)
        return NULL;
      if (GET_MODE (x7) == E_QImode)
        {
          res = split_5 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      if (GET_MODE (x7) != E_HImode
          || pattern151 (x1) != 0
          || !(
#line 3862 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3864 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_344 (insn, operands);

    case AND:
      switch (pattern33 (x1))
        {
        case 0:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_955 (insn, operands);

        case 1:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_959 (insn, operands);

        case 2:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_963 (insn, operands);

        case 3:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_967 (insn, operands);

        case 4:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_956 (insn, operands);

        case 5:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_960 (insn, operands);

        case 6:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_964 (insn, operands);

        case 7:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_968 (insn, operands);

        case 8:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_957 (insn, operands);

        case 9:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_961 (insn, operands);

        case 10:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_965 (insn, operands);

        case 11:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_969 (insn, operands);

        case 12:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_958 (insn, operands);

        case 13:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_962 (insn, operands);

        case 14:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_966 (insn, operands);

        case 15:
          if (!(
#line 10835 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_970 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern17 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern81 (x1))
        {
        case 0:
          if (
#line 6218 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_540 (insn, operands);
          break;

        case 1:
          if (
#line 6254 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_542 (insn, operands);
          break;

        case 2:
          if (
#line 6274 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_543 (insn, operands);
          break;

        case 3:
          if (
#line 6295 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_544 (insn, operands);
          break;

        case 4:
          if (
#line 6329 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_545 (insn, operands);
          break;

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case SUBREG:
          switch (pattern82 (x1))
            {
            case 0:
              if (!(
#line 10542 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10544 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_747 (insn, operands);

            case 1:
              if (!(
#line 10542 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10544 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_748 (insn, operands);

            case 2:
              if (!(
#line 10542 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10544 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_749 (insn, operands);

            case 3:
              if (!(
#line 10542 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10544 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_750 (insn, operands);

            default:
              return NULL;
            }

        case REG:
          if (REGNO (x3) != 18
              || GET_MODE (x3) != E_DImode
              || pattern34 (x1, 
E_DImode, 
18) != 0
              || !(
#line 421 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 423 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1903 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (!
#line 6236 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_541 (insn, operands);

    case 2:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_790 (insn, operands);

    case 3:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_791 (insn, operands);

    case 4:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_792 (insn, operands);

    case 5:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_793 (insn, operands);

    case 6:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_794 (insn, operands);

    case 7:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_795 (insn, operands);

    case 8:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_796 (insn, operands);

    case 9:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_797 (insn, operands);

    case 10:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_802 (insn, operands);

    case 11:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_803 (insn, operands);

    case 12:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_804 (insn, operands);

    case 13:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_805 (insn, operands);

    case 14:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_798 (insn, operands);

    case 15:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_799 (insn, operands);

    case 16:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_800 (insn, operands);

    case 17:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_801 (insn, operands);

    case 18:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_806 (insn, operands);

    case 19:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_807 (insn, operands);

    case 20:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_808 (insn, operands);

    case 21:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_809 (insn, operands);

    case 22:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_810 (insn, operands);

    case 23:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_811 (insn, operands);

    case 24:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_812 (insn, operands);

    case 25:
      if (!(
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10674 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_813 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_21 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case LSHIFTRT:
      if (GET_MODE (x3) != E_HImode)
        return NULL;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MULT
          || GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return NULL;
      x7 = XEXP (x4, 0);
      if (GET_MODE (x7) != E_HImode)
        return NULL;
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != E_HImode)
        return NULL;
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x8) != SIGN_EXTEND)
            return NULL;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_QImode))
            return NULL;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_QImode)
              || !(
#line 2260 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2262 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_164 (insn, operands);

        case ZERO_EXTEND:
          if (GET_CODE (x8) != ZERO_EXTEND)
            return NULL;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_QImode))
            return NULL;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_QImode)
              || !(
#line 2260 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2262 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_165 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x3) != E_SImode
          || pattern35 (x1, 
E_SImode, 
22) != 0
          || !
#line 9229 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_640 (insn, operands);

    case POPCOUNT:
      if (GET_MODE (x3) != E_SImode
          || pattern35 (x1, 
E_SImode, 
22) != 0
          || !
#line 9305 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_643 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_26 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_QImode))
    return NULL;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 1);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern296 (x6, 
E_HImode) != 0
              || !
#line 2130 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_152 (insn, operands);

        case E_HQmode:
          if (pattern296 (x6, 
E_HQmode) != 0
              || !
#line 2130 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_153 (insn, operands);

        case E_UHQmode:
          if (pattern296 (x6, 
E_UHQmode) != 0
              || !
#line 2130 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_154 (insn, operands);

        case E_HAmode:
          if (pattern296 (x6, 
E_HAmode) != 0
              || !
#line 2130 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_155 (insn, operands);

        case E_UHAmode:
          if (pattern296 (x6, 
E_UHAmode) != 0
              || !
#line 2130 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_156 (insn, operands);

        case E_SImode:
          if (pattern296 (x6, 
E_SImode) != 0
              || !
#line 2160 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_157 (insn, operands);

        case E_SQmode:
          if (pattern296 (x6, 
E_SQmode) != 0
              || !
#line 2160 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_158 (insn, operands);

        case E_USQmode:
          if (pattern296 (x6, 
E_USQmode) != 0
              || !
#line 2160 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_159 (insn, operands);

        case E_SAmode:
          if (pattern296 (x6, 
E_SAmode) != 0
              || !
#line 2160 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_160 (insn, operands);

        case E_USAmode:
          if (pattern296 (x6, 
E_USAmode) != 0
              || !
#line 2160 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_161 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      operands[4] = x5;
      switch (pattern223 (x6))
        {
        case 0:
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 2657 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2659 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_280 (insn, operands);

        case 1:
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2872 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2874 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_292 (insn, operands);
          if (!u8_operand (operands[2], E_HImode)
              || !(
#line 2963 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)) && 
#line 2966 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_297 (insn, operands);

        case 2:
          if (!u8_operand (operands[2], E_HImode)
              || !(
#line 2872 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2874 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_293 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      if (pattern210 (x6) != 0)
        return NULL;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      operands[4] = x5;
      x10 = XEXP (x7, 0);
      switch (pattern340 (x10))
        {
        case 0:
          if (!(
#line 2895 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2897 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_294 (insn, operands);

        case 1:
          if (!(
#line 2919 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2921 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_295 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!l_register_operand (operands[0], E_QImode)
          || !const_operand (operands[1], E_QImode)
          || !
#line 887 "../../gcc/config/avr/avr.md"
(!satisfies_constraint_Y00 (operands[1])
   && !satisfies_constraint_Y01 (operands[1])
   && !satisfies_constraint_Ym1 (operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_1 (insn, operands);

    case E_QQmode:
      if (!l_register_operand (operands[0], E_QQmode)
          || !const_operand (operands[1], E_QQmode)
          || !
#line 887 "../../gcc/config/avr/avr.md"
(!satisfies_constraint_Y00 (operands[1])
   && !satisfies_constraint_Y01 (operands[1])
   && !satisfies_constraint_Ym1 (operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_2 (insn, operands);

    case E_UQQmode:
      if (!l_register_operand (operands[0], E_UQQmode)
          || !const_operand (operands[1], E_UQQmode)
          || !
#line 887 "../../gcc/config/avr/avr.md"
(!satisfies_constraint_Y00 (operands[1])
   && !satisfies_constraint_Y01 (operands[1])
   && !satisfies_constraint_Ym1 (operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_3 (insn, operands);

    case E_HImode:
      if (l_register_operand (operands[0], E_HImode)
          && const_or_immediate_operand (operands[1], E_HImode)
          && 
#line 926 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (HImode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_4 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2
          || !d_register_operand (operands[0], E_HImode))
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != PARALLEL)
        return NULL;
      if (const_int_operand (operands[1], E_HImode))
        {
          switch (XVECLEN (x6, 0))
            {
            case 3:
              switch (pattern300 (x6, 
E_HImode))
                {
                case 0:
                  if (
#line 1031 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_15 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if (
#line 1031 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_16 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if (
#line 1031 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_17 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
              break;

            case 2:
              if (pattern303 (x6, 
E_HImode, 
PLUS) == 0)
                {
                  x7 = XVECEXP (x6, 0, 0);
                  x8 = XEXP (x7, 1);
                  x9 = XEXP (x8, 1);
                  operands[2] = x9;
                  if (register_operand (operands[2], E_HImode))
                    {
                      x10 = XEXP (x8, 0);
                      if (rtx_equal_p (x10, operands[0]))
                        {
                          x11 = XEXP (x7, 0);
                          if (rtx_equal_p (x11, operands[0])
                              && 
#line 1050 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                            {
                              *pmatch_len_ = 1;
                              res = gen_peephole2_24 (insn, operands);
                              if (res != NULL_RTX)
                                return res;
                            }
                        }
                    }
                }
              break;

            default:
              break;
            }
        }
      if (XVECLEN (x6, 0) != 2
          || !const_operand (operands[1], E_HImode)
          || pattern298 (x6, 
E_HImode) != 0
          || !
#line 1863 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_32 (insn, operands);

    case E_HQmode:
      if (l_register_operand (operands[0], E_HQmode)
          && const_or_immediate_operand (operands[1], E_HQmode)
          && 
#line 926 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (HQmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_5 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern299 (x6, 
E_HQmode) != 0
          || !
#line 1863 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_33 (insn, operands);

    case E_UHQmode:
      if (l_register_operand (operands[0], E_UHQmode)
          && const_or_immediate_operand (operands[1], E_UHQmode)
          && 
#line 926 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (UHQmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_6 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern299 (x6, 
E_UHQmode) != 0
          || !
#line 1863 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_34 (insn, operands);

    case E_HAmode:
      if (l_register_operand (operands[0], E_HAmode)
          && const_or_immediate_operand (operands[1], E_HAmode)
          && 
#line 926 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (HAmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_7 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern299 (x6, 
E_HAmode) != 0
          || !
#line 1863 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_35 (insn, operands);

    case E_UHAmode:
      if (l_register_operand (operands[0], E_UHAmode)
          && const_or_immediate_operand (operands[1], E_UHAmode)
          && 
#line 926 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (UHAmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_8 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern299 (x6, 
E_UHAmode) != 0
          || !
#line 1863 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_36 (insn, operands);

    case E_PSImode:
      if (peep2_current_count >= 2)
        {
          x6 = PATTERN (peep2_next_insn (1));
          switch (pattern301 (x6, 
E_PSImode))
            {
            case 0:
              if (
#line 1031 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_18 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 1031 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_19 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 1031 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_20 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!l_register_operand (operands[0], E_PSImode)
          || !immediate_operand (operands[1], E_PSImode)
          || !
#line 1103 "../../gcc/config/avr/avr.md"
(operands[1] != const0_rtx
   && operands[1] != constm1_rtx))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_25 (insn, operands);

    case E_SImode:
      if (peep2_current_count >= 2)
        {
          x6 = PATTERN (peep2_next_insn (1));
          switch (pattern301 (x6, 
E_SImode))
            {
            case 0:
              if (
#line 1031 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_21 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 1031 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_22 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 1031 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_23 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!l_register_operand (operands[0], E_SImode)
          || !immediate_operand (operands[1], E_SImode)
          || !
#line 1158 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SImode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_26 (insn, operands);

    case E_SQmode:
      if (!l_register_operand (operands[0], E_SQmode)
          || !immediate_operand (operands[1], E_SQmode)
          || !
#line 1158 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SQmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_27 (insn, operands);

    case E_USQmode:
      if (!l_register_operand (operands[0], E_USQmode)
          || !immediate_operand (operands[1], E_USQmode)
          || !
#line 1158 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (USQmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_28 (insn, operands);

    case E_SAmode:
      if (!l_register_operand (operands[0], E_SAmode)
          || !immediate_operand (operands[1], E_SAmode)
          || !
#line 1158 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SAmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_29 (insn, operands);

    case E_USAmode:
      if (!l_register_operand (operands[0], E_USAmode)
          || !immediate_operand (operands[1], E_USAmode)
          || !
#line 1158 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (USAmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_30 (insn, operands);

    case E_SFmode:
      if (!l_register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 1262 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SFmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_31 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x7) != PARALLEL)
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern314 (x7) != 0)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (odd_register_operand (operands[2], E_QImode)
          && even_register_operand (operands[0], E_QImode)
          && even_register_operand (operands[1], E_QImode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (odd_register_operand (operands[3], E_QImode)
              && 
#line 982 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[0]) == REGNO (operands[2]) - 1
   && REGNO (operands[1]) == REGNO (operands[3]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_9 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (even_register_operand (operands[2], E_QImode)
          && odd_register_operand (operands[0], E_QImode)
          && odd_register_operand (operands[1], E_QImode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (even_register_operand (operands[3], E_QImode)
              && 
#line 1000 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[2]) == REGNO (operands[0]) - 1
   && REGNO (operands[3]) == REGNO (operands[1]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_12 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3)
        return NULL;
      switch (pattern364 (x8, 
E_QImode))
        {
        case 0:
          if (!
#line 4981 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_76 (insn, operands);

        case 1:
          if (!
#line 4981 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_77 (insn, operands);

        case 2:
          if (!
#line 4981 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_78 (insn, operands);

        default:
          return NULL;
        }

    case E_QQmode:
      if (pattern314 (x7) != 0)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (odd_register_operand (operands[2], E_QQmode)
          && even_register_operand (operands[0], E_QQmode)
          && even_register_operand (operands[1], E_QQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (odd_register_operand (operands[3], E_QQmode)
              && 
#line 982 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[0]) == REGNO (operands[2]) - 1
   && REGNO (operands[1]) == REGNO (operands[3]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (even_register_operand (operands[2], E_QQmode)
          && odd_register_operand (operands[0], E_QQmode)
          && odd_register_operand (operands[1], E_QQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (even_register_operand (operands[3], E_QQmode)
              && 
#line 1000 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[2]) == REGNO (operands[0]) - 1
   && REGNO (operands[3]) == REGNO (operands[1]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_13 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3)
        return NULL;
      switch (pattern364 (x8, 
E_QQmode))
        {
        case 0:
          if (!
#line 4981 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_79 (insn, operands);

        case 1:
          if (!
#line 4981 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_80 (insn, operands);

        case 2:
          if (!
#line 4981 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_81 (insn, operands);

        default:
          return NULL;
        }

    case E_UQQmode:
      if (pattern314 (x7) != 0)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (odd_register_operand (operands[2], E_UQQmode)
          && even_register_operand (operands[0], E_UQQmode)
          && even_register_operand (operands[1], E_UQQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (odd_register_operand (operands[3], E_UQQmode)
              && 
#line 982 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[0]) == REGNO (operands[2]) - 1
   && REGNO (operands[1]) == REGNO (operands[3]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_11 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (even_register_operand (operands[2], E_UQQmode)
          && odd_register_operand (operands[0], E_UQQmode)
          && odd_register_operand (operands[1], E_UQQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (even_register_operand (operands[3], E_UQQmode)
              && 
#line 1000 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[2]) == REGNO (operands[0]) - 1
   && REGNO (operands[3]) == REGNO (operands[1]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_14 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3)
        return NULL;
      switch (pattern364 (x8, 
E_UQQmode))
        {
        case 0:
          if (!
#line 4981 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_82 (insn, operands);

        case 1:
          if (!
#line 4981 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_83 (insn, operands);

        case 2:
          if (!
#line 4981 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_84 (insn, operands);

        default:
          return NULL;
        }

    case E_HImode:
      switch (pattern315 (x7, 
E_HImode))
        {
        case 0:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_43 (insn, operands);

        case 1:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_44 (insn, operands);

        case 2:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_45 (insn, operands);

        default:
          return NULL;
        }

    case E_SImode:
      switch (pattern315 (x7, 
E_SImode))
        {
        case 0:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_46 (insn, operands);

        case 1:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_47 (insn, operands);

        case 2:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_48 (insn, operands);

        default:
          return NULL;
        }

    case E_PSImode:
      switch (pattern315 (x7, 
E_PSImode))
        {
        case 0:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_49 (insn, operands);

        case 1:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_50 (insn, operands);

        case 2:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_51 (insn, operands);

        default:
          return NULL;
        }

    case E_HQmode:
      switch (pattern315 (x7, 
E_HQmode))
        {
        case 0:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_52 (insn, operands);

        case 1:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_53 (insn, operands);

        case 2:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_54 (insn, operands);

        default:
          return NULL;
        }

    case E_UHQmode:
      switch (pattern315 (x7, 
E_UHQmode))
        {
        case 0:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_55 (insn, operands);

        case 1:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_56 (insn, operands);

        case 2:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_57 (insn, operands);

        default:
          return NULL;
        }

    case E_HAmode:
      switch (pattern315 (x7, 
E_HAmode))
        {
        case 0:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_58 (insn, operands);

        case 1:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_59 (insn, operands);

        case 2:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_60 (insn, operands);

        default:
          return NULL;
        }

    case E_UHAmode:
      switch (pattern315 (x7, 
E_UHAmode))
        {
        case 0:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_61 (insn, operands);

        case 1:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_62 (insn, operands);

        case 2:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_63 (insn, operands);

        default:
          return NULL;
        }

    case E_SQmode:
      switch (pattern315 (x7, 
E_SQmode))
        {
        case 0:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_64 (insn, operands);

        case 1:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_65 (insn, operands);

        case 2:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_66 (insn, operands);

        default:
          return NULL;
        }

    case E_USQmode:
      switch (pattern315 (x7, 
E_USQmode))
        {
        case 0:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_67 (insn, operands);

        case 1:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_68 (insn, operands);

        case 2:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_69 (insn, operands);

        default:
          return NULL;
        }

    case E_SAmode:
      switch (pattern315 (x7, 
E_SAmode))
        {
        case 0:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_70 (insn, operands);

        case 1:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_71 (insn, operands);

        case 2:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_72 (insn, operands);

        default:
          return NULL;
        }

    case E_USAmode:
      switch (pattern315 (x7, 
E_USAmode))
        {
        case 0:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_73 (insn, operands);

        case 1:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_74 (insn, operands);

        case 2:
          if (!
#line 4948 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_75 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
