/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  x7 = XEXP (x4, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || GET_MODE (x4) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !const7_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || !const15_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_HImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || GET_MODE (x4) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || !const23_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_PSImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !const31_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x7) != E_HImode
              || !register_operand (operands[1], E_QImode)
              || !const15_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || GET_MODE (x4) != E_PSImode
              || GET_MODE (x7) != E_PSImode
              || !const23_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_PSImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 5;

            case E_HImode:
              if (!register_operand (operands[1], E_HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x7) != E_SImode
              || !const31_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_SImode))
            return -1;
          res = pattern4 ();
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      return pattern42 (x3); /* [-1, 2] */

    case ZERO_EXTEND:
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          res = pattern44 (x3);
          if (res >= 0)
            return res + 3; /* [3, 8] */
          return -1;

        case AND:
          res = pattern2 (x3);
          if (res >= 0)
            return res + 9; /* [9, 14] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != AND)
        return -1;
      res = pattern2 (x3);
      if (res >= 0)
        return res + 15; /* [15, 20] */
      return -1;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x4, 2);
  operands[1] = x7;
  if (!const_0_to_7_operand (operands[1], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !nox_general_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!nonimmediate_operand (operands[0], E_QQmode)
          || !nox_general_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!nonimmediate_operand (operands[0], E_UQQmode)
          || !nox_general_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      return 3;

    case E_HQmode:
      if (!nonimmediate_operand (operands[0], E_HQmode)
          || !nox_general_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!nonimmediate_operand (operands[0], E_UHQmode)
          || !nox_general_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!nonimmediate_operand (operands[0], E_HAmode)
          || !nox_general_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!nonimmediate_operand (operands[0], E_UHAmode)
          || !nox_general_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_PSImode:
      return 8;

    case E_SImode:
      return 9;

    case E_SQmode:
      return 10;

    case E_USQmode:
      return 11;

    case E_SAmode:
      return 12;

    case E_USAmode:
      return 13;

    case E_SFmode:
      return 14;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      return 0;

    case ZERO_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != CONST_INT)
            return -1;
          return 1;

        case AND:
          res = pattern2 (x1);
          if (res >= 0)
            return res + 2; /* [2, 7] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          x6 = XEXP (x1, 1);
          res = pattern75 (x6);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case AND:
          res = pattern2 (x1);
          if (res >= 0)
            return res + 10; /* [10, 15] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!reg_or_low_io_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x2, 2);
  operands[2] = x6;
  if (!const_0_to_7_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern92 (rtx x1, unsigned int i1, machine_mode i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i4
      || GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i4
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  return pattern91 (x6, 
i1, 
i2); /* [-1, 0] */
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern99 (x5, 
E_HImode); /* [-1, 0] */

    case E_PSImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern99 (x5, 
E_PSImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern99 (x5, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern113 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode)
          || pattern115 (x1) != 0)
        return -1;
      return 0;

    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      res = pattern78 (x1);
      if (res >= 0)
        return res + 1; /* [1, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern121 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern121 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern121 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern121 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 2);
  operands[2] = x4;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern124 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern124 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern124 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern124 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1
      || pattern131 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern135 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      if (pnum_clobbers == NULL
          || REGNO (x4) != 22)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 24)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 22)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 24:
          return pattern132 (x1, 
E_QImode, 
25); /* [-1, 0] */

        case 22:
          if (pattern132 (x1, 
E_HImode, 
24) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (pnum_clobbers == NULL
          || REGNO (x4) != 18)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 22)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 18)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 22:
          if (pattern132 (x1, 
E_PSImode, 
18) != 0)
            return -1;
          return 2;

        case 18:
          if (pattern132 (x1, 
E_SImode, 
22) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 25:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      res = pattern134 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 21
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 30
      || GET_MODE (x9) != E_HImode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode)
          || GET_MODE (x5) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !memory_operand (operands[1], E_QQmode)
          || GET_MODE (x5) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !memory_operand (operands[1], E_UQQmode)
          || GET_MODE (x5) != E_UQQmode)
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !memory_operand (operands[1], E_HImode)
          || GET_MODE (x5) != E_HImode)
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !memory_operand (operands[1], E_HQmode)
          || GET_MODE (x5) != E_HQmode)
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !memory_operand (operands[1], E_UHQmode)
          || GET_MODE (x5) != E_UHQmode)
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !memory_operand (operands[1], E_HAmode)
          || GET_MODE (x5) != E_HAmode)
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !memory_operand (operands[1], E_UHAmode)
          || GET_MODE (x5) != E_UHAmode)
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode)
          || GET_MODE (x5) != E_SImode)
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !memory_operand (operands[1], E_SQmode)
          || GET_MODE (x5) != E_SQmode)
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !memory_operand (operands[1], E_USQmode)
          || GET_MODE (x5) != E_USQmode)
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !memory_operand (operands[1], E_SAmode)
          || GET_MODE (x5) != E_SAmode)
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !memory_operand (operands[1], E_USAmode)
          || GET_MODE (x5) != E_USAmode)
        return -1;
      return 12;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_SFmode)
          || GET_MODE (x5) != E_SFmode)
        return -1;
      return 13;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !memory_operand (operands[1], E_PSImode)
          || GET_MODE (x5) != E_PSImode)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern191 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern198 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern213 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_2_to_7_operand (operands[2], E_HImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (x3))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      res = pattern4 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HQmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_HQmode)
        return -1;
      return 0;

    case E_UHQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_UHQmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_UHQmode)
        return -1;
      return 1;

    case E_HAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_HAmode)
        return -1;
      return 2;

    case E_UHAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_UHAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_UHAmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern236 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  if (!const_int_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_QImode))
    return -1;
  x12 = XEXP (x4, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  return 0;
}

int
pattern245 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x1, 0);
  if (REGNO (x5) != i3
      || GET_MODE (x5) != i1
      || GET_MODE (x2) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern250 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 24
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 25
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || pattern249 (x1, 
24, 
E_HImode, 
22, 
E_HImode) != 0)
    return -1;
  return 0;
}

int
pattern257 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!pseudo_register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!pseudo_register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern262 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  return pattern261 (x1); /* [-1, 1] */
}

int
pattern267 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != 3
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 32
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 32
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != UNSPEC_VOLATILE
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 6
      || GET_MODE (x7) != E_BLKmode
      || !const_int_operand (operands[0], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XVECEXP (x8, 0, 1);
  operands[1] = x9;
  if (!const_int_operand (operands[1], E_QImode))
    return -1;
  x10 = XEXP (x6, 0);
  operands[2] = x10;
  x11 = XVECEXP (x7, 0, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern279 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 24
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (REGNO (x5) != 25
      || pattern249 (x1, 
24, 
E_HImode, 
22, 
E_HImode) != 0)
    return -1;
  return 0;
}

int
pattern281 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 3:
      return pattern279 (x1); /* [-1, 0] */

    case 4:
      if (pattern279 (x1) != 0)
        return -1;
      return 1;

    case 5:
      if (pattern279 (x1) != 0)
        return -1;
      return 2;

    case 7:
      x4 = XVECEXP (x3, 0, 1);
      if (REGNO (x4) != 24)
        return -1;
      res = pattern280 (x1);
      if (res >= 0)
        return res + 3; /* [3, 12] */
      return -1;

    default:
      return -1;
    }
}

int
pattern285 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern290 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern296 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_or_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern300 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  switch (GET_CODE (x7))
    {
    case PLUS:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 0;

    case IOR:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 1;

    case AND:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern326 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (REGNO (x4))
    {
    case 22:
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 24
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 21
          || GET_MODE (x7) != E_QImode
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      if (GET_MODE (x10) != E_HImode)
        return -1;
      return 0;

    case 25:
      if (pattern325 (x1) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern336 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  if (!const0_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern335 (x3); /* [-1, 1] */
}

int
pattern340 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case ZERO_EXTEND:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_QImode)
          || !const_2_to_7_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case SIGN_EXTEND:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_QImode)
          || !const_1_to_6_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern345 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 18
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 26
      || GET_MODE (x5) != E_HImode)
    return -1;
  return 0;
}

int
pattern352 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1)
      || !nonmemory_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1)
      || !nonmemory_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern357 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i2
      || GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 30
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern351 (x4); /* [-1, 14] */
}

int
pattern366 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  if (!const_operand (operands[2], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern337 (x3); /* [-1, 0] */
}

int
pattern371 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  return pattern370 (x6); /* [-1, 2] */
}

int
pattern375 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern381 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case GE:
      return pattern375 (x4); /* [-1, 0] */

    case LT:
      if (pattern375 (x4) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) == MEM)
    {
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers != NULL)
    {
      switch (pattern111 (x3))
        {
        case 0:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 68; /* fxloadqi_A */
            }
          break;

        case 1:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 69; /* fxloadqq_A */
            }
          break;

        case 2:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 70; /* fxloaduqq_A */
            }
          break;

        case 3:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 71; /* fxloadhi_A */
            }
          break;

        case 4:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 72; /* fxloadhq_A */
            }
          break;

        case 5:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 73; /* fxloaduhq_A */
            }
          break;

        case 6:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 74; /* fxloadha_A */
            }
          break;

        case 7:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 75; /* fxloaduha_A */
            }
          break;

        case 8:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 76; /* fxloadsi_A */
            }
          break;

        case 9:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 77; /* fxloadsq_A */
            }
          break;

        case 10:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 78; /* fxloadusq_A */
            }
          break;

        case 11:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 79; /* fxloadsa_A */
            }
          break;

        case 12:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 80; /* fxloadusa_A */
            }
          break;

        case 13:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 81; /* fxloadsf_A */
            }
          break;

        case 14:
          if (
#line 669 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 82; /* fxloadpsi_A */
            }
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL
      || GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 21
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode
      || GET_CODE (x2) != REG
      || REGNO (x2) != 22)
    return -1;
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 83; /* fxload_qi_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 98; /* *fxload_qi_libgcc */

    case E_QQmode:
      if (GET_MODE (x3) != E_QQmode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 84; /* fxload_qq_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 99; /* *fxload_qq_libgcc */

    case E_UQQmode:
      if (GET_MODE (x3) != E_UQQmode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 85; /* fxload_uqq_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 100; /* *fxload_uqq_libgcc */

    case E_HImode:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 86; /* fxload_hi_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 101; /* *fxload_hi_libgcc */

    case E_HQmode:
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 87; /* fxload_hq_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 102; /* *fxload_hq_libgcc */

    case E_UHQmode:
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 88; /* fxload_uhq_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 103; /* *fxload_uhq_libgcc */

    case E_HAmode:
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 89; /* fxload_ha_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 104; /* *fxload_ha_libgcc */

    case E_UHAmode:
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 90; /* fxload_uha_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 105; /* *fxload_uha_libgcc */

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 91; /* fxload_si_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 106; /* *fxload_si_libgcc */

    case E_SQmode:
      if (GET_MODE (x3) != E_SQmode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 92; /* fxload_sq_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 107; /* *fxload_sq_libgcc */

    case E_USQmode:
      if (GET_MODE (x3) != E_USQmode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 93; /* fxload_usq_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 108; /* *fxload_usq_libgcc */

    case E_SAmode:
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 94; /* fxload_sa_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 109; /* *fxload_sa_libgcc */

    case E_USAmode:
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 95; /* fxload_usa_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 110; /* *fxload_usa_libgcc */

    case E_SFmode:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 96; /* fxload_sf_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 111; /* *fxload_sf_libgcc */

    case E_PSImode:
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      if (
#line 710 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 97; /* fxload_psi_libgcc */
        }
      if (!
#line 726 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 112; /* *fxload_psi_libgcc */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern39 (x1))
        {
        case 0:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != CONST_INT
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          if (XWINT (x4, 0) == 1L)
            return 526; /* *ashiftqihi2.signx.1_split */
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x4;
          if (const_2_to_6_operand (operands[2], E_HImode)
              && 
#line 3087 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 528; /* *ashifthi3.signx.const */
            }
          if (XWINT (x4, 0) != 7L
              || !
#line 3105 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 529; /* *ashifthi3.signx.const7 */

        case 1:
          if (!
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1445; /* *map.shl.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1447; /* *map.shl.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1451; /* *map.shl.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1449; /* *map.shl.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1453; /* *map.shl.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1455; /* *map.shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL
              || pattern114 (x2, 
E_HImode) != 0
              || !const_2_to_7_operand (operands[2], E_HImode)
              || !
#line 3123 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 530; /* *ashifthi3.zerox.const */

        case AND:
          x7 = XEXP (x6, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          switch (pattern37 (x2))
            {
            case 0:
              if (!
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
                return -1;
              return 1446; /* *map.shl.ext.and1-to-skip.hi */

            case 1:
              if (!
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
                return -1;
              return 1448; /* *map.shl.ext.and1-to-skip.psi */

            case 2:
              if (!
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
                return -1;
              return 1452; /* *map.shl.ext.and1-to-skip.psi */

            case 3:
              if (!
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
                return -1;
              return 1450; /* *map.shl.ext.and1-to-skip.si */

            case 4:
              if (!
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
                return -1;
              return 1454; /* *map.shl.ext.and1-to-skip.si */

            case 5:
              if (!
#line 10882 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
                return -1;
              return 1456; /* *map.shl.ext.and1-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_16 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG)
        return -1;
      switch (pattern53 (x1))
        {
        case 0:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3281; /* ashldi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3309; /* *ashldi3_insn */

        case 1:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3285; /* ashldq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3313; /* *ashldq3_insn */

        case 2:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3289; /* ashludq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3317; /* *ashludq3_insn */

        case 3:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3293; /* ashlda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3321; /* *ashlda3_insn */

        case 4:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3297; /* ashluda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3325; /* *ashluda3_insn */

        case 5:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3301; /* ashlta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3329; /* *ashlta3_insn */

        case 6:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3305; /* ashluta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3333; /* *ashluta3_insn */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 1L
          || pattern71 (x1) != 0)
        return -1;
      return 1013; /* mask1_0x01_split */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern17 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern81 (x1))
        {
        case 0:
          return 785; /* negqi2 */

        case 1:
          return 789; /* neghi2 */

        case 2:
          return 791; /* negpsi2 */

        case 3:
          return 793; /* negsi2 */

        case 4:
          return 796; /* negsf2 */

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case REG:
          res = recog_19 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case SUBREG:
          switch (pattern82 (x1))
            {
            case 0:
              if (
#line 10542 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1177; /* *neg.ashiftrtqi.msb */
              break;

            case 1:
              if (
#line 10542 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1178; /* *neg.ashiftrthi.msb */
              break;

            case 2:
              if (
#line 10542 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1179; /* *neg.ashiftrtpsi.msb */
              break;

            case 3:
              if (
#line 10542 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1180; /* *neg.ashiftrtsi.msb */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !
#line 6315 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 795; /* *negsi2 */

    case 1:
      return 787; /* *negqihi2_split */

    case 2:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1248; /* *neg.zextr-to-sextr.hi.qi */

    case 3:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1249; /* *neg.zextr-to-sextr.hi.hi */

    case 4:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1250; /* *neg.zextr-to-sextr.hi.psi */

    case 5:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1251; /* *neg.zextr-to-sextr.hi.si */

    case 6:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1252; /* *neg.zextr-to-sextr.psi.qi */

    case 7:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1253; /* *neg.zextr-to-sextr.psi.hi */

    case 8:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1254; /* *neg.zextr-to-sextr.psi.psi */

    case 9:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1255; /* *neg.zextr-to-sextr.psi.si */

    case 10:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1260; /* *neg.zextr-to-sextr.psi.qi */

    case 11:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1261; /* *neg.zextr-to-sextr.psi.hi */

    case 12:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1262; /* *neg.zextr-to-sextr.psi.psi */

    case 13:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1263; /* *neg.zextr-to-sextr.psi.si */

    case 14:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1256; /* *neg.zextr-to-sextr.si.qi */

    case 15:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1257; /* *neg.zextr-to-sextr.si.hi */

    case 16:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1258; /* *neg.zextr-to-sextr.si.psi */

    case 17:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1259; /* *neg.zextr-to-sextr.si.si */

    case 18:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1264; /* *neg.zextr-to-sextr.si.qi */

    case 19:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1265; /* *neg.zextr-to-sextr.si.hi */

    case 20:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1266; /* *neg.zextr-to-sextr.si.psi */

    case 21:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1267; /* *neg.zextr-to-sextr.si.si */

    case 22:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1268; /* *neg.zextr-to-sextr.si.qi */

    case 23:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1269; /* *neg.zextr-to-sextr.si.hi */

    case 24:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1270; /* *neg.zextr-to-sextr.si.psi */

    case 25:
      if (!
#line 10670 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1271; /* *neg.zextr-to-sextr.si.si */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) == 22)
    {
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) == REG
          && REGNO (x5) == 36
          && GET_MODE (x5) == E_CCmode)
        {
          x6 = XEXP (x2, 1);
          operands[0] = x6;
          switch (GET_MODE (x3))
            {
            case E_QImode:
              if (memory_operand (operands[0], E_QImode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 20; /* *load_qi_libgcc */
              break;

            case E_QQmode:
              if (memory_operand (operands[0], E_QQmode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 21; /* *load_qq_libgcc */
              break;

            case E_UQQmode:
              if (memory_operand (operands[0], E_UQQmode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 22; /* *load_uqq_libgcc */
              break;

            case E_HImode:
              if (memory_operand (operands[0], E_HImode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 23; /* *load_hi_libgcc */
              break;

            case E_HQmode:
              if (memory_operand (operands[0], E_HQmode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 24; /* *load_hq_libgcc */
              break;

            case E_UHQmode:
              if (memory_operand (operands[0], E_UHQmode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 25; /* *load_uhq_libgcc */
              break;

            case E_HAmode:
              if (memory_operand (operands[0], E_HAmode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 26; /* *load_ha_libgcc */
              break;

            case E_UHAmode:
              if (memory_operand (operands[0], E_UHAmode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 27; /* *load_uha_libgcc */
              break;

            case E_SImode:
              if (memory_operand (operands[0], E_SImode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 28; /* *load_si_libgcc */
              break;

            case E_SQmode:
              if (memory_operand (operands[0], E_SQmode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 29; /* *load_sq_libgcc */
              break;

            case E_USQmode:
              if (memory_operand (operands[0], E_USQmode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 30; /* *load_usq_libgcc */
              break;

            case E_SAmode:
              if (memory_operand (operands[0], E_SAmode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 31; /* *load_sa_libgcc */
              break;

            case E_USAmode:
              if (memory_operand (operands[0], E_USAmode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 32; /* *load_usa_libgcc */
              break;

            case E_SFmode:
              if (memory_operand (operands[0], E_SFmode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 33; /* *load_sf_libgcc */
              break;

            case E_PSImode:
              if (memory_operand (operands[0], E_PSImode)
                  && 
#line 580 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 34; /* *load_psi_libgcc */
              break;

            default:
              break;
            }
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x3;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!l_register_operand (operands[0], E_HImode)
          || !immediate_operand (operands[1], E_HImode)
          || !
#line 941 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 123; /* *reload_inhi */

    case E_HQmode:
      if (!l_register_operand (operands[0], E_HQmode)
          || !immediate_operand (operands[1], E_HQmode)
          || !
#line 941 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 124; /* *reload_inhq */

    case E_UHQmode:
      if (!l_register_operand (operands[0], E_UHQmode)
          || !immediate_operand (operands[1], E_UHQmode)
          || !
#line 941 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 125; /* *reload_inuhq */

    case E_HAmode:
      if (!l_register_operand (operands[0], E_HAmode)
          || !immediate_operand (operands[1], E_HAmode)
          || !
#line 941 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 126; /* *reload_inha */

    case E_UHAmode:
      if (!l_register_operand (operands[0], E_UHAmode)
          || !immediate_operand (operands[1], E_UHAmode)
          || !
#line 941 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 127; /* *reload_inuha */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x3, 0);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  switch (pattern277 (x1))
    {
    case 0:
      return 881; /* cbranchsi4_insn */

    case 1:
      return 882; /* cbranchsq4_insn */

    case 2:
      return 883; /* cbranchusq4_insn */

    case 3:
      return 884; /* cbranchsa4_insn */

    case 4:
      return 885; /* cbranchusa4_insn */

    case 5:
      return 886; /* cbranchpsi4_insn */

    case 6:
      return 887; /* cbranchhi4_insn */

    case 7:
      return 888; /* cbranchhq4_insn */

    case 8:
      return 889; /* cbranchuhq4_insn */

    case 9:
      return 890; /* cbranchha4_insn */

    case 10:
      return 891; /* cbranchuha4_insn */

    default:
      break;
    }
  if (GET_CODE (x9) != REG)
    return -1;
  switch (pattern278 (x1))
    {
    case 0:
      if (!
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3267; /* cbranch_const_di2_split */

    case 1:
      if (!
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3268; /* cbranch_const_dq2_split */

    case 2:
      if (!
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3269; /* cbranch_const_udq2_split */

    case 3:
      if (!
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3270; /* cbranch_const_da2_split */

    case 4:
      if (!
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3271; /* cbranch_const_uda2_split */

    case 5:
      if (!
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3272; /* cbranch_const_ta2_split */

    case 6:
      if (!
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3273; /* cbranch_const_uta2_split */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[0] = x4;
      if (ordered_comparison_operator (operands[0], E_VOIDmode))
        {
          res = recog_53 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x3, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (pattern91 (x9, 
36, 
E_CCmode) != 0)
        return -1;
      switch (GET_CODE (operands[0]))
        {
        case NE:
        case EQ:
          if (!eqne_operator (operands[0], E_VOIDmode))
            return -1;
          x10 = XEXP (x6, 0);
          operands[3] = x10;
          x11 = XEXP (x4, 0);
          switch (GET_CODE (x11))
            {
            case ZERO_EXTRACT:
              x12 = XEXP (x11, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x13 = XEXP (x11, 2);
              operands[2] = x13;
              if (!const_int_operand (operands[2], E_VOIDmode))
                return -1;
              x14 = XEXP (x11, 0);
              switch (GET_CODE (x14))
                {
                case REG:
                case SUBREG:
                  operands[1] = x14;
                  if (!register_operand (operands[1], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (x11))
                    {
                    case E_QImode:
                      if (!
#line 7651 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 953; /* *sbrx_branchqi */

                    case E_HImode:
                      if (!
#line 7651 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 954; /* *sbrx_branchhi */

                    case E_PSImode:
                      if (!
#line 7651 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 955; /* *sbrx_branchpsi */

                    case E_SImode:
                      if (!
#line 7651 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 956; /* *sbrx_branchsi */

                    case E_DImode:
                      if (!
#line 7651 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 957; /* *sbrx_branchdi */

                    default:
                      return -1;
                    }

                case MEM:
                  if (GET_MODE (x14) != E_QImode)
                    return -1;
                  x15 = XEXP (x14, 0);
                  operands[1] = x15;
                  switch (GET_MODE (x11))
                    {
                    case E_QImode:
                      if (low_io_address_operand (operands[1], E_VOIDmode)
                          && 
#line 8165 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return 984; /* *sbix_branch */
                      if (!high_io_address_operand (operands[1], E_VOIDmode)
                          || !
#line 8260 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 990; /* *sbix_branch_tmp */

                    case E_HImode:
                      if (low_io_address_operand (operands[1], E_VOIDmode)
                          && 
#line 8165 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return 985; /* *sbix_branch */
                      if (!high_io_address_operand (operands[1], E_VOIDmode)
                          || !
#line 8260 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 991; /* *sbix_branch_tmp */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case AND:
              x14 = XEXP (x11, 0);
              operands[1] = x14;
              x12 = XEXP (x11, 1);
              operands[2] = x12;
              switch (GET_MODE (x11))
                {
                case E_QImode:
                  if (!register_operand (operands[1], E_QImode)
                      || !single_one_operand (operands[2], E_QImode)
                      || !
#line 7699 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 962; /* *sbrx_and_branchqi */

                case E_HImode:
                  if (!register_operand (operands[1], E_HImode)
                      || !single_one_operand (operands[2], E_HImode)
                      || !
#line 7699 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 963; /* *sbrx_and_branchhi */

                case E_PSImode:
                  if (!register_operand (operands[1], E_PSImode)
                      || !single_one_operand (operands[2], E_PSImode)
                      || !
#line 7699 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 964; /* *sbrx_and_branchpsi */

                case E_SImode:
                  if (!register_operand (operands[1], E_SImode)
                      || !single_one_operand (operands[2], E_SImode)
                      || !
#line 7699 "../../gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 965; /* *sbrx_and_branchsi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GE:
        case LT:
          if (!gelt_operator (operands[0], E_VOIDmode))
            return -1;
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_QImode)
            return -1;
          x14 = XEXP (x11, 0);
          operands[1] = x14;
          x10 = XEXP (x6, 0);
          operands[2] = x10;
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8207 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 987; /* *sbix_branch_bit7 */
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8301 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 993; /* *sbix_branch_tmp_bit7 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (register_operand (operands[1], E_QImode))
        {
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) == REG
              && REGNO (x7) == 36
              && GET_MODE (x7) == E_CCmode
              && register_operand (operands[0], E_QImode)
              && GET_MODE (x5) == E_QImode)
            {
              x8 = XEXP (x5, 1);
              operands[2] = x8;
              if (nonmemory_operand (operands[2], E_QImode)
                  && 
#line 4488 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 619; /* *andqi3 */
            }
        }
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      switch (pattern100 (x1))
        {
        case 0:
          return 620; /* andhi3 */

        case 1:
          return 622; /* andpsi3 */

        case 2:
          return 624; /* andsi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern193 (x1))
        {
        case 0:
          if (!
#line 10590 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1194; /* *insv.any_shift.qi */

        case 1:
          if (!
#line 10590 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1197; /* *insv.any_shift.hi */

        case 2:
          if (!
#line 10590 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1200; /* *insv.any_shift.psi */

        case 3:
          if (!
#line 10590 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1203; /* *insv.any_shift.si */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern193 (x1))
        {
        case 0:
          if (!
#line 10590 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1195; /* *insv.any_shift.qi */

        case 1:
          if (!
#line 10590 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1198; /* *insv.any_shift.hi */

        case 2:
          if (!
#line 10590 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1201; /* *insv.any_shift.psi */

        case 3:
          if (!
#line 10590 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1204; /* *insv.any_shift.si */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern193 (x1))
        {
        case 0:
          if (!
#line 10590 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1196; /* *insv.any_shift.qi */

        case 1:
          if (!
#line 10590 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1199; /* *insv.any_shift.hi */

        case 2:
          if (!
#line 10590 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1202; /* *insv.any_shift.psi */

        case 3:
          if (!
#line 10590 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1205; /* *insv.any_shift.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_60 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_58 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_56 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_65 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_59 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_68 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_64 (x1, insn, pnum_clobbers);

    case DIV:
      if (pnum_clobbers != NULL)
        {
          switch (pattern130 (x1, 
MOD))
            {
            case 0:
              *pnum_clobbers = 4;
              return 584; /* divmodqi4 */

            case 1:
              *pnum_clobbers = 4;
              return 590; /* divmodhi4 */

            case 2:
              *pnum_clobbers = 2;
              return 606; /* divmodpsi4 */

            case 3:
              *pnum_clobbers = 4;
              return 612; /* divmodsi4 */

            default:
              break;
            }
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern135 (x1, pnum_clobbers, 
MOD))
        {
        case 0:
          *pnum_clobbers = 2;
          return 585; /* *divmodqi4_call_split */

        case 1:
          *pnum_clobbers = 2;
          return 591; /* *divmodhi4_call_split */

        case 2:
          *pnum_clobbers = 3;
          return 607; /* *divmodpsi4_call_split */

        case 3:
          *pnum_clobbers = 2;
          return 613; /* *divmodsi4_call_split */

        case 4:
          return 3072; /* *divqq3.call_split */

        case 5:
          return 3074; /* *divuqq3.call_split */

        default:
          return -1;
        }

    case UDIV:
      if (pnum_clobbers != NULL)
        {
          switch (pattern130 (x1, 
UMOD))
            {
            case 0:
              *pnum_clobbers = 4;
              return 587; /* udivmodqi4 */

            case 1:
              *pnum_clobbers = 4;
              return 593; /* udivmodhi4 */

            case 2:
              *pnum_clobbers = 2;
              return 609; /* udivmodpsi4 */

            case 3:
              *pnum_clobbers = 4;
              return 615; /* udivmodsi4 */

            default:
              break;
            }
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern135 (x1, pnum_clobbers, 
UMOD))
        {
        case 0:
          *pnum_clobbers = 1;
          return 588; /* *udivmodqi4_call_split */

        case 1:
          *pnum_clobbers = 2;
          return 594; /* *udivmodhi4_call_split */

        case 2:
          *pnum_clobbers = 3;
          return 610; /* *udivmodpsi4_call_split */

        case 3:
          *pnum_clobbers = 2;
          return 616; /* *udivmodsi4_call_split */

        case 4:
          return 3071; /* *udivqq3.call_split */

        case 5:
          return 3073; /* *udivuqq3.call_split */

        default:
          return -1;
        }

    case AND:
      return recog_66 (x1, insn, pnum_clobbers);

    case IOR:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (register_operand (operands[0], E_QImode)
          && pattern194 (x1) == 0)
        {
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          if (nonmemory_operand (operands[2], E_QImode)
              && 
#line 4638 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 627; /* *iorqi3 */
        }
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (pattern100 (x1))
        {
        case 0:
          return 628; /* iorhi3 */

        case 1:
          return 630; /* iorpsi3 */

        case 2:
          return 632; /* iorsi3 */

        default:
          return -1;
        }

    case XOR:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (register_operand (operands[0], E_QImode)
          && pattern194 (x1) == 0)
        {
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          if (register_operand (operands[2], E_QImode)
              && 
#line 4762 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 635; /* *xorqi3 */
        }
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (pattern100 (x1))
        {
        case 0:
          return 636; /* xorhi3 */

        case 1:
          return 638; /* xorpsi3 */

        case 2:
          return 640; /* xorsi3 */

        default:
          return -1;
        }

    case ROTATE:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          res = recog_48 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x4) != REG)
            return -1;
          switch (pattern157 (x1))
            {
            case 0:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3312; /* *rotldi3_insn */

            case 1:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3316; /* *rotldq3_insn */

            case 2:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3320; /* *rotludq3_insn */

            case 3:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3324; /* *rotlda3_insn */

            case 4:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3328; /* *rotluda3_insn */

            case 5:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3332; /* *rotlta3_insn */

            case 6:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3336; /* *rotluta3_insn */

            default:
              return -1;
            }

        case CONST_INT:
          if (pattern156 (x1, 
E_QImode) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          operands[1] = x7;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          switch (XWINT (x4, 0))
            {
            case 1L:
              if (!
#line 8971 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1014; /* *mask1_0x01 */

            case -2L:
              if (!
#line 9047 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1019; /* *mask1_0xfe */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3310; /* *ashrdi3_insn */

        case 1:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3314; /* *ashrdq3_insn */

        case 2:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3318; /* *ashrudq3_insn */

        case 3:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3322; /* *ashrda3_insn */

        case 4:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3326; /* *ashruda3_insn */

        case 5:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3330; /* *ashrta3_insn */

        case 6:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3334; /* *ashruta3_insn */

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3311; /* *lshrdi3_insn */

        case 1:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3315; /* *lshrdq3_insn */

        case 2:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3319; /* *lshrudq3_insn */

        case 3:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3323; /* *lshrda3_insn */

        case 4:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3327; /* *lshruda3_insn */

        case 5:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3331; /* *lshrta3_insn */

        case 6:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3335; /* *lshruta3_insn */

        default:
          return -1;
        }

    case ABS:
      if (pattern90 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 6184 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 782; /* *absqi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 6204 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 784; /* *abssf2 */

        default:
          return -1;
        }

    case NEG:
      return recog_62 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_63 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_70 (x1, insn, pnum_clobbers);

    case LO_SUM:
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern158 (x1) != 0)
        return -1;
      return 822; /* n_extendhipsi2 */

    case COMPARE:
      return recog_57 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_61 (x1, insn, pnum_clobbers);

    case CALL:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!nonmemory_operand (operands[1], E_HImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (!general_operand (operands[2], E_HImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_HImode))
        return -1;
      return 971; /* call_value_insn */

    case ROTATERT:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != CONST_INT
          || XWINT (x4, 0) != -128L)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern197 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode)
          || !
#line 9004 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1016; /* *mask1_0x80 */

    case PARITY:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      if (REGNO (x9) == 24)
        {
          switch (pattern214 (x1))
            {
            case 0:
              if (
#line 9135 "../../gcc/config/avr/avr.md"
(!reload_completed))
                return 1022; /* *parityhi2 */
              break;

            case 1:
              if (
#line 9164 "../../gcc/config/avr/avr.md"
(!reload_completed))
                return 1024; /* *parityqihi2.2 */
              break;

            default:
              break;
            }
        }
      if (REGNO (x9) != 36
          || GET_MODE (x9) != E_CCmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24
          || GET_MODE (x4) != E_HImode)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 24
          || GET_MODE (x6) != E_HImode
          || !
#line 9202 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1026; /* *parityhi2.libgcc */

    case ZERO_EXTEND:
      return recog_71 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 24)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern91 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      switch (GET_MODE (x6))
        {
        case E_HImode:
          if (GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || !
#line 9296 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1033; /* *popcounthi2.libgcc */

        case E_QImode:
          if (GET_MODE (x3) != E_QImode
              || GET_MODE (x4) != E_QImode
              || !
#line 9332 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1037; /* *popcountqi2.libgcc */

        default:
          return -1;
        }

    case CLZ:
      if (pattern92 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
        return -1;
      return 1039; /* *clzhi2.libgcc_split */

    case CTZ:
      if (pattern92 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
        return -1;
      return 1043; /* *ctzhi2.libgcc_split */

    case FFS:
      if (pattern92 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
        return -1;
      return 1047; /* *ffshi2.libgcc_split */

    case BSWAP:
      if (pattern92 (x1, 
36, 
E_CCmode, 
E_SImode, 
22) != 0
          || !
#line 9600 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1053; /* *bswapsi2.libgcc */

    case ZERO_EXTRACT:
      return recog_69 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      return recog_67 (x1, insn, pnum_clobbers);

    case FRACT_CONVERT:
      return recog_55 (x1, insn, pnum_clobbers);

    case UNSIGNED_FRACT_CONVERT:
      return recog_54 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern91 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      switch (pattern225 (x3))
        {
        case 0:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3003; /* *ssaddqq3 */
          break;

        case 1:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3005; /* *ssaddhq3 */
          break;

        case 2:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3007; /* *ssaddha3 */
          break;

        case 3:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3009; /* *ssaddsa3 */
          break;

        case 4:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3011; /* *ssaddsq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern226 (x2))
        {
        case 0:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3207; /* *ssadddq3_insn */

        case 1:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3209; /* *ssaddda3_insn */

        case 2:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3211; /* *ssaddta3_insn */

        case 3:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3219; /* *ssadddq3_const_insn */

        case 4:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3221; /* *ssaddda3_const_insn */

        case 5:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3223; /* *ssaddta3_const_insn */

        default:
          return -1;
        }

    case SS_MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern91 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      switch (pattern225 (x3))
        {
        case 0:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3004; /* *sssubqq3 */
          break;

        case 1:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3006; /* *sssubhq3 */
          break;

        case 2:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3008; /* *sssubha3 */
          break;

        case 3:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3010; /* *sssubsa3 */
          break;

        case 4:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3012; /* *sssubsq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern226 (x2))
        {
        case 0:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3208; /* *sssubdq3_insn */

        case 1:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3210; /* *sssubda3_insn */

        case 2:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3212; /* *sssubta3_insn */

        case 3:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3220; /* *sssubdq3_const_insn */

        case 4:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3222; /* *sssubda3_const_insn */

        case 5:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3224; /* *sssubta3_const_insn */

        default:
          return -1;
        }

    case US_PLUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern91 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      switch (pattern227 (x3))
        {
        case 0:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3023; /* *usadduqq3 */
          break;

        case 1:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3025; /* *usadduhq3 */
          break;

        case 2:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3027; /* *usadduha3 */
          break;

        case 3:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3029; /* *usaddusa3 */
          break;

        case 4:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3031; /* *usaddusq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern228 (x2))
        {
        case 0:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3231; /* *usaddudq3_insn */

        case 1:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3233; /* *usadduda3_insn */

        case 2:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3235; /* *usadduta3_insn */

        case 3:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3243; /* *usaddudq3_const_insn */

        case 4:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3245; /* *usadduda3_const_insn */

        case 5:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3247; /* *usadduta3_const_insn */

        default:
          return -1;
        }

    case US_MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern91 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      switch (pattern227 (x3))
        {
        case 0:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3024; /* *ussubuqq3 */
          break;

        case 1:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3026; /* *ussubuhq3 */
          break;

        case 2:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3028; /* *ussubuha3 */
          break;

        case 3:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3030; /* *ussubusa3 */
          break;

        case 4:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3032; /* *ussubusq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern228 (x2))
        {
        case 0:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3232; /* *ussubudq3_insn */

        case 1:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3234; /* *ussubuda3_insn */

        case 2:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3236; /* *ussubuta3_insn */

        case 3:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3244; /* *ussubudq3_const_insn */

        case 4:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3246; /* *ussubuda3_const_insn */

        case 5:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3248; /* *ussubuta3_const_insn */

        default:
          return -1;
        }

    case SS_NEG:
      if (GET_MODE (x3) == E_QQmode
          && pattern136 (x1) == 0
          && 
#line 200 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return 3034; /* *ssnegqq2 */
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern137 (x1))
        {
        case 0:
          if (!
#line 252 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3042; /* *ssneghq2 */

        case 1:
          if (!
#line 252 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3044; /* *ssnegha2 */

        case 2:
          if (!
#line 272 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3050; /* *ssnegsa2 */

        case 3:
          if (!
#line 272 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3052; /* *ssnegsq2 */

        default:
          return -1;
        }

    case SS_ABS:
      if (GET_MODE (x3) == E_QQmode
          && pattern136 (x1) == 0
          && 
#line 218 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return 3036; /* *ssabsqq2 */
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern137 (x1))
        {
        case 0:
          if (!
#line 252 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3041; /* *ssabshq2 */

        case 1:
          if (!
#line 252 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3043; /* *ssabsha2 */

        case 2:
          if (!
#line 272 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3049; /* *ssabssa2 */

        case 3:
          if (!
#line 272 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3051; /* *ssabssq2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (pattern141 (x3) != 0
          || !
#line 4627 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_371 (insn, operands);

    case LSHIFTRT:
      switch (pattern74 (x3))
        {
        case 0:
          if (!(
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10149 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_668 (insn, operands);

        case 1:
          if (!(
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10149 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_672 (insn, operands);

        case 2:
          if (!(
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10149 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_676 (insn, operands);

        case 3:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_692 (insn, operands);

        case 4:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_696 (insn, operands);

        case 5:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_704 (insn, operands);

        case 6:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_700 (insn, operands);

        case 7:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_708 (insn, operands);

        case 8:
          if (!(
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_712 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern76 (x3))
        {
        case 0:
          x5 = XEXP (x4, 1);
          operands[3] = x5;
          switch (pattern42 (x3))
            {
            case 0:
              if ((
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10149 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_670 (insn, operands);
              break;

            case 1:
              if ((
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10149 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_674 (insn, operands);
              break;

            case 2:
              if ((
#line 10147 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10149 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_678 (insn, operands);
              break;

            default:
              break;
            }
          if (XWINT (x5, 0) != 8L
              || pattern206 (x3) != 0
              || !(
#line 10259 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10261 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_719 (insn, operands);

        case 1:
          x5 = XEXP (x4, 1);
          operands[3] = x5;
          switch (pattern44 (x3))
            {
            case 0:
              if ((
#line 10193 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_694 (insn, operands);
              break;

            case 1:
              if ((
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_698 (insn, operands);
              break;

            case 2:
              if ((
#line 10193 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_706 (insn, operands);
              break;

            case 3:
              if ((
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_702 (insn, operands);
              break;

            case 4:
              if ((
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_710 (insn, operands);
              break;

            case 5:
              if ((
#line 10193 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_714 (insn, operands);
              break;

            default:
              break;
            }
          if (XWINT (x5, 0) != 8L)
            return NULL;
          switch (pattern217 (x3))
            {
            case 0:
              if (!(
#line 10210 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10212 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_716 (insn, operands);

            case 1:
              if (!(
#line 10243 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10245 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_718 (insn, operands);

            default:
              return NULL;
            }

        case 2:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_913 (insn, operands);

        case 3:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_919 (insn, operands);

        case 4:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_931 (insn, operands);

        case 5:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_925 (insn, operands);

        case 6:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_937 (insn, operands);

        case 7:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_943 (insn, operands);

        case 8:
          if (!(
#line 10210 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10212 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_715 (insn, operands);

        case 9:
          if (!(
#line 10243 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10245 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_717 (insn, operands);

        case 10:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_912 (insn, operands);

        case 11:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_918 (insn, operands);

        case 12:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_930 (insn, operands);

        case 13:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_924 (insn, operands);

        case 14:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_936 (insn, operands);

        case 15:
          if (!(
#line 10789 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10793 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_942 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (pattern3 (x3))
        {
        case 0:
          if (!(
#line 10170 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 10172 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_680 (insn, operands);

        case 1:
          if (!(
#line 10170 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 10172 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_682 (insn, operands);

        case 2:
          if (!(
#line 10170 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 10172 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_686 (insn, operands);

        case 3:
          if (!(
#line 10170 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 10172 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_684 (insn, operands);

        case 4:
          if (!(
#line 10170 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 10172 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_688 (insn, operands);

        case 5:
          if (!(
#line 10170 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 10172 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_690 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x3))
            {
            case 0:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_815 (insn, operands);

            case 1:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_827 (insn, operands);

            case 2:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_839 (insn, operands);

            case 3:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_851 (insn, operands);

            case 4:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_818 (insn, operands);

            case 5:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_830 (insn, operands);

            case 6:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_842 (insn, operands);

            case 7:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_854 (insn, operands);

            case 8:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_821 (insn, operands);

            case 9:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_833 (insn, operands);

            case 10:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_845 (insn, operands);

            case 11:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_857 (insn, operands);

            case 12:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_824 (insn, operands);

            case 13:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_836 (insn, operands);

            case 14:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_848 (insn, operands);

            case 15:
              if (!(
#line 10727 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_860 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern12 (x3))
            {
            case 0:
              if (!(
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10813 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_947 (insn, operands);

            case 1:
              if (!(
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10813 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_950 (insn, operands);

            case 2:
              if (!(
#line 10808 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10813 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_953 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      switch (pattern80 (x3))
        {
        case 0:
          if (!(
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_863 (insn, operands);

        case 1:
          if (!(
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_866 (insn, operands);

        case 2:
          if (!(
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_869 (insn, operands);

        case 3:
          if (!(
#line 10752 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_872 (insn, operands);

        case 4:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_876 (insn, operands);

        case 5:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_882 (insn, operands);

        case 6:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_894 (insn, operands);

        case 7:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_888 (insn, operands);

        case 8:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_900 (insn, operands);

        case 9:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_906 (insn, operands);

        case 10:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_877 (insn, operands);

        case 11:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_883 (insn, operands);

        case 12:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_895 (insn, operands);

        case 13:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_889 (insn, operands);

        case 14:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_901 (insn, operands);

        case 15:
          if (!(
#line 10769 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10773 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_907 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[0] = x3;
      if (ordered_comparison_operator (operands[0], E_VOIDmode))
        {
          res = split_7 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 7626 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_607 (insn, operands);

        case 1:
          if (!
#line 7626 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_608 (insn, operands);

        case 2:
          if (!
#line 7626 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_609 (insn, operands);

        case 3:
          if (!
#line 7626 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_610 (insn, operands);

        case 4:
          if (!
#line 7626 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_611 (insn, operands);

        case 5:
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8140 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_618 (insn, operands);
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8235 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_621 (insn, operands);

        case 6:
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8140 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_619 (insn, operands);
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8235 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_622 (insn, operands);

        case 7:
          if (!
#line 7679 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_612 (insn, operands);

        case 8:
          if (!
#line 7679 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_613 (insn, operands);

        case 9:
          if (!
#line 7679 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_614 (insn, operands);

        case 10:
          if (!
#line 7679 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_615 (insn, operands);

        case 11:
          operands[0] = x3;
          if (gelt_operator (operands[0], E_VOIDmode))
            {
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) == MEM
                  && GET_MODE (x5) == E_QImode)
                {
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  x7 = XEXP (x2, 1);
                  x8 = XEXP (x7, 0);
                  operands[2] = x8;
                  if (low_io_address_operand (operands[1], E_VOIDmode)
                      && 
#line 8188 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return gen_split_620 (insn, operands);
                  if (high_io_address_operand (operands[1], E_VOIDmode)
                      && 
#line 8282 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return gen_split_623 (insn, operands);
                }
            }
          if (GET_CODE (x3) != GE)
            return NULL;
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!
#line 9084 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_633 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_24 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  switch (REGNO (x5))
    {
    case 30:
      switch (pattern239 (x5))
        {
        case 0:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_17 (insn, operands);

        case 1:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_18 (insn, operands);

        case 2:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_19 (insn, operands);

        case 3:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_20 (insn, operands);

        case 4:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_21 (insn, operands);

        case 5:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_22 (insn, operands);

        case 6:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_23 (insn, operands);

        case 7:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_24 (insn, operands);

        case 8:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_25 (insn, operands);

        case 9:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_26 (insn, operands);

        case 10:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_27 (insn, operands);

        case 11:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_28 (insn, operands);

        case 12:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_29 (insn, operands);

        case 13:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_30 (insn, operands);

        case 14:
          if (!(
#line 594 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 599 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_31 (insn, operands);

        default:
          return NULL;
        }

    case 36:
      if (GET_MODE (x5) != E_CCmode)
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || !general_operand (operands[1], E_QImode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_70 (insn, operands);

        case E_QQmode:
          if (!nonimmediate_operand (operands[0], E_QQmode)
              || !general_operand (operands[1], E_QQmode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_71 (insn, operands);

        case E_UQQmode:
          if (!nonimmediate_operand (operands[0], E_UQQmode)
              || !general_operand (operands[1], E_UQQmode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_72 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !general_operand (operands[1], E_HImode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_73 (insn, operands);

        case E_HQmode:
          if (!nonimmediate_operand (operands[0], E_HQmode)
              || !general_operand (operands[1], E_HQmode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_74 (insn, operands);

        case E_UHQmode:
          if (!nonimmediate_operand (operands[0], E_UHQmode)
              || !general_operand (operands[1], E_UHQmode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_75 (insn, operands);

        case E_HAmode:
          if (!nonimmediate_operand (operands[0], E_HAmode)
              || !general_operand (operands[1], E_HAmode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_76 (insn, operands);

        case E_UHAmode:
          if (!nonimmediate_operand (operands[0], E_UHAmode)
              || !general_operand (operands[1], E_UHAmode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_77 (insn, operands);

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !general_operand (operands[1], E_SImode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_78 (insn, operands);

        case E_SQmode:
          if (!nonimmediate_operand (operands[0], E_SQmode)
              || !general_operand (operands[1], E_SQmode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_79 (insn, operands);

        case E_USQmode:
          if (!nonimmediate_operand (operands[0], E_USQmode)
              || !general_operand (operands[1], E_USQmode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_80 (insn, operands);

        case E_SAmode:
          if (!nonimmediate_operand (operands[0], E_SAmode)
              || !general_operand (operands[1], E_SAmode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_81 (insn, operands);

        case E_USAmode:
          if (!nonimmediate_operand (operands[0], E_USAmode)
              || !general_operand (operands[1], E_USAmode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_82 (insn, operands);

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || !general_operand (operands[1], E_SFmode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_83 (insn, operands);

        case E_PSImode:
          if (!nonimmediate_operand (operands[0], E_PSImode)
              || !general_operand (operands[1], E_PSImode)
              || !
#line 1068 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_84 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (pattern307 (x4) != 0)
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (pattern369 (x5) != 0)
    return NULL;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_PSImode)
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      switch (pattern376 (x9, 
E_PSImode))
        {
        case 0:
          if (!
#line 7405 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_200 (insn, operands);

        case 1:
          if (!
#line 7405 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_201 (insn, operands);

        case 2:
          if (!
#line 7405 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_202 (insn, operands);

        case 3:
          if (!
#line 7405 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_203 (insn, operands);

        case 4:
          if (!
#line 7405 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_204 (insn, operands);

        case 5:
          if (!
#line 7405 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_205 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern378 (x3))
        {
        case 0:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_206 (insn, operands);

        case 1:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_207 (insn, operands);

        case 2:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_208 (insn, operands);

        case 3:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_209 (insn, operands);

        case 4:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_210 (insn, operands);

        case 5:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_211 (insn, operands);

        case 6:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_218 (insn, operands);

        case 7:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_219 (insn, operands);

        case 8:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_220 (insn, operands);

        case 9:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_221 (insn, operands);

        case 10:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_222 (insn, operands);

        case 11:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_223 (insn, operands);

        case 12:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_242 (insn, operands);

        case 13:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_243 (insn, operands);

        case 14:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_244 (insn, operands);

        case 15:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_245 (insn, operands);

        case 16:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_246 (insn, operands);

        case 17:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_247 (insn, operands);

        case 18:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_230 (insn, operands);

        case 19:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_231 (insn, operands);

        case 20:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_232 (insn, operands);

        case 21:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_233 (insn, operands);

        case 22:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_234 (insn, operands);

        case 23:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_235 (insn, operands);

        case 24:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_254 (insn, operands);

        case 25:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_255 (insn, operands);

        case 26:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_256 (insn, operands);

        case 27:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_257 (insn, operands);

        case 28:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_258 (insn, operands);

        case 29:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_259 (insn, operands);

        case 30:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_266 (insn, operands);

        case 31:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_267 (insn, operands);

        case 32:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_268 (insn, operands);

        case 33:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_269 (insn, operands);

        case 34:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_270 (insn, operands);

        case 35:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_271 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern378 (x3))
        {
        case 0:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_212 (insn, operands);

        case 1:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_213 (insn, operands);

        case 2:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_214 (insn, operands);

        case 3:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_215 (insn, operands);

        case 4:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_216 (insn, operands);

        case 5:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_217 (insn, operands);

        case 6:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_224 (insn, operands);

        case 7:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_225 (insn, operands);

        case 8:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_226 (insn, operands);

        case 9:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_227 (insn, operands);

        case 10:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_228 (insn, operands);

        case 11:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_229 (insn, operands);

        case 12:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_248 (insn, operands);

        case 13:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_249 (insn, operands);

        case 14:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_250 (insn, operands);

        case 15:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_251 (insn, operands);

        case 16:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_252 (insn, operands);

        case 17:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_253 (insn, operands);

        case 18:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_236 (insn, operands);

        case 19:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_237 (insn, operands);

        case 20:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_238 (insn, operands);

        case 21:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_239 (insn, operands);

        case 22:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_240 (insn, operands);

        case 23:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_241 (insn, operands);

        case 24:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_260 (insn, operands);

        case 25:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_261 (insn, operands);

        case 26:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_262 (insn, operands);

        case 27:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_263 (insn, operands);

        case 28:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_264 (insn, operands);

        case 29:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_265 (insn, operands);

        case 30:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_272 (insn, operands);

        case 31:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_273 (insn, operands);

        case 32:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_274 (insn, operands);

        case 33:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_275 (insn, operands);

        case 34:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_276 (insn, operands);

        case 35:
          if (!
#line 7436 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_277 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
